/* Include files */
#include "supply_3_GA_sfun.h"
#include "c8_supply_3_GA.h"
#define CHARTINSTANCE_CHARTNUMBER       (chartInstance.chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER    (chartInstance.instanceNumber)
#include "supply_3_GA_sfun_debug_macros.h"

/* Type Definitions */

/* Named Constants */
#define c8_IN_NO_ACTIVE_CHILD           (0)

/* Variable Declarations */

/* Variable Definitions */
static SFc8_supply_3_GAInstanceStruct chartInstance;

/* Function Declarations */
static void initialize_c8_supply_3_GA(void);
static void initialize_params_c8_supply_3_GA(void);
static void enable_c8_supply_3_GA(void);
static void disable_c8_supply_3_GA(void);
static void finalize_c8_supply_3_GA(void);
static void sf_c8_supply_3_GA(void);
static void init_script_number_translation(uint32_T c8_machineNumber, uint32_T
 c8_chartNumber);
static const mxArray *c8_sf_marshall(void *c8_chartInstance, void *c8_u);
static const mxArray *c8_b_sf_marshall(void *c8_chartInstance, void *c8_u);
static const mxArray *c8_c_sf_marshall(void *c8_chartInstance, void *c8_u);
static const mxArray *c8_d_sf_marshall(void *c8_chartInstance, void *c8_u);
static const mxArray *c8_e_sf_marshall(void *c8_chartInstance, void *c8_u);
static const mxArray *c8_f_sf_marshall(void *c8_chartInstance, void *c8_u);
static const mxArray *c8_g_sf_marshall(void *c8_chartInstance, void *c8_u);
static const mxArray *c8_h_sf_marshall(void *c8_chartInstance, void *c8_u);
static const mxArray *c8_i_sf_marshall(void *c8_chartInstance, void *c8_u);
static void c8_info_helper(c8_ResolvedFunctionInfo c8_info[26]);
static void init_dsm_address_info(void);

/* Function Definitions */
static void initialize_c8_supply_3_GA(void)
{
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
  chartInstance.c8_is_active_c8_supply_3_GA = 0U;
}

static void initialize_params_c8_supply_3_GA(void)
{
}

static void enable_c8_supply_3_GA(void)
{
}

static void disable_c8_supply_3_GA(void)
{
}

static void finalize_c8_supply_3_GA(void)
{
}

static void sf_c8_supply_3_GA(void)
{
  int32_T c8_i0;
  int32_T c8_i1;
  int32_T c8_i2;
  int32_T c8_i3;
  int32_T c8_i4;
  int32_T c8_i5;
  uint8_T c8_previousEvent;
  int32_T c8_i6;
  real_T c8_tl[3];
  int32_T c8_i7;
  real_T c8_dtl[3];
  real_T c8_tau;
  real_T c8_dtau;
  int32_T c8_i8;
  real_T c8_f[3];
  int32_T c8_i9;
  real_T c8_df[3];
  real_T c8_dtau_abs;
  real_T c8_tau_abs1;
  real_T c8_Jp[6];
  real_T c8_x;
  real_T c8_b_x;
  int32_T c8_i10;
  int32_T c8_i11;
  int32_T c8_i12;
  int32_T c8_i13;
  real_T *c8_b_tau;
  real_T *c8_b_dtau;
  real_T (*c8_b_Jp)[6];
  real_T (*c8_b_tl)[3];
  real_T (*c8_b_dtl)[3];
  real_T (*c8_b_f)[3];
  real_T (*c8_b_df)[3];
  c8_b_tau = (real_T *)ssGetInputPortSignal(chartInstance.S, 2);
  c8_b_f = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 4);
  c8_b_dtau = (real_T *)ssGetInputPortSignal(chartInstance.S, 3);
  c8_b_Jp = (real_T (*)[6])ssGetOutputPortSignal(chartInstance.S, 1);
  c8_b_df = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 5);
  c8_b_tl = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 0);
  c8_b_dtl = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 1);
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
  for(c8_i0 = 0; c8_i0 < 3; c8_i0 = c8_i0 + 1) {
    _SFD_DATA_RANGE_CHECK((*c8_b_tl)[c8_i0], 4U);
  }
  for(c8_i1 = 0; c8_i1 < 3; c8_i1 = c8_i1 + 1) {
    _SFD_DATA_RANGE_CHECK((*c8_b_dtl)[c8_i1], 1U);
  }
  _SFD_DATA_RANGE_CHECK(*c8_b_tau, 0U);
  _SFD_DATA_RANGE_CHECK(*c8_b_dtau, 3U);
  for(c8_i2 = 0; c8_i2 < 2; c8_i2 = c8_i2 + 1) {
    for(c8_i3 = 0; c8_i3 < 3; c8_i3 = c8_i3 + 1) {
      _SFD_DATA_RANGE_CHECK((*c8_b_Jp)[c8_i3 + 3 * c8_i2], 5U);
    }
  }
  for(c8_i4 = 0; c8_i4 < 3; c8_i4 = c8_i4 + 1) {
    _SFD_DATA_RANGE_CHECK((*c8_b_f)[c8_i4], 2U);
  }
  for(c8_i5 = 0; c8_i5 < 3; c8_i5 = c8_i5 + 1) {
    _SFD_DATA_RANGE_CHECK((*c8_b_df)[c8_i5], 6U);
  }
  c8_previousEvent = _sfEvent_;
  _sfEvent_ = CALL_EVENT;
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG,7);
  for(c8_i6 = 0; c8_i6 < 3; c8_i6 = c8_i6 + 1) {
    c8_tl[c8_i6] = (*c8_b_tl)[c8_i6];
  }
  for(c8_i7 = 0; c8_i7 < 3; c8_i7 = c8_i7 + 1) {
    c8_dtl[c8_i7] = (*c8_b_dtl)[c8_i7];
  }
  c8_tau = *c8_b_tau;
  c8_dtau = *c8_b_dtau;
  for(c8_i8 = 0; c8_i8 < 3; c8_i8 = c8_i8 + 1) {
    c8_f[c8_i8] = (*c8_b_f)[c8_i8];
  }
  for(c8_i9 = 0; c8_i9 < 3; c8_i9 = c8_i9 + 1) {
    c8_df[c8_i9] = (*c8_b_df)[c8_i9];
  }
  sf_debug_symbol_scope_push(9U, 0U);
  sf_debug_symbol_scope_add("dtau_abs", &c8_dtau_abs, c8_i_sf_marshall);
  sf_debug_symbol_scope_add("tau_abs1", &c8_tau_abs1, c8_h_sf_marshall);
  sf_debug_symbol_scope_add("Jp", &c8_Jp, c8_g_sf_marshall);
  sf_debug_symbol_scope_add("df", &c8_df, c8_f_sf_marshall);
  sf_debug_symbol_scope_add("f", &c8_f, c8_e_sf_marshall);
  sf_debug_symbol_scope_add("dtau", &c8_dtau, c8_d_sf_marshall);
  sf_debug_symbol_scope_add("tau", &c8_tau, c8_c_sf_marshall);
  sf_debug_symbol_scope_add("dtl", &c8_dtl, c8_b_sf_marshall);
  sf_debug_symbol_scope_add("tl", &c8_tl, c8_sf_marshall);
  CV_EML_FCN(0, 0);
  /*  constants */
  /*  tl = [25, 50, 80]; */
  /*  dtl = [25, 50, 80]; */
  /*  Absolute value   */
  _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,7);
  c8_x = c8_tau;
  c8_tau_abs1 = fabs(c8_x);
  _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,10);
  if(CV_EML_IF(0, 0, c8_tau_abs1 > c8_tl[0])) {
    /* % Force Level performance index */
    _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,11);
    c8_f[0] = c8_f[0] + 1.0;
  }
  _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,13);
  if(CV_EML_IF(0, 1, c8_tau_abs1 > c8_tl[1])) {
    _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,14);
    c8_f[1] = c8_f[1] + 1.0;
  }
  _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,16);
  if(CV_EML_IF(0, 2, c8_tau_abs1 > c8_tl[2])) {
    _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,17);
    c8_f[2] = c8_f[2] + 1.0;
  }
  /* % delta Force Level Performance index */
  _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,20);
  c8_b_x = c8_dtau;
  c8_dtau_abs = fabs(c8_b_x);
  _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,21);
  if(CV_EML_IF(0, 3, c8_dtau_abs > c8_dtl[0])) {
    _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,22);
    c8_df[0] = c8_df[0] + 1.0;
  }
  _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,24);
  if(CV_EML_IF(0, 4, c8_dtau_abs > c8_dtl[1])) {
    _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,25);
    c8_df[1] = c8_df[1] + 1.0;
  }
  _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,27);
  if(CV_EML_IF(0, 5, c8_dtau_abs > c8_dtl[2])) {
    _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,28);
    c8_df[2] = c8_df[2] + 1.0;
  }
  /*  Output */
  _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,31);
  for(c8_i10 = 0; c8_i10 < 3; c8_i10 = c8_i10 + 1) {
    c8_Jp[c8_i10] = c8_f[c8_i10];
  }
  for(c8_i11 = 0; c8_i11 < 3; c8_i11 = c8_i11 + 1) {
    c8_Jp[c8_i11 + 3] = c8_df[c8_i11];
  }
  _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,-31);
  sf_debug_symbol_scope_pop();
  for(c8_i12 = 0; c8_i12 < 2; c8_i12 = c8_i12 + 1) {
    for(c8_i13 = 0; c8_i13 < 3; c8_i13 = c8_i13 + 1) {
      (*c8_b_Jp)[c8_i13 + 3 * c8_i12] = c8_Jp[c8_i13 + 3 * c8_i12];
    }
  }
  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG,7);
  _sfEvent_ = c8_previousEvent;
  sf_debug_check_for_state_inconsistency(_supply_3_GAMachineNumber_,
   chartInstance.chartNumber, chartInstance.instanceNumber);
}

static void init_script_number_translation(uint32_T c8_machineNumber, uint32_T
 c8_chartNumber)
{
}

static const mxArray *c8_sf_marshall(void *c8_chartInstance, void *c8_u)
{
  const mxArray *c8_y = NULL;
  int32_T c8_i14;
  real_T c8_b_u[3];
  const mxArray *c8_b_y = NULL;
  c8_y = NULL;
  for(c8_i14 = 0; c8_i14 < 3; c8_i14 = c8_i14 + 1) {
    c8_b_u[c8_i14] = (*((real_T (*)[3])c8_u))[c8_i14];
  }
  c8_b_y = NULL;
  sf_mex_assign(&c8_b_y, sf_mex_create(&c8_b_u, "y", 0, 0U, 1U, 1, 3));
  sf_mex_assign(&c8_y, c8_b_y);
  return c8_y;
}

static const mxArray *c8_b_sf_marshall(void *c8_chartInstance, void *c8_u)
{
  const mxArray *c8_y = NULL;
  int32_T c8_i15;
  real_T c8_b_u[3];
  const mxArray *c8_b_y = NULL;
  c8_y = NULL;
  for(c8_i15 = 0; c8_i15 < 3; c8_i15 = c8_i15 + 1) {
    c8_b_u[c8_i15] = (*((real_T (*)[3])c8_u))[c8_i15];
  }
  c8_b_y = NULL;
  sf_mex_assign(&c8_b_y, sf_mex_create(&c8_b_u, "y", 0, 0U, 1U, 1, 3));
  sf_mex_assign(&c8_y, c8_b_y);
  return c8_y;
}

static const mxArray *c8_c_sf_marshall(void *c8_chartInstance, void *c8_u)
{
  const mxArray *c8_y = NULL;
  real_T c8_b_u;
  const mxArray *c8_b_y = NULL;
  c8_y = NULL;
  c8_b_u = *((real_T *)c8_u);
  c8_b_y = NULL;
  sf_mex_assign(&c8_b_y, sf_mex_create(&c8_b_u, "y", 0, 0U, 0U, 0));
  sf_mex_assign(&c8_y, c8_b_y);
  return c8_y;
}

static const mxArray *c8_d_sf_marshall(void *c8_chartInstance, void *c8_u)
{
  const mxArray *c8_y = NULL;
  real_T c8_b_u;
  const mxArray *c8_b_y = NULL;
  c8_y = NULL;
  c8_b_u = *((real_T *)c8_u);
  c8_b_y = NULL;
  sf_mex_assign(&c8_b_y, sf_mex_create(&c8_b_u, "y", 0, 0U, 0U, 0));
  sf_mex_assign(&c8_y, c8_b_y);
  return c8_y;
}

static const mxArray *c8_e_sf_marshall(void *c8_chartInstance, void *c8_u)
{
  const mxArray *c8_y = NULL;
  int32_T c8_i16;
  real_T c8_b_u[3];
  const mxArray *c8_b_y = NULL;
  c8_y = NULL;
  for(c8_i16 = 0; c8_i16 < 3; c8_i16 = c8_i16 + 1) {
    c8_b_u[c8_i16] = (*((real_T (*)[3])c8_u))[c8_i16];
  }
  c8_b_y = NULL;
  sf_mex_assign(&c8_b_y, sf_mex_create(&c8_b_u, "y", 0, 0U, 1U, 1, 3));
  sf_mex_assign(&c8_y, c8_b_y);
  return c8_y;
}

static const mxArray *c8_f_sf_marshall(void *c8_chartInstance, void *c8_u)
{
  const mxArray *c8_y = NULL;
  int32_T c8_i17;
  real_T c8_b_u[3];
  const mxArray *c8_b_y = NULL;
  c8_y = NULL;
  for(c8_i17 = 0; c8_i17 < 3; c8_i17 = c8_i17 + 1) {
    c8_b_u[c8_i17] = (*((real_T (*)[3])c8_u))[c8_i17];
  }
  c8_b_y = NULL;
  sf_mex_assign(&c8_b_y, sf_mex_create(&c8_b_u, "y", 0, 0U, 1U, 1, 3));
  sf_mex_assign(&c8_y, c8_b_y);
  return c8_y;
}

static const mxArray *c8_g_sf_marshall(void *c8_chartInstance, void *c8_u)
{
  const mxArray *c8_y = NULL;
  int32_T c8_i18;
  int32_T c8_i19;
  real_T c8_b_u[6];
  const mxArray *c8_b_y = NULL;
  c8_y = NULL;
  for(c8_i18 = 0; c8_i18 < 2; c8_i18 = c8_i18 + 1) {
    for(c8_i19 = 0; c8_i19 < 3; c8_i19 = c8_i19 + 1) {
      c8_b_u[c8_i19 + 3 * c8_i18] = (*((real_T (*)[6])c8_u))[c8_i19 + 3 *
        c8_i18];
    }
  }
  c8_b_y = NULL;
  sf_mex_assign(&c8_b_y, sf_mex_create(&c8_b_u, "y", 0, 0U, 1U, 2, 3, 2));
  sf_mex_assign(&c8_y, c8_b_y);
  return c8_y;
}

static const mxArray *c8_h_sf_marshall(void *c8_chartInstance, void *c8_u)
{
  const mxArray *c8_y = NULL;
  real_T c8_b_u;
  const mxArray *c8_b_y = NULL;
  c8_y = NULL;
  c8_b_u = *((real_T *)c8_u);
  c8_b_y = NULL;
  sf_mex_assign(&c8_b_y, sf_mex_create(&c8_b_u, "y", 0, 0U, 0U, 0));
  sf_mex_assign(&c8_y, c8_b_y);
  return c8_y;
}

static const mxArray *c8_i_sf_marshall(void *c8_chartInstance, void *c8_u)
{
  const mxArray *c8_y = NULL;
  real_T c8_b_u;
  const mxArray *c8_b_y = NULL;
  c8_y = NULL;
  c8_b_u = *((real_T *)c8_u);
  c8_b_y = NULL;
  sf_mex_assign(&c8_b_y, sf_mex_create(&c8_b_u, "y", 0, 0U, 0U, 0));
  sf_mex_assign(&c8_y, c8_b_y);
  return c8_y;
}

const mxArray *sf_c8_supply_3_GA_get_eml_resolved_functions_info(void)
{
  const mxArray *c8_nameCaptureInfo = NULL;
  c8_ResolvedFunctionInfo c8_info[26];
  const mxArray *c8_m0 = NULL;
  int32_T c8_i20;
  c8_ResolvedFunctionInfo *c8_r0;
  c8_nameCaptureInfo = NULL;
  c8_info_helper(c8_info);
  sf_mex_assign(&c8_m0, sf_mex_createstruct("nameCaptureInfo", 1, 26));
  for(c8_i20 = 0; c8_i20 < 26; c8_i20 = c8_i20 + 1) {
    c8_r0 = &c8_info[c8_i20];
    sf_mex_addfield(c8_m0, sf_mex_create(c8_r0->context, "nameCaptureInfo", 13,
      0U, 0U, 2, 1, strlen(c8_r0->context)), "context",
     "nameCaptureInfo", c8_i20);
    sf_mex_addfield(c8_m0, sf_mex_create(c8_r0->name, "nameCaptureInfo", 13, 0U,
      0U, 2, 1, strlen(c8_r0->name)), "name",
     "nameCaptureInfo", c8_i20);
    sf_mex_addfield(c8_m0, sf_mex_create(c8_r0->dominantType, "nameCaptureInfo",
      13, 0U, 0U, 2, 1, strlen(c8_r0->dominantType)),
     "dominantType", "nameCaptureInfo", c8_i20);
    sf_mex_addfield(c8_m0, sf_mex_create(c8_r0->resolved, "nameCaptureInfo", 13,
      0U, 0U, 2, 1, strlen(c8_r0->resolved)), "resolved",
     "nameCaptureInfo", c8_i20);
    sf_mex_addfield(c8_m0, sf_mex_create(&c8_r0->fileLength, "nameCaptureInfo",
      7, 0U, 0U, 0), "fileLength", "nameCaptureInfo", c8_i20);
    sf_mex_addfield(c8_m0, sf_mex_create(&c8_r0->fileTime1, "nameCaptureInfo",
      7, 0U, 0U, 0), "fileTime1", "nameCaptureInfo", c8_i20);
    sf_mex_addfield(c8_m0, sf_mex_create(&c8_r0->fileTime2, "nameCaptureInfo",
      7, 0U, 0U, 0), "fileTime2", "nameCaptureInfo", c8_i20);
  }
  sf_mex_assign(&c8_nameCaptureInfo, c8_m0);
  return c8_nameCaptureInfo;
}

static void c8_info_helper(c8_ResolvedFunctionInfo c8_info[26])
{
  c8_info[0].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/datatypes/isnumeric.m";
  c8_info[0].name = "isa";
  c8_info[0].dominantType = "double";
  c8_info[0].resolved = "[I]$matlabroot$/toolbox/eml/lib/matlab/datatypes/isa.m";
  c8_info[0].fileLength = 791U;
  c8_info[0].fileTime1 = 1160425018U;
  c8_info[0].fileTime2 = 0U;
  c8_info[1].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/datatypes/isa.m";
  c8_info[1].name = "class";
  c8_info[1].dominantType = "char";
  c8_info[1].resolved = "[B]class";
  c8_info[1].fileLength = 0U;
  c8_info[1].fileTime1 = 0U;
  c8_info[1].fileTime2 = 0U;
  c8_info[2].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c8_info[2].name = "isreal";
  c8_info[2].dominantType = "double";
  c8_info[2].resolved = "[B]isreal";
  c8_info[2].fileLength = 0U;
  c8_info[2].fileTime1 = 0U;
  c8_info[2].fileTime2 = 0U;
  c8_info[3].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elmat/isscalar.m";
  c8_info[3].name = "length";
  c8_info[3].dominantType = "double";
  c8_info[3].resolved = "[I]$matlabroot$/toolbox/eml/lib/matlab/elmat/length.m";
  c8_info[3].fileLength = 347U;
  c8_info[3].fileTime1 = 1163949170U;
  c8_info[3].fileTime2 = 0U;
  c8_info[4].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c8_info[4].name = "isscalar";
  c8_info[4].dominantType = "double";
  c8_info[4].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/elmat/isscalar.m";
  c8_info[4].fileLength = 243U;
  c8_info[4].fileTime1 = 1160425104U;
  c8_info[4].fileTime2 = 0U;
  c8_info[5].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/datatypes/isa.m";
  c8_info[5].name = "eml_is_integer_class";
  c8_info[5].dominantType = "char";
  c8_info[5].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_is_integer_class.m";
  c8_info[5].fileLength = 462U;
  c8_info[5].fileTime1 = 1160425144U;
  c8_info[5].fileTime2 = 0U;
  c8_info[6].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c8_info[6].name = "isinteger";
  c8_info[6].dominantType = "double";
  c8_info[6].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/datatypes/isinteger.m";
  c8_info[6].fileLength = 254U;
  c8_info[6].fileTime1 = 1160425020U;
  c8_info[6].fileTime2 = 0U;
  c8_info[7].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c8_info[7].name = "isnumeric";
  c8_info[7].dominantType = "double";
  c8_info[7].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/datatypes/isnumeric.m";
  c8_info[7].fileLength = 250U;
  c8_info[7].fileTime1 = 1160425022U;
  c8_info[7].fileTime2 = 0U;
  c8_info[8].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c8_info[8].name = "nargin";
  c8_info[8].dominantType = "";
  c8_info[8].resolved = "[B]nargin";
  c8_info[8].fileLength = 0U;
  c8_info[8].fileTime1 = 0U;
  c8_info[8].fileTime2 = 0U;
  c8_info[9].context = "";
  c8_info[9].name = "abs";
  c8_info[9].dominantType = "double";
  c8_info[9].resolved = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c8_info[9].fileLength = 1031U;
  c8_info[9].fileTime1 = 1163949102U;
  c8_info[9].fileTime2 = 0U;
  c8_info[10].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_numel.m";
  c8_info[10].name = "numel";
  c8_info[10].dominantType = "double";
  c8_info[10].resolved = "[B]numel";
  c8_info[10].fileLength = 0U;
  c8_info[10].fileTime1 = 0U;
  c8_info[10].fileTime2 = 0U;
  c8_info[11].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c8_info[11].name = "islogical";
  c8_info[11].dominantType = "double";
  c8_info[11].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/datatypes/islogical.m";
  c8_info[11].fileLength = 186U;
  c8_info[11].fileTime1 = 1160425022U;
  c8_info[11].fileTime2 = 0U;
  c8_info[12].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c8_info[12].name = "zeros";
  c8_info[12].dominantType = "double";
  c8_info[12].resolved = "[B]zeros";
  c8_info[12].fileLength = 0U;
  c8_info[12].fileTime1 = 0U;
  c8_info[12].fileTime2 = 0U;
  c8_info[13].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elmat/length.m";
  c8_info[13].name = "size";
  c8_info[13].dominantType = "double";
  c8_info[13].resolved = "[B]size";
  c8_info[13].fileLength = 0U;
  c8_info[13].fileTime1 = 0U;
  c8_info[13].fileTime2 = 0U;
  c8_info[14].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c8_info[14].name = "isfloat";
  c8_info[14].dominantType = "double";
  c8_info[14].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/datatypes/isfloat.m";
  c8_info[14].fileLength = 182U;
  c8_info[14].fileTime1 = 1160425020U;
  c8_info[14].fileTime2 = 0U;
  c8_info[15].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c8_info[15].name = "not";
  c8_info[15].dominantType = "logical";
  c8_info[15].resolved = "[B]not";
  c8_info[15].fileLength = 0U;
  c8_info[15].fileTime1 = 0U;
  c8_info[15].fileTime2 = 0U;
  c8_info[16].context = "";
  c8_info[16].name = "plus";
  c8_info[16].dominantType = "double";
  c8_info[16].resolved = "[B]plus";
  c8_info[16].fileLength = 0U;
  c8_info[16].fileTime1 = 0U;
  c8_info[16].fileTime2 = 0U;
  c8_info[17].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c8_info[17].name = "gt";
  c8_info[17].dominantType = "double";
  c8_info[17].resolved = "[B]gt";
  c8_info[17].fileLength = 0U;
  c8_info[17].fileTime1 = 0U;
  c8_info[17].fileTime2 = 0U;
  c8_info[18].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/datatypes/isa.m";
  c8_info[18].name = "eml_is_float_class";
  c8_info[18].dominantType = "char";
  c8_info[18].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_is_float_class.m";
  c8_info[18].fileLength = 273U;
  c8_info[18].fileTime1 = 1160425144U;
  c8_info[18].fileTime2 = 0U;
  c8_info[19].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_is_float_class.m";
  c8_info[19].name = "ischar";
  c8_info[19].dominantType = "char";
  c8_info[19].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/strfun/ischar.m";
  c8_info[19].fileLength = 244U;
  c8_info[19].fileTime1 = 1160425234U;
  c8_info[19].fileTime2 = 0U;
  c8_info[20].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c8_info[20].name = "eml_assert";
  c8_info[20].dominantType = "char";
  c8_info[20].resolved = "[B]eml_assert";
  c8_info[20].fileLength = 0U;
  c8_info[20].fileTime1 = 0U;
  c8_info[20].fileTime2 = 0U;
  c8_info[21].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/datatypes/isa.m";
  c8_info[21].name = "strcmp";
  c8_info[21].dominantType = "char";
  c8_info[21].resolved = "[B]strcmp";
  c8_info[21].fileLength = 0U;
  c8_info[21].fileTime1 = 0U;
  c8_info[21].fileTime2 = 0U;
  c8_info[22].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elmat/length.m";
  c8_info[22].name = "eml_numel";
  c8_info[22].dominantType = "double";
  c8_info[22].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_numel.m";
  c8_info[22].fileLength = 278U;
  c8_info[22].fileTime1 = 1163949202U;
  c8_info[22].fileTime2 = 0U;
  c8_info[23].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c8_info[23].name = "eml_isa_uint";
  c8_info[23].dominantType = "double";
  c8_info[23].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_isa_uint.m";
  c8_info[23].fileLength = 288U;
  c8_info[23].fileTime1 = 1163949198U;
  c8_info[23].fileTime2 = 0U;
  c8_info[24].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c8_info[24].name = "isempty";
  c8_info[24].dominantType = "double";
  c8_info[24].resolved = "[B]isempty";
  c8_info[24].fileLength = 0U;
  c8_info[24].fileTime1 = 0U;
  c8_info[24].fileTime2 = 0U;
  c8_info[25].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/datatypes/isa.m";
  c8_info[25].name = "eq";
  c8_info[25].dominantType = "double";
  c8_info[25].resolved = "[B]eq";
  c8_info[25].fileLength = 0U;
  c8_info[25].fileTime1 = 0U;
  c8_info[25].fileTime2 = 0U;
}

static void init_dsm_address_info(void)
{
}

/* SFunction Glue Code */
void sf_c8_supply_3_GA_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(277954793U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(4040047261U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(2811602052U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(1221420416U);
}

mxArray *sf_c8_supply_3_GA_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] =
  {"checksum","inputs","parameters","outputs"};
  mxArray *mxAutoinheritanceInfo =
  mxCreateStructMatrix(1,1,4,autoinheritanceFields);
  {
    mxArray *mxChecksum = mxCreateDoubleMatrix(4,1,mxREAL);
    double *pr = mxGetPr(mxChecksum);
    pr[0] = (double)(4134639946U);
    pr[1] = (double)(1932682459U);
    pr[2] = (double)(2714485965U);
    pr[3] = (double)(3163624183U);
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }
  {
    const char *dataFields[] = {"size","type","complexity"};
    mxArray *mxData = mxCreateStructMatrix(1,6,3,dataFields);
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }
    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }
    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }
    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,3,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,3,"type",mxType);
    }
    mxSetField(mxData,3,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,4,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,4,"type",mxType);
    }
    mxSetField(mxData,4,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,5,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,5,"type",mxType);
    }
    mxSetField(mxData,5,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }
  {
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxCreateDoubleMatrix(0,0,mxREAL));
  }
  {
    const char *dataFields[] = {"size","type","complexity"};
    mxArray *mxData = mxCreateStructMatrix(1,1,3,dataFields);
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(2);
      mxSetField(mxData,0,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }
    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }
  return(mxAutoinheritanceInfo);
}

static void chart_debug_initialization(SimStruct *S, unsigned int
 fullDebuggerInitialization)
{
  if(ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
    /* do this only if simulation is starting */
    if(!sim_mode_is_rtw_gen(S)) {
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent =
          sf_debug_initialize_chart(_supply_3_GAMachineNumber_,
         8,
         1,
         1,
         7,
         0,
         0,
         0,
         0,
         0,
         &(chartInstance.chartNumber),
         &(chartInstance.instanceNumber),
         ssGetPath(S),
         (void *)S);
        if(chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation(_supply_3_GAMachineNumber_,chartInstance.chartNumber);
          sf_debug_set_chart_disable_implicit_casting(_supply_3_GAMachineNumber_,chartInstance.chartNumber,1);
          sf_debug_set_chart_event_thresholds(_supply_3_GAMachineNumber_,
           chartInstance.chartNumber,
           0,
           0,
           0);

          {
            unsigned int dimVector[1];
            dimVector[0]= 3;
            _SFD_SET_DATA_PROPS(4,1,1,0,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,1.0,0,"tl",0,c8_sf_marshall);
          }
          {
            unsigned int dimVector[1];
            dimVector[0]= 3;
            _SFD_SET_DATA_PROPS(1,1,1,0,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,1.0,0,"dtl",0,c8_b_sf_marshall);
          }
          _SFD_SET_DATA_PROPS(0,1,1,0,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,"tau",0,c8_c_sf_marshall);
          _SFD_SET_DATA_PROPS(3,1,1,0,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,"dtau",0,c8_d_sf_marshall);
          {
            unsigned int dimVector[2];
            dimVector[0]= 3;
            dimVector[1]= 2;
            _SFD_SET_DATA_PROPS(5,2,0,1,SF_DOUBLE,2,&(dimVector[0]),0,0,0,0.0,1.0,0,"Jp",0,c8_g_sf_marshall);
          }
          {
            unsigned int dimVector[1];
            dimVector[0]= 3;
            _SFD_SET_DATA_PROPS(2,1,1,0,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,1.0,0,"f",0,c8_e_sf_marshall);
          }
          {
            unsigned int dimVector[1];
            dimVector[0]= 3;
            _SFD_SET_DATA_PROPS(6,1,1,0,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,1.0,0,"df",0,c8_f_sf_marshall);
          }
          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }
        _SFD_CV_INIT_CHART(0,0,0,0);
        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of EML Model Coverage */
        _SFD_CV_INIT_EML(0,1,6,0,0,0,0,0);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,532);
        _SFD_CV_INIT_EML_IF(0,0,171,190,-1,215);
        _SFD_CV_INIT_EML_IF(0,1,216,235,-1,260);
        _SFD_CV_INIT_EML_IF(0,2,261,280,-1,305);
        _SFD_CV_INIT_EML_IF(0,3,367,387,-1,414);
        _SFD_CV_INIT_EML_IF(0,4,415,435,-1,462);
        _SFD_CV_INIT_EML_IF(0,5,463,483,-1,510);
        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if(chartAlreadyPresent==0)
        {
          _SFD_TRANS_COV_MAPS(0,
           0,NULL,NULL,
           0,NULL,NULL,
           1,NULL,NULL,
           0,NULL,NULL);
        }

        {
          real_T (*c8_tl)[3];
          real_T (*c8_dtl)[3];
          real_T *c8_tau;
          real_T *c8_dtau;
          real_T (*c8_Jp)[6];
          real_T (*c8_f)[3];
          real_T (*c8_df)[3];
          c8_tau = (real_T *)ssGetInputPortSignal(chartInstance.S, 2);
          c8_f = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 4);
          c8_dtau = (real_T *)ssGetInputPortSignal(chartInstance.S, 3);
          c8_Jp = (real_T (*)[6])ssGetOutputPortSignal(chartInstance.S, 1);
          c8_df = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 5);
          c8_tl = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 0);
          c8_dtl = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 1);
          _SFD_SET_DATA_VALUE_PTR(4U, c8_tl);
          _SFD_SET_DATA_VALUE_PTR(1U, c8_dtl);
          _SFD_SET_DATA_VALUE_PTR(0U, c8_tau);
          _SFD_SET_DATA_VALUE_PTR(3U, c8_dtau);
          _SFD_SET_DATA_VALUE_PTR(5U, c8_Jp);
          _SFD_SET_DATA_VALUE_PTR(2U, c8_f);
          _SFD_SET_DATA_VALUE_PTR(6U, c8_df);
        }
      }
    }
  } else {
    sf_debug_reset_current_state_configuration(_supply_3_GAMachineNumber_,chartInstance.chartNumber,chartInstance.instanceNumber);
  }
}

static void sf_opaque_initialize_c8_supply_3_GA(void *chartInstanceVar)
{
  chart_debug_initialization(chartInstance.S,0);
  initialize_params_c8_supply_3_GA();
  initialize_c8_supply_3_GA();
}

static void sf_opaque_enable_c8_supply_3_GA(void *chartInstanceVar)
{
  enable_c8_supply_3_GA();
}

static void sf_opaque_disable_c8_supply_3_GA(void *chartInstanceVar)
{
  disable_c8_supply_3_GA();
}

static void sf_opaque_gateway_c8_supply_3_GA(void *chartInstanceVar)
{
  sf_c8_supply_3_GA();
}

static void sf_opaque_terminate_c8_supply_3_GA(void *chartInstanceVar)
{
  if (sim_mode_is_rtw_gen(chartInstance.S) ||
   sim_mode_is_external(chartInstance.S)) {
    sf_clear_rtw_identifier(chartInstance.S);
  }
  finalize_c8_supply_3_GA();
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c8_supply_3_GA(SimStruct *S)
{
  int i;
  for(i=0;i<ssGetNumRunTimeParams(S);i++) {
    if(ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }
  if(sf_machine_global_initializer_called()) {
    initialize_params_c8_supply_3_GA();
  }
}

static void mdlSetWorkWidths_c8_supply_3_GA(SimStruct *S)
{
  if(sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable("supply_3_GA",8);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop("supply_3_GA",8,"gatewayCannotBeInlinedMultipleTimes"));
    if(chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 1, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 2, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 3, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 4, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 5, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,"supply_3_GA",8,6);
      sf_mark_chart_reusable_outputs(S,"supply_3_GA",8,1);
    }
    sf_set_rtw_dwork_info(S,"supply_3_GA",8);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
    ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  }

  ssSetChecksum0(S,(2509185506U));
  ssSetChecksum1(S,(1352505646U));
  ssSetChecksum2(S,(259247270U));
  ssSetChecksum3(S,(3203824434U));

  ssSetmdlDerivatives(S, NULL);

  ssSetExplicitFCSSCtrl(S,1);
}

static void mdlRTW_c8_supply_3_GA(SimStruct *S)
{
  if(sim_mode_is_rtw_gen(S)) {
    sf_write_symbol_mapping(S, "supply_3_GA", 8);
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c8_supply_3_GA(SimStruct *S)
{
  chartInstance.chartInfo.chartInstance = NULL;
  chartInstance.chartInfo.isEMLChart = 1;
  chartInstance.chartInfo.chartInitialized = 0;
  chartInstance.chartInfo.sFunctionGateway = sf_opaque_gateway_c8_supply_3_GA;
  chartInstance.chartInfo.initializeChart = sf_opaque_initialize_c8_supply_3_GA;
  chartInstance.chartInfo.terminateChart = sf_opaque_terminate_c8_supply_3_GA;
  chartInstance.chartInfo.enableChart = sf_opaque_enable_c8_supply_3_GA;
  chartInstance.chartInfo.disableChart = sf_opaque_disable_c8_supply_3_GA;
  chartInstance.chartInfo.zeroCrossings = NULL;
  chartInstance.chartInfo.outputs = NULL;
  chartInstance.chartInfo.derivatives = NULL;
  chartInstance.chartInfo.mdlRTW = mdlRTW_c8_supply_3_GA;
  chartInstance.chartInfo.mdlStart = mdlStart_c8_supply_3_GA;
  chartInstance.chartInfo.mdlSetWorkWidths = mdlSetWorkWidths_c8_supply_3_GA;
  chartInstance.chartInfo.extModeExec = NULL;
  chartInstance.chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance.chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance.chartInfo.storeCurrentConfiguration = NULL;
  chartInstance.S = S;
  ssSetUserData(S,(void *)(&(chartInstance.chartInfo))); /* register the chart instance with simstruct */

  if(!sim_mode_is_rtw_gen(S)) {
    init_dsm_address_info();
  }
  chart_debug_initialization(S,1);
}

void c8_supply_3_GA_method_dispatcher(SimStruct *S, int_T method, void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c8_supply_3_GA(S);
    break;
   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c8_supply_3_GA(S);
    break;
   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c8_supply_3_GA(S);
    break;
   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
     "Error calling c8_supply_3_GA_method_dispatcher.\n"
     "Can't handle method %d.\n", method);
    break;
  }
}

