simIn.plot = 1; % 0 if not plotting 1 if plotting position during sim.
simIn.step_dist = 0; % Add step disturbance peak 20 s after 3 min
simIn.adap_w = 0;    % Activate adaptive omega
% Simulationtime default 5 min
simIn.offset = 120; % Delay before calculating PI
% NB! wave is generated for max 7 min
T = 300; % Time window
Ts = 0.2; % Sampling time h
simIn.time = simIn.offset + T; 
% Init weigthing levels
simIn.pos_weight= [0.2 0.3 0.5];
simIn.head_weight = [0.2 0.3 0.5];
simIn.lambda = [0.5, 0.5, 0.5]; % lambda weighting force
% Setting heading ref 
simIn.psi_d = 0;    % NB! PI is implemented only for 0 deg
simIn.SeaState = 4; % Sea state code, wave is pre-generated only up to 5
simIn.sea_type = 1; % 0 equals Longcrest waves, 1 equals Shortcrest
simIn.Beta_c = 225; % Ocean current direction in deg
simIn.V_c = 0.5;    % Ocean current speed in [m/s]
simIn.w_surge = 0.0375;% 0.25
simIn.w_sway = 0.0625; %0.25
simIn.w_yaw = 0.0625;  %0.25
simIn.tau_min = [0, 0, 0];
simIn.tau_max = [0.75, 0.75, 0.75];
%% Setting levels
[simIn.x_lim(1),simIn.x_lim(2),simIn.x_lim(3),...
    simIn.y_lim(1),simIn.y_lim(2),simIn.y_lim(3),...
    simIn.h_lim(1),simIn.h_lim(2),simIn.h_lim(3),...
    simIn.filter_w0] =...
    set_lev_filt(simIn.SeaState, 0.7, simIn.psi_d,simIn.lambda);
disp('Initial simulink model parameters')
simIn