function chromosome = initPopNonLin(size, low_bound, up_bound);
% Initialise population for NonLinPID controller
rand('state',sum(100*clock));  % Resets it to a different state each time
for k = 1:size
    chromosome(k,1) = rand(1)*(up_bound-low_bound/2) + low_bound/2; %omega surge
    chromosome(k,2) = rand(1)*(up_bound-low_bound) + low_bound;  % omega sway
    chromosome(k,3) = rand(1)*(up_bound-low_bound) + low_bound;  % omega yaw
end