%% Plot
% Performance position
L1Str = ['J_{l1} = ',num2str(round(Jp_lev(end,1)*10)/10),' [%]'];
L2Str = ['J_{l2} = ',num2str(round(Jp_lev(end,2)*10)/10),' [%]'];
L3Str = ['J_{l3} = ',num2str(round(Jp_lev(end,3)*10)/10),' [%]'];
JpStr =   ['J_p      = ',num2str(round(Jp_Jh_lev(end,1)*10)/10),' [%]'];
JtsuStr = ['J_{\tau_{surge}} = ',num2str(round(JT_tau(end,1)*10)/10),' [%]'];
JtswStr = ['J_{\tau_{sway}}  = ',num2str(round(JT_tau(end,2)*10)/10),' [%]'];
seaState = ['Sea state = ',num2str(simIn.SeaState)];
Wsway = ['weight = ',num2str(simIn.lambda(2))];
w_surge = ['\omega_{surge} = ',num2str(round(simIn.w_surge*10000)/10000)];
w_sway = ['\omega_{sway} = ',num2str(round(simIn.w_sway*10000)/10000)];
% Performance heading 
H1Str = ['J_{h1} = ',num2str(round(Jh_lev(end,1)*10)/10),' [%]'];
H2Str = ['J_{h2} = ',num2str(round(Jh_lev(end,2)*10)/10),' [%]'];
H3Str = ['J_{h3} = ',num2str(round(Jh_lev(end,3)*10)/10),' [%]'];
JhStr = ['J_h    = ',num2str(round(Jp_Jh_lev(end,3)*10)/10),' [%]'];
JtyaStr = ['J_{\tau_{yaw}} = ',num2str(round(JT_tau(end,3)*10)/10),' [%]'];
Wyaw = ['weight = ',num2str(simIn.lambda(3))];
w_yaw = ['\omega_{yaw} = ',num2str(round(simIn.w_yaw*10000)/10000)];
% Plotting
levels_plot_pos(0,0,simIn.x_lim,simIn.y_lim,simIn.psi_d,...
    y.signals.values((offset+1):end,1),x.signals.values((offset+1):end,1)...
    ,L1Str,L2Str,L3Str,JpStr,JtsuStr,JtswStr,seaState,Wsway,w_surge,w_sway);
head_perf_fig(simIn.h_lim,psi,offset,H1Str,H2Str,H3Str,JhStr,JtyaStr,seaState,Wyaw,w_yaw)
tau_bal_plot(Jp_Jh_lev(end,1),Jp_Jh_lev(end,3),JT_tau(end,1),JT_tau(end,2),JT_tau(end,3))
