/* Include files */
#include "supply__sfun.h"
#include "c1_supply_.h"
#define CHARTINSTANCE_CHARTNUMBER       (chartInstance.chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER    (chartInstance.instanceNumber)
#include "supply__sfun_debug_macros.h"

/* Type Definitions */

/* Named Constants */
#define c1_IN_NO_ACTIVE_CHILD           (0)

/* Variable Declarations */

/* Variable Definitions */
static SFc1_supply_InstanceStruct chartInstance;

/* Function Declarations */
static void initialize_c1_supply_(void);
static void initialize_params_c1_supply_(void);
static void enable_c1_supply_(void);
static void disable_c1_supply_(void);
static void finalize_c1_supply_(void);
static void sf_c1_supply_(void);
static void init_script_number_translation(uint32_T c1_machineNumber, uint32_T
 c1_chartNumber);
static real_T c1_mpower(real_T c1_a);
static const mxArray *c1_sf_marshall(void *c1_chartInstance, void *c1_u);
static const mxArray *c1_b_sf_marshall(void *c1_chartInstance, void *c1_u);
static const mxArray *c1_c_sf_marshall(void *c1_chartInstance, void *c1_u);
static const mxArray *c1_d_sf_marshall(void *c1_chartInstance, void *c1_u);
static const mxArray *c1_e_sf_marshall(void *c1_chartInstance, void *c1_u);
static const mxArray *c1_f_sf_marshall(void *c1_chartInstance, void *c1_u);
static const mxArray *c1_g_sf_marshall(void *c1_chartInstance, void *c1_u);
static const mxArray *c1_h_sf_marshall(void *c1_chartInstance, void *c1_u);
static const mxArray *c1_i_sf_marshall(void *c1_chartInstance, void *c1_u);
static const mxArray *c1_j_sf_marshall(void *c1_chartInstance, void *c1_u);
static const mxArray *c1_k_sf_marshall(void *c1_chartInstance, void *c1_u);
static const mxArray *c1_l_sf_marshall(void *c1_chartInstance, void *c1_u);
static const mxArray *c1_m_sf_marshall(void *c1_chartInstance, void *c1_u);
static const mxArray *c1_n_sf_marshall(void *c1_chartInstance, void *c1_u);
static const mxArray *c1_o_sf_marshall(void *c1_chartInstance, void *c1_u);
static void c1_info_helper(c1_ResolvedFunctionInfo c1_info[55]);
static void init_dsm_address_info(void);

/* Function Definitions */
static void initialize_c1_supply_(void)
{
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
  chartInstance.c1_is_active_c1_supply_ = 0U;
}

static void initialize_params_c1_supply_(void)
{
}

static void enable_c1_supply_(void)
{
}

static void disable_c1_supply_(void)
{
}

static void finalize_c1_supply_(void)
{
}

static void sf_c1_supply_(void)
{
  int32_T c1_i0;
  int32_T c1_i1;
  int32_T c1_i2;
  int32_T c1_i3;
  int32_T c1_i4;
  int32_T c1_i5;
  int32_T c1_i6;
  uint8_T c1_previousEvent;
  int32_T c1_i7;
  real_T c1_a[3];
  int32_T c1_i8;
  real_T c1_b[3];
  int32_T c1_i9;
  real_T c1_c[3];
  real_T c1_x;
  real_T c1_y;
  real_T c1_psi;
  int32_T c1_i10;
  real_T c1_l[3];
  int32_T c1_i11;
  real_T c1_h[3];
  real_T c1_psi_abs;
  real_T c1_r3;
  real_T c1_r2;
  real_T c1_r1;
  real_T c1_phi;
  real_T c1_r;
  real_T c1_Jp[6];
  real_T c1_b_x;
  int32_T c1_i12;
  static char c1_cv0[31] = { 'E', 'm', 'b', 'e', 'd', 'd', 'e', 'd', 'M', 'A',
    'T', 'L', 'A', 'B', ':', 's', 'q', 'r', 't', ':', 'd',
    'o', 'm', 'a', 'i', 'n', 'E', 'r', 'r', 'o', 'r' };
  char c1_x1[31];
  int32_T c1_i13;
  static char c1_cv1[77] = { 'D', 'o', 'm', 'a', 'i', 'n', ' ', 'e', 'r', 'r',
    'o', 'r', '.', ' ', 'T', 'o', ' ', 'c', 'o', 'm', 'p',
    'u', 't', 'e', ' ', 'c', 'o', 'm', 'p', 'l', 'e', 'x', ' ', 'r', 'e', 's',
    'u', 'l', 't', 's', ' ', 'f',
    'r', 'o', 'm', ' ', 'r', 'e', 'a', 'l', ' ', 'x', ',', ' ', 'u', 's', 'e',
    ' ', '\'', 's', 'q', 'r', 't'
    , '(', 'c', 'o', 'm', 'p', 'l', 'e', 'x', '(', 'x', ')', ')', '\'', '.' };
  char c1_x2[77];
  int32_T c1_i14;
  char c1_u[31];
  const mxArray *c1_b_y = NULL;
  int32_T c1_i15;
  char c1_b_u[77];
  const mxArray *c1_c_y = NULL;
  real_T c1_A;
  real_T c1_B;
  real_T c1_c_x;
  real_T c1_d_y;
  real_T c1_b_A;
  real_T c1_b_B;
  real_T c1_d_x;
  real_T c1_e_y;
  real_T c1_e_x;
  real_T c1_c_A;
  real_T c1_f_x;
  real_T c1_g_x;
  real_T c1_h_x;
  real_T c1_i_x;
  real_T c1_j_x;
  real_T c1_c_B;
  int32_T c1_i16;
  char c1_b_x1[31];
  int32_T c1_i17;
  char c1_b_x2[77];
  int32_T c1_i18;
  char c1_c_u[31];
  const mxArray *c1_f_y = NULL;
  int32_T c1_i19;
  char c1_d_u[77];
  const mxArray *c1_g_y = NULL;
  real_T c1_k_x;
  real_T c1_h_y;
  real_T c1_d_A;
  real_T c1_l_x;
  real_T c1_m_x;
  real_T c1_n_x;
  real_T c1_o_x;
  real_T c1_p_x;
  real_T c1_d_B;
  int32_T c1_i20;
  char c1_c_x1[31];
  int32_T c1_i21;
  char c1_c_x2[77];
  int32_T c1_i22;
  char c1_e_u[31];
  const mxArray *c1_i_y = NULL;
  int32_T c1_i23;
  char c1_f_u[77];
  const mxArray *c1_j_y = NULL;
  real_T c1_q_x;
  real_T c1_k_y;
  real_T c1_e_A;
  real_T c1_r_x;
  real_T c1_s_x;
  real_T c1_t_x;
  real_T c1_u_x;
  real_T c1_v_x;
  real_T c1_e_B;
  int32_T c1_i24;
  char c1_d_x1[31];
  int32_T c1_i25;
  char c1_d_x2[77];
  int32_T c1_i26;
  char c1_g_u[31];
  const mxArray *c1_l_y = NULL;
  int32_T c1_i27;
  char c1_h_u[77];
  const mxArray *c1_m_y = NULL;
  real_T c1_w_x;
  real_T c1_n_y;
  real_T c1_x_x;
  int32_T c1_i28;
  int32_T c1_i29;
  int32_T c1_i30;
  int32_T c1_i31;
  real_T *c1_y_x;
  real_T *c1_o_y;
  real_T *c1_b_psi;
  real_T (*c1_b_Jp)[6];
  real_T (*c1_b_a)[3];
  real_T (*c1_b_b)[3];
  real_T (*c1_b_c)[3];
  real_T (*c1_b_l)[3];
  real_T (*c1_b_h)[3];
  c1_b_psi = (real_T *)ssGetInputPortSignal(chartInstance.S, 5);
  c1_b_b = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 1);
  c1_b_Jp = (real_T (*)[6])ssGetOutputPortSignal(chartInstance.S, 1);
  c1_o_y = (real_T *)ssGetInputPortSignal(chartInstance.S, 4);
  c1_b_c = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 2);
  c1_y_x = (real_T *)ssGetInputPortSignal(chartInstance.S, 3);
  c1_b_l = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 6);
  c1_b_h = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 7);
  c1_b_a = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 0);
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
  for(c1_i0 = 0; c1_i0 < 3; c1_i0 = c1_i0 + 1) {
    _SFD_DATA_RANGE_CHECK((*c1_b_a)[c1_i0], 8U);
  }
  for(c1_i1 = 0; c1_i1 < 3; c1_i1 = c1_i1 + 1) {
    _SFD_DATA_RANGE_CHECK((*c1_b_b)[c1_i1], 5U);
  }
  for(c1_i2 = 0; c1_i2 < 3; c1_i2 = c1_i2 + 1) {
    _SFD_DATA_RANGE_CHECK((*c1_b_c)[c1_i2], 3U);
  }
  _SFD_DATA_RANGE_CHECK(*c1_y_x, 6U);
  for(c1_i3 = 0; c1_i3 < 2; c1_i3 = c1_i3 + 1) {
    for(c1_i4 = 0; c1_i4 < 3; c1_i4 = c1_i4 + 1) {
      _SFD_DATA_RANGE_CHECK((*c1_b_Jp)[c1_i4 + 3 * c1_i3], 7U);
    }
  }
  _SFD_DATA_RANGE_CHECK(*c1_o_y, 1U);
  _SFD_DATA_RANGE_CHECK(*c1_b_psi, 4U);
  for(c1_i5 = 0; c1_i5 < 3; c1_i5 = c1_i5 + 1) {
    _SFD_DATA_RANGE_CHECK((*c1_b_l)[c1_i5], 0U);
  }
  for(c1_i6 = 0; c1_i6 < 3; c1_i6 = c1_i6 + 1) {
    _SFD_DATA_RANGE_CHECK((*c1_b_h)[c1_i6], 2U);
  }
  c1_previousEvent = _sfEvent_;
  _sfEvent_ = CALL_EVENT;
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG,0);
  for(c1_i7 = 0; c1_i7 < 3; c1_i7 = c1_i7 + 1) {
    c1_a[c1_i7] = (*c1_b_a)[c1_i7];
  }
  for(c1_i8 = 0; c1_i8 < 3; c1_i8 = c1_i8 + 1) {
    c1_b[c1_i8] = (*c1_b_b)[c1_i8];
  }
  for(c1_i9 = 0; c1_i9 < 3; c1_i9 = c1_i9 + 1) {
    c1_c[c1_i9] = (*c1_b_c)[c1_i9];
  }
  c1_x = *c1_y_x;
  c1_y = *c1_o_y;
  c1_psi = *c1_b_psi;
  for(c1_i10 = 0; c1_i10 < 3; c1_i10 = c1_i10 + 1) {
    c1_l[c1_i10] = (*c1_b_l)[c1_i10];
  }
  for(c1_i11 = 0; c1_i11 < 3; c1_i11 = c1_i11 + 1) {
    c1_h[c1_i11] = (*c1_b_h)[c1_i11];
  }
  sf_debug_symbol_scope_push(15U, 0U);
  sf_debug_symbol_scope_add("psi_abs", &c1_psi_abs, c1_o_sf_marshall);
  sf_debug_symbol_scope_add("r3", &c1_r3, c1_n_sf_marshall);
  sf_debug_symbol_scope_add("r2", &c1_r2, c1_m_sf_marshall);
  sf_debug_symbol_scope_add("r1", &c1_r1, c1_l_sf_marshall);
  sf_debug_symbol_scope_add("phi", &c1_phi, c1_k_sf_marshall);
  sf_debug_symbol_scope_add("r", &c1_r, c1_j_sf_marshall);
  sf_debug_symbol_scope_add("Jp", &c1_Jp, c1_i_sf_marshall);
  sf_debug_symbol_scope_add("h", &c1_h, c1_h_sf_marshall);
  sf_debug_symbol_scope_add("l", &c1_l, c1_g_sf_marshall);
  sf_debug_symbol_scope_add("psi", &c1_psi, c1_f_sf_marshall);
  sf_debug_symbol_scope_add("y", &c1_y, c1_e_sf_marshall);
  sf_debug_symbol_scope_add("x", &c1_x, c1_d_sf_marshall);
  sf_debug_symbol_scope_add("c", &c1_c, c1_c_sf_marshall);
  sf_debug_symbol_scope_add("b", &c1_b, c1_b_sf_marshall);
  sf_debug_symbol_scope_add("a", &c1_a, c1_sf_marshall);
  CV_EML_FCN(0, 0);
  /*  Radius to position from setpoint */
  _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,3);
  c1_b_x = c1_mpower(c1_x) + c1_mpower(c1_y);
  c1_r = c1_b_x;
  if(c1_r < 0.0) {
    for(c1_i12 = 0; c1_i12 < 31; c1_i12 = c1_i12 + 1) {
      c1_x1[c1_i12] = c1_cv0[c1_i12];
    }
    for(c1_i13 = 0; c1_i13 < 77; c1_i13 = c1_i13 + 1) {
      c1_x2[c1_i13] = c1_cv1[c1_i13];
    }
    for(c1_i14 = 0; c1_i14 < 31; c1_i14 = c1_i14 + 1) {
      c1_u[c1_i14] = c1_x1[c1_i14];
    }
    c1_b_y = NULL;
    sf_mex_assign(&c1_b_y, sf_mex_create(&c1_u, "y", 8, 0U, 1U, 2, 1, 31));
    for(c1_i15 = 0; c1_i15 < 77; c1_i15 = c1_i15 + 1) {
      c1_b_u[c1_i15] = c1_x2[c1_i15];
    }
    c1_c_y = NULL;
    sf_mex_assign(&c1_c_y, sf_mex_create(&c1_b_u, "y", 8, 0U, 1U, 2, 1, 77));
    sf_mex_call("error", 0U, 2U, 14, c1_b_y, 14, c1_c_y);
  }
  c1_r = sqrt(c1_r);
  _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,6);
  if(CV_EML_IF(0, 0, c1_y == 0.0)) {
    /*  Angle to position from setpoint */
    _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,7);
    c1_A = 3.1415926535897931E+000;
    c1_B = 2.0;
    c1_c_x = c1_A;
    c1_d_y = c1_B;
    c1_phi = c1_c_x / c1_d_y;
  } else {
    _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,9);
    c1_b_A = c1_x;
    c1_b_B = c1_y;
    c1_d_x = c1_b_A;
    c1_e_y = c1_b_B;
    c1_e_x = c1_d_x / c1_e_y;
    c1_phi = c1_e_x;
    c1_phi = atan(c1_phi);
  }
  /*  Radius levels */
  _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,12);
  c1_c_A = c1_a[0] * c1_b[0];
  c1_f_x = c1_phi;
  c1_g_x = c1_f_x;
  c1_g_x = sin(c1_g_x);
  c1_h_x = c1_phi;
  c1_i_x = c1_h_x;
  c1_i_x = cos(c1_i_x);
  c1_j_x = c1_mpower(c1_b[0]) * c1_mpower(c1_i_x) + c1_mpower(c1_a[0]) *
    c1_mpower(c1_g_x);
  c1_c_B = c1_j_x;
  if(c1_c_B < 0.0) {
    for(c1_i16 = 0; c1_i16 < 31; c1_i16 = c1_i16 + 1) {
      c1_b_x1[c1_i16] = c1_cv0[c1_i16];
    }
    for(c1_i17 = 0; c1_i17 < 77; c1_i17 = c1_i17 + 1) {
      c1_b_x2[c1_i17] = c1_cv1[c1_i17];
    }
    for(c1_i18 = 0; c1_i18 < 31; c1_i18 = c1_i18 + 1) {
      c1_c_u[c1_i18] = c1_b_x1[c1_i18];
    }
    c1_f_y = NULL;
    sf_mex_assign(&c1_f_y, sf_mex_create(&c1_c_u, "y", 8, 0U, 1U, 2, 1, 31));
    for(c1_i19 = 0; c1_i19 < 77; c1_i19 = c1_i19 + 1) {
      c1_d_u[c1_i19] = c1_b_x2[c1_i19];
    }
    c1_g_y = NULL;
    sf_mex_assign(&c1_g_y, sf_mex_create(&c1_d_u, "y", 8, 0U, 1U, 2, 1, 77));
    sf_mex_call("error", 0U, 2U, 14, c1_f_y, 14, c1_g_y);
  }
  c1_c_B = sqrt(c1_c_B);
  c1_k_x = c1_c_A;
  c1_h_y = c1_c_B;
  c1_r1 = c1_k_x / c1_h_y;
  _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,13);
  c1_d_A = c1_a[1] * c1_b[1];
  c1_l_x = c1_phi;
  c1_m_x = c1_l_x;
  c1_m_x = sin(c1_m_x);
  c1_n_x = c1_phi;
  c1_o_x = c1_n_x;
  c1_o_x = cos(c1_o_x);
  c1_p_x = c1_mpower(c1_b[1]) * c1_mpower(c1_o_x) + c1_mpower(c1_a[1]) *
    c1_mpower(c1_m_x);
  c1_d_B = c1_p_x;
  if(c1_d_B < 0.0) {
    for(c1_i20 = 0; c1_i20 < 31; c1_i20 = c1_i20 + 1) {
      c1_c_x1[c1_i20] = c1_cv0[c1_i20];
    }
    for(c1_i21 = 0; c1_i21 < 77; c1_i21 = c1_i21 + 1) {
      c1_c_x2[c1_i21] = c1_cv1[c1_i21];
    }
    for(c1_i22 = 0; c1_i22 < 31; c1_i22 = c1_i22 + 1) {
      c1_e_u[c1_i22] = c1_c_x1[c1_i22];
    }
    c1_i_y = NULL;
    sf_mex_assign(&c1_i_y, sf_mex_create(&c1_e_u, "y", 8, 0U, 1U, 2, 1, 31));
    for(c1_i23 = 0; c1_i23 < 77; c1_i23 = c1_i23 + 1) {
      c1_f_u[c1_i23] = c1_c_x2[c1_i23];
    }
    c1_j_y = NULL;
    sf_mex_assign(&c1_j_y, sf_mex_create(&c1_f_u, "y", 8, 0U, 1U, 2, 1, 77));
    sf_mex_call("error", 0U, 2U, 14, c1_i_y, 14, c1_j_y);
  }
  c1_d_B = sqrt(c1_d_B);
  c1_q_x = c1_d_A;
  c1_k_y = c1_d_B;
  c1_r2 = c1_q_x / c1_k_y;
  _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,14);
  c1_e_A = c1_a[2] * c1_b[2];
  c1_r_x = c1_phi;
  c1_s_x = c1_r_x;
  c1_s_x = sin(c1_s_x);
  c1_t_x = c1_phi;
  c1_u_x = c1_t_x;
  c1_u_x = cos(c1_u_x);
  c1_v_x = c1_mpower(c1_b[2]) * c1_mpower(c1_u_x) + c1_mpower(c1_a[2]) *
    c1_mpower(c1_s_x);
  c1_e_B = c1_v_x;
  if(c1_e_B < 0.0) {
    for(c1_i24 = 0; c1_i24 < 31; c1_i24 = c1_i24 + 1) {
      c1_d_x1[c1_i24] = c1_cv0[c1_i24];
    }
    for(c1_i25 = 0; c1_i25 < 77; c1_i25 = c1_i25 + 1) {
      c1_d_x2[c1_i25] = c1_cv1[c1_i25];
    }
    for(c1_i26 = 0; c1_i26 < 31; c1_i26 = c1_i26 + 1) {
      c1_g_u[c1_i26] = c1_d_x1[c1_i26];
    }
    c1_l_y = NULL;
    sf_mex_assign(&c1_l_y, sf_mex_create(&c1_g_u, "y", 8, 0U, 1U, 2, 1, 31));
    for(c1_i27 = 0; c1_i27 < 77; c1_i27 = c1_i27 + 1) {
      c1_h_u[c1_i27] = c1_d_x2[c1_i27];
    }
    c1_m_y = NULL;
    sf_mex_assign(&c1_m_y, sf_mex_create(&c1_h_u, "y", 8, 0U, 1U, 2, 1, 77));
    sf_mex_call("error", 0U, 2U, 14, c1_l_y, 14, c1_m_y);
  }
  c1_e_B = sqrt(c1_e_B);
  c1_w_x = c1_e_A;
  c1_n_y = c1_e_B;
  c1_r3 = c1_w_x / c1_n_y;
  _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,16);
  if(CV_EML_IF(0, 1, c1_r > c1_r1)) {
    /* % Pos Level performance index */
    _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,17);
    c1_l[0] = c1_l[0] + 1.0;
  }
  _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,19);
  if(CV_EML_IF(0, 2, c1_r > c1_r2)) {
    _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,20);
    c1_l[1] = c1_l[1] + 1.0;
  }
  _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,22);
  if(CV_EML_IF(0, 3, c1_r > c1_r3)) {
    _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,23);
    c1_l[2] = c1_l[2] + 1.0;
  }
  /* % Head Level Performance index */
  _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,26);
  c1_x_x = c1_psi;
  c1_psi_abs = fabs(c1_x_x);
  _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,27);
  if(CV_EML_IF(0, 4, c1_psi_abs > c1_c[0])) {
    _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,28);
    c1_h[0] = c1_h[0] + 1.0;
  }
  _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,30);
  if(CV_EML_IF(0, 5, c1_psi_abs > c1_c[1])) {
    _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,31);
    c1_h[1] = c1_h[1] + 1.0;
  }
  _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,33);
  if(CV_EML_IF(0, 6, c1_psi_abs > c1_c[2])) {
    _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,34);
    c1_h[2] = c1_h[2] + 1.0;
  }
  /*  Output */
  _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,38);
  for(c1_i28 = 0; c1_i28 < 3; c1_i28 = c1_i28 + 1) {
    c1_Jp[c1_i28] = c1_l[c1_i28];
  }
  for(c1_i29 = 0; c1_i29 < 3; c1_i29 = c1_i29 + 1) {
    c1_Jp[c1_i29 + 3] = c1_h[c1_i29];
  }
  _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,-38);
  sf_debug_symbol_scope_pop();
  for(c1_i30 = 0; c1_i30 < 2; c1_i30 = c1_i30 + 1) {
    for(c1_i31 = 0; c1_i31 < 3; c1_i31 = c1_i31 + 1) {
      (*c1_b_Jp)[c1_i31 + 3 * c1_i30] = c1_Jp[c1_i31 + 3 * c1_i30];
    }
  }
  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG,0);
  _sfEvent_ = c1_previousEvent;
  sf_debug_check_for_state_inconsistency(_supply_MachineNumber_,
   chartInstance.chartNumber, chartInstance.instanceNumber);
}

static void init_script_number_translation(uint32_T c1_machineNumber, uint32_T
 c1_chartNumber)
{
}

static real_T c1_mpower(real_T c1_a)
{
  real_T c1_b_a;
  real_T c1_b;
  real_T c1_ak;
  real_T c1_bk;
  real_T c1_x;
  real_T c1_b_x;
  int32_T c1_i32;
  static char c1_cv2[32] = { 'E', 'm', 'b', 'e', 'd', 'd', 'e', 'd', 'M', 'A',
    'T', 'L', 'A', 'B', ':', 'p', 'o', 'w', 'e', 'r', ':',
    'd', 'o', 'm', 'a', 'i', 'n', 'E', 'r', 'r', 'o', 'r' };
  char c1_x1[32];
  int32_T c1_i33;
  static char c1_cv3[102] = { 'D', 'o', 'm', 'a', 'i', 'n', ' ', 'e', 'r', 'r',
    'o', 'r', '.', ' ', 'T', 'o', ' ', 'c', 'o', 'm', 'p'
    , 'u', 't', 'e', ' ', 'c', 'o', 'm', 'p', 'l', 'e', 'x', ' ', 'r', 'e', 's',
    'u', 'l', 't', 's', ',',
    ' ', 'm', 'a', 'k', 'e', ' ', 'a', 't', ' ', 'l', 'e', 'a', 's', 't', ' ',
    'o', 'n', 'e', ' ', 'i', 'n'
    , 'p', 'u', 't', ' ', 'c', 'o', 'm', 'p', 'l', 'e', 'x', ',', ' ', 'e', '.',
    'g', '.', ' ', '\'', 'p',
    'o', 'w', 'e', 'r', '(', 'c', 'o', 'm', 'p', 'l', 'e', 'x', '(', 'a', ')',
    ',', 'b', ')', '\'', '.' };
  char c1_x2[102];
  int32_T c1_i34;
  char c1_u[32];
  const mxArray *c1_y = NULL;
  int32_T c1_i35;
  char c1_b_u[102];
  const mxArray *c1_b_y = NULL;
  c1_b_a = c1_a;
  c1_b = 2.0;
  c1_ak = c1_b_a;
  c1_bk = c1_b;
  if(c1_ak < 0.0) {
    c1_x = c1_bk;
    c1_b_x = c1_x;
    c1_b_x = floor(c1_b_x);
    if(c1_b_x != c1_bk) {
      for(c1_i32 = 0; c1_i32 < 32; c1_i32 = c1_i32 + 1) {
        c1_x1[c1_i32] = c1_cv2[c1_i32];
      }
      for(c1_i33 = 0; c1_i33 < 102; c1_i33 = c1_i33 + 1) {
        c1_x2[c1_i33] = c1_cv3[c1_i33];
      }
      for(c1_i34 = 0; c1_i34 < 32; c1_i34 = c1_i34 + 1) {
        c1_u[c1_i34] = c1_x1[c1_i34];
      }
      c1_y = NULL;
      sf_mex_assign(&c1_y, sf_mex_create(&c1_u, "y", 8, 0U, 1U, 2, 1, 32));
      for(c1_i35 = 0; c1_i35 < 102; c1_i35 = c1_i35 + 1) {
        c1_b_u[c1_i35] = c1_x2[c1_i35];
      }
      c1_b_y = NULL;
      sf_mex_assign(&c1_b_y, sf_mex_create(&c1_b_u, "y", 8, 0U, 1U, 2, 1, 102));
      sf_mex_call("error", 0U, 2U, 14, c1_y, 14, c1_b_y);
    }
  }
  return pow(c1_ak, c1_bk);
}

static const mxArray *c1_sf_marshall(void *c1_chartInstance, void *c1_u)
{
  const mxArray *c1_y = NULL;
  int32_T c1_i36;
  real_T c1_b_u[3];
  const mxArray *c1_b_y = NULL;
  c1_y = NULL;
  for(c1_i36 = 0; c1_i36 < 3; c1_i36 = c1_i36 + 1) {
    c1_b_u[c1_i36] = (*((real_T (*)[3])c1_u))[c1_i36];
  }
  c1_b_y = NULL;
  sf_mex_assign(&c1_b_y, sf_mex_create(&c1_b_u, "y", 0, 0U, 1U, 1, 3));
  sf_mex_assign(&c1_y, c1_b_y);
  return c1_y;
}

static const mxArray *c1_b_sf_marshall(void *c1_chartInstance, void *c1_u)
{
  const mxArray *c1_y = NULL;
  int32_T c1_i37;
  real_T c1_b_u[3];
  const mxArray *c1_b_y = NULL;
  c1_y = NULL;
  for(c1_i37 = 0; c1_i37 < 3; c1_i37 = c1_i37 + 1) {
    c1_b_u[c1_i37] = (*((real_T (*)[3])c1_u))[c1_i37];
  }
  c1_b_y = NULL;
  sf_mex_assign(&c1_b_y, sf_mex_create(&c1_b_u, "y", 0, 0U, 1U, 1, 3));
  sf_mex_assign(&c1_y, c1_b_y);
  return c1_y;
}

static const mxArray *c1_c_sf_marshall(void *c1_chartInstance, void *c1_u)
{
  const mxArray *c1_y = NULL;
  int32_T c1_i38;
  real_T c1_b_u[3];
  const mxArray *c1_b_y = NULL;
  c1_y = NULL;
  for(c1_i38 = 0; c1_i38 < 3; c1_i38 = c1_i38 + 1) {
    c1_b_u[c1_i38] = (*((real_T (*)[3])c1_u))[c1_i38];
  }
  c1_b_y = NULL;
  sf_mex_assign(&c1_b_y, sf_mex_create(&c1_b_u, "y", 0, 0U, 1U, 1, 3));
  sf_mex_assign(&c1_y, c1_b_y);
  return c1_y;
}

static const mxArray *c1_d_sf_marshall(void *c1_chartInstance, void *c1_u)
{
  const mxArray *c1_y = NULL;
  real_T c1_b_u;
  const mxArray *c1_b_y = NULL;
  c1_y = NULL;
  c1_b_u = *((real_T *)c1_u);
  c1_b_y = NULL;
  sf_mex_assign(&c1_b_y, sf_mex_create(&c1_b_u, "y", 0, 0U, 0U, 0));
  sf_mex_assign(&c1_y, c1_b_y);
  return c1_y;
}

static const mxArray *c1_e_sf_marshall(void *c1_chartInstance, void *c1_u)
{
  const mxArray *c1_y = NULL;
  real_T c1_b_u;
  const mxArray *c1_b_y = NULL;
  c1_y = NULL;
  c1_b_u = *((real_T *)c1_u);
  c1_b_y = NULL;
  sf_mex_assign(&c1_b_y, sf_mex_create(&c1_b_u, "y", 0, 0U, 0U, 0));
  sf_mex_assign(&c1_y, c1_b_y);
  return c1_y;
}

static const mxArray *c1_f_sf_marshall(void *c1_chartInstance, void *c1_u)
{
  const mxArray *c1_y = NULL;
  real_T c1_b_u;
  const mxArray *c1_b_y = NULL;
  c1_y = NULL;
  c1_b_u = *((real_T *)c1_u);
  c1_b_y = NULL;
  sf_mex_assign(&c1_b_y, sf_mex_create(&c1_b_u, "y", 0, 0U, 0U, 0));
  sf_mex_assign(&c1_y, c1_b_y);
  return c1_y;
}

static const mxArray *c1_g_sf_marshall(void *c1_chartInstance, void *c1_u)
{
  const mxArray *c1_y = NULL;
  int32_T c1_i39;
  real_T c1_b_u[3];
  const mxArray *c1_b_y = NULL;
  c1_y = NULL;
  for(c1_i39 = 0; c1_i39 < 3; c1_i39 = c1_i39 + 1) {
    c1_b_u[c1_i39] = (*((real_T (*)[3])c1_u))[c1_i39];
  }
  c1_b_y = NULL;
  sf_mex_assign(&c1_b_y, sf_mex_create(&c1_b_u, "y", 0, 0U, 1U, 1, 3));
  sf_mex_assign(&c1_y, c1_b_y);
  return c1_y;
}

static const mxArray *c1_h_sf_marshall(void *c1_chartInstance, void *c1_u)
{
  const mxArray *c1_y = NULL;
  int32_T c1_i40;
  real_T c1_b_u[3];
  const mxArray *c1_b_y = NULL;
  c1_y = NULL;
  for(c1_i40 = 0; c1_i40 < 3; c1_i40 = c1_i40 + 1) {
    c1_b_u[c1_i40] = (*((real_T (*)[3])c1_u))[c1_i40];
  }
  c1_b_y = NULL;
  sf_mex_assign(&c1_b_y, sf_mex_create(&c1_b_u, "y", 0, 0U, 1U, 1, 3));
  sf_mex_assign(&c1_y, c1_b_y);
  return c1_y;
}

static const mxArray *c1_i_sf_marshall(void *c1_chartInstance, void *c1_u)
{
  const mxArray *c1_y = NULL;
  int32_T c1_i41;
  int32_T c1_i42;
  real_T c1_b_u[6];
  const mxArray *c1_b_y = NULL;
  c1_y = NULL;
  for(c1_i41 = 0; c1_i41 < 2; c1_i41 = c1_i41 + 1) {
    for(c1_i42 = 0; c1_i42 < 3; c1_i42 = c1_i42 + 1) {
      c1_b_u[c1_i42 + 3 * c1_i41] = (*((real_T (*)[6])c1_u))[c1_i42 + 3 *
        c1_i41];
    }
  }
  c1_b_y = NULL;
  sf_mex_assign(&c1_b_y, sf_mex_create(&c1_b_u, "y", 0, 0U, 1U, 2, 3, 2));
  sf_mex_assign(&c1_y, c1_b_y);
  return c1_y;
}

static const mxArray *c1_j_sf_marshall(void *c1_chartInstance, void *c1_u)
{
  const mxArray *c1_y = NULL;
  real_T c1_b_u;
  const mxArray *c1_b_y = NULL;
  c1_y = NULL;
  c1_b_u = *((real_T *)c1_u);
  c1_b_y = NULL;
  sf_mex_assign(&c1_b_y, sf_mex_create(&c1_b_u, "y", 0, 0U, 0U, 0));
  sf_mex_assign(&c1_y, c1_b_y);
  return c1_y;
}

static const mxArray *c1_k_sf_marshall(void *c1_chartInstance, void *c1_u)
{
  const mxArray *c1_y = NULL;
  real_T c1_b_u;
  const mxArray *c1_b_y = NULL;
  c1_y = NULL;
  c1_b_u = *((real_T *)c1_u);
  c1_b_y = NULL;
  sf_mex_assign(&c1_b_y, sf_mex_create(&c1_b_u, "y", 0, 0U, 0U, 0));
  sf_mex_assign(&c1_y, c1_b_y);
  return c1_y;
}

static const mxArray *c1_l_sf_marshall(void *c1_chartInstance, void *c1_u)
{
  const mxArray *c1_y = NULL;
  real_T c1_b_u;
  const mxArray *c1_b_y = NULL;
  c1_y = NULL;
  c1_b_u = *((real_T *)c1_u);
  c1_b_y = NULL;
  sf_mex_assign(&c1_b_y, sf_mex_create(&c1_b_u, "y", 0, 0U, 0U, 0));
  sf_mex_assign(&c1_y, c1_b_y);
  return c1_y;
}

static const mxArray *c1_m_sf_marshall(void *c1_chartInstance, void *c1_u)
{
  const mxArray *c1_y = NULL;
  real_T c1_b_u;
  const mxArray *c1_b_y = NULL;
  c1_y = NULL;
  c1_b_u = *((real_T *)c1_u);
  c1_b_y = NULL;
  sf_mex_assign(&c1_b_y, sf_mex_create(&c1_b_u, "y", 0, 0U, 0U, 0));
  sf_mex_assign(&c1_y, c1_b_y);
  return c1_y;
}

static const mxArray *c1_n_sf_marshall(void *c1_chartInstance, void *c1_u)
{
  const mxArray *c1_y = NULL;
  real_T c1_b_u;
  const mxArray *c1_b_y = NULL;
  c1_y = NULL;
  c1_b_u = *((real_T *)c1_u);
  c1_b_y = NULL;
  sf_mex_assign(&c1_b_y, sf_mex_create(&c1_b_u, "y", 0, 0U, 0U, 0));
  sf_mex_assign(&c1_y, c1_b_y);
  return c1_y;
}

static const mxArray *c1_o_sf_marshall(void *c1_chartInstance, void *c1_u)
{
  const mxArray *c1_y = NULL;
  real_T c1_b_u;
  const mxArray *c1_b_y = NULL;
  c1_y = NULL;
  c1_b_u = *((real_T *)c1_u);
  c1_b_y = NULL;
  sf_mex_assign(&c1_b_y, sf_mex_create(&c1_b_u, "y", 0, 0U, 0U, 0));
  sf_mex_assign(&c1_y, c1_b_y);
  return c1_y;
}

const mxArray *sf_c1_supply__get_eml_resolved_functions_info(void)
{
  const mxArray *c1_nameCaptureInfo = NULL;
  c1_ResolvedFunctionInfo c1_info[55];
  const mxArray *c1_m0 = NULL;
  int32_T c1_i43;
  c1_ResolvedFunctionInfo *c1_r0;
  c1_nameCaptureInfo = NULL;
  c1_info_helper(c1_info);
  sf_mex_assign(&c1_m0, sf_mex_createstruct("nameCaptureInfo", 1, 55));
  for(c1_i43 = 0; c1_i43 < 55; c1_i43 = c1_i43 + 1) {
    c1_r0 = &c1_info[c1_i43];
    sf_mex_addfield(c1_m0, sf_mex_create(c1_r0->context, "nameCaptureInfo", 13,
      0U, 0U, 2, 1, strlen(c1_r0->context)), "context",
     "nameCaptureInfo", c1_i43);
    sf_mex_addfield(c1_m0, sf_mex_create(c1_r0->name, "nameCaptureInfo", 13, 0U,
      0U, 2, 1, strlen(c1_r0->name)), "name",
     "nameCaptureInfo", c1_i43);
    sf_mex_addfield(c1_m0, sf_mex_create(c1_r0->dominantType, "nameCaptureInfo",
      13, 0U, 0U, 2, 1, strlen(c1_r0->dominantType)),
     "dominantType", "nameCaptureInfo", c1_i43);
    sf_mex_addfield(c1_m0, sf_mex_create(c1_r0->resolved, "nameCaptureInfo", 13,
      0U, 0U, 2, 1, strlen(c1_r0->resolved)), "resolved",
     "nameCaptureInfo", c1_i43);
    sf_mex_addfield(c1_m0, sf_mex_create(&c1_r0->fileLength, "nameCaptureInfo",
      7, 0U, 0U, 0), "fileLength", "nameCaptureInfo", c1_i43);
    sf_mex_addfield(c1_m0, sf_mex_create(&c1_r0->fileTime1, "nameCaptureInfo",
      7, 0U, 0U, 0), "fileTime1", "nameCaptureInfo", c1_i43);
    sf_mex_addfield(c1_m0, sf_mex_create(&c1_r0->fileTime2, "nameCaptureInfo",
      7, 0U, 0U, 0), "fileTime2", "nameCaptureInfo", c1_i43);
  }
  sf_mex_assign(&c1_nameCaptureInfo, c1_m0);
  return c1_nameCaptureInfo;
}

static void c1_info_helper(c1_ResolvedFunctionInfo c1_info[55])
{
  c1_info[0].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/datatypes/isa.m";
  c1_info[0].name = "strcmp";
  c1_info[0].dominantType = "char";
  c1_info[0].resolved = "[B]strcmp";
  c1_info[0].fileLength = 0U;
  c1_info[0].fileTime1 = 0U;
  c1_info[0].fileTime2 = 0U;
  c1_info[1].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/datatypes/isa.m";
  c1_info[1].name = "eq";
  c1_info[1].dominantType = "double";
  c1_info[1].resolved = "[B]eq";
  c1_info[1].fileLength = 0U;
  c1_info[1].fileTime1 = 0U;
  c1_info[1].fileTime2 = 0U;
  c1_info[2].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_alloc.m";
  c1_info[2].name = "isstruct";
  c1_info[2].dominantType = "double";
  c1_info[2].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/datatypes/isstruct.m";
  c1_info[2].fileLength = 179U;
  c1_info[2].fileTime1 = 1160425024U;
  c1_info[2].fileTime2 = 0U;
  c1_info[3].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_is_float_class.m";
  c1_info[3].name = "ischar";
  c1_info[3].dominantType = "char";
  c1_info[3].resolved = "[I]$matlabroot$/toolbox/eml/lib/matlab/strfun/ischar.m";
  c1_info[3].fileLength = 244U;
  c1_info[3].fileTime1 = 1160425234U;
  c1_info[3].fileTime2 = 0U;
  c1_info[4].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_assert_valid_size_arg.m/check_arg";
  c1_info[4].name = "real";
  c1_info[4].dominantType = "double";
  c1_info[4].resolved = "[B]real";
  c1_info[4].fileLength = 0U;
  c1_info[4].fileTime1 = 0U;
  c1_info[4].fileTime2 = 0U;
  c1_info[5].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_assert_valid_size_arg.m/check_arg";
  c1_info[5].name = "imag";
  c1_info[5].dominantType = "double";
  c1_info[5].resolved = "[B]imag";
  c1_info[5].fileLength = 0U;
  c1_info[5].fileTime1 = 0U;
  c1_info[5].fileTime2 = 0U;
  c1_info[6].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mpower.m";
  c1_info[6].name = "power";
  c1_info[6].dominantType = "double";
  c1_info[6].resolved = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m";
  c1_info[6].fileLength = 4842U;
  c1_info[6].fileTime1 = 1177078146U;
  c1_info[6].fileTime2 = 0U;
  c1_info[7].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_alloc.m";
  c1_info[7].name = "cast";
  c1_info[7].dominantType = "double";
  c1_info[7].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/datatypes/cast.m";
  c1_info[7].fileLength = 907U;
  c1_info[7].fileTime1 = 1160425018U;
  c1_info[7].fileTime2 = 0U;
  c1_info[8].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elmat/false.m";
  c1_info[8].name = "logical";
  c1_info[8].dominantType = "double";
  c1_info[8].resolved = "[B]logical";
  c1_info[8].fileLength = 0U;
  c1_info[8].fileTime1 = 0U;
  c1_info[8].fileTime2 = 0U;
  c1_info[9].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c1_info[9].name = "islogical";
  c1_info[9].dominantType = "double";
  c1_info[9].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/datatypes/islogical.m";
  c1_info[9].fileLength = 186U;
  c1_info[9].fileTime1 = 1160425022U;
  c1_info[9].fileTime2 = 0U;
  c1_info[10].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mpower.m";
  c1_info[10].name = "nargin";
  c1_info[10].dominantType = "";
  c1_info[10].resolved = "[B]nargin";
  c1_info[10].fileLength = 0U;
  c1_info[10].fileTime1 = 0U;
  c1_info[10].fileTime2 = 0U;
  c1_info[11].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_assert_valid_size_arg.m/check_arg";
  c1_info[11].name = "true";
  c1_info[11].dominantType = "";
  c1_info[11].resolved = "[I]$matlabroot$/toolbox/eml/lib/matlab/elmat/true.m";
  c1_info[11].fileLength = 625U;
  c1_info[11].fileTime1 = 1163949186U;
  c1_info[11].fileTime2 = 0U;
  c1_info[12].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mpower.m";
  c1_info[12].name = "isinteger";
  c1_info[12].dominantType = "double";
  c1_info[12].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/datatypes/isinteger.m";
  c1_info[12].fileLength = 254U;
  c1_info[12].fileTime1 = 1160425020U;
  c1_info[12].fileTime2 = 0U;
  c1_info[13].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m";
  c1_info[13].name = "eml_scalexp_size";
  c1_info[13].dominantType = "double";
  c1_info[13].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalexp_size.m";
  c1_info[13].fileLength = 923U;
  c1_info[13].fileTime1 = 1160425156U;
  c1_info[13].fileTime2 = 0U;
  c1_info[14].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/datatypes/isa.m";
  c1_info[14].name = "eml_is_float_class";
  c1_info[14].dominantType = "char";
  c1_info[14].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_is_float_class.m";
  c1_info[14].fileLength = 273U;
  c1_info[14].fileTime1 = 1160425144U;
  c1_info[14].fileTime2 = 0U;
  c1_info[15].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m";
  c1_info[15].name = "floor";
  c1_info[15].dominantType = "double";
  c1_info[15].resolved = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/floor.m";
  c1_info[15].fileLength = 595U;
  c1_info[15].fileTime1 = 1163949136U;
  c1_info[15].fileTime2 = 0U;
  c1_info[16].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalexp_size.m";
  c1_info[16].name = "eml_scalexp_compatible";
  c1_info[16].dominantType = "double";
  c1_info[16].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalexp_compatible.m";
  c1_info[16].fileLength = 422U;
  c1_info[16].fileTime1 = 1160425154U;
  c1_info[16].fileTime2 = 0U;
  c1_info[17].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mpower.m";
  c1_info[17].name = "ndims";
  c1_info[17].dominantType = "double";
  c1_info[17].resolved = "[I]$matlabroot$/toolbox/eml/lib/matlab/elmat/ndims.m";
  c1_info[17].fileLength = 236U;
  c1_info[17].fileTime1 = 1163949176U;
  c1_info[17].fileTime2 = 0U;
  c1_info[18].context = "";
  c1_info[18].name = "mrdivide";
  c1_info[18].dominantType = "double";
  c1_info[18].resolved = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.m";
  c1_info[18].fileLength = 653U;
  c1_info[18].fileTime1 = 1160425202U;
  c1_info[18].fileTime2 = 0U;
  c1_info[19].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_assert_valid_size_arg.m/check_arg";
  c1_info[19].name = "ne";
  c1_info[19].dominantType = "double";
  c1_info[19].resolved = "[B]ne";
  c1_info[19].fileLength = 0U;
  c1_info[19].fileTime1 = 0U;
  c1_info[19].fileTime2 = 0U;
  c1_info[20].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_alloc.m";
  c1_info[20].name = "zeros";
  c1_info[20].dominantType = "double";
  c1_info[20].resolved = "[B]zeros";
  c1_info[20].fileLength = 0U;
  c1_info[20].fileTime1 = 0U;
  c1_info[20].fileTime2 = 0U;
  c1_info[21].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/datatypes/cast.m";
  c1_info[21].name = "ge";
  c1_info[21].dominantType = "double";
  c1_info[21].resolved = "[B]ge";
  c1_info[21].fileLength = 0U;
  c1_info[21].fileTime1 = 0U;
  c1_info[21].fileTime2 = 0U;
  c1_info[22].context = "";
  c1_info[22].name = "mtimes";
  c1_info[22].dominantType = "double";
  c1_info[22].resolved = "[B]mtimes";
  c1_info[22].fileLength = 0U;
  c1_info[22].fileTime1 = 0U;
  c1_info[22].fileTime2 = 0U;
  c1_info[23].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c1_info[23].name = "not";
  c1_info[23].dominantType = "logical";
  c1_info[23].resolved = "[B]not";
  c1_info[23].fileLength = 0U;
  c1_info[23].fileTime1 = 0U;
  c1_info[23].fileTime2 = 0U;
  c1_info[24].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elmat/false.m";
  c1_info[24].name = "lt";
  c1_info[24].dominantType = "double";
  c1_info[24].resolved = "[B]lt";
  c1_info[24].fileLength = 0U;
  c1_info[24].fileTime1 = 0U;
  c1_info[24].fileTime2 = 0U;
  c1_info[25].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c1_info[25].name = "eml_isa_uint";
  c1_info[25].dominantType = "double";
  c1_info[25].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_isa_uint.m";
  c1_info[25].fileLength = 288U;
  c1_info[25].fileTime1 = 1163949198U;
  c1_info[25].fileTime2 = 0U;
  c1_info[26].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mpower.m";
  c1_info[26].name = "isnumeric";
  c1_info[26].dominantType = "double";
  c1_info[26].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/datatypes/isnumeric.m";
  c1_info[26].fileLength = 250U;
  c1_info[26].fileTime1 = 1160425022U;
  c1_info[26].fileTime2 = 0U;
  c1_info[27].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/datatypes/isa.m";
  c1_info[27].name = "class";
  c1_info[27].dominantType = "char";
  c1_info[27].resolved = "[B]class";
  c1_info[27].fileLength = 0U;
  c1_info[27].fileTime1 = 0U;
  c1_info[27].fileTime2 = 0U;
  c1_info[28].context = "";
  c1_info[28].name = "abs";
  c1_info[28].dominantType = "double";
  c1_info[28].resolved = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c1_info[28].fileLength = 1031U;
  c1_info[28].fileTime1 = 1163949102U;
  c1_info[28].fileTime2 = 0U;
  c1_info[29].context = "";
  c1_info[29].name = "cos";
  c1_info[29].dominantType = "double";
  c1_info[29].resolved = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/cos.m";
  c1_info[29].fileLength = 772U;
  c1_info[29].fileTime1 = 1163949124U;
  c1_info[29].fileTime2 = 0U;
  c1_info[30].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/datatypes/cast.m";
  c1_info[30].name = "double";
  c1_info[30].dominantType = "double";
  c1_info[30].resolved = "[B]double";
  c1_info[30].fileLength = 0U;
  c1_info[30].fileTime1 = 0U;
  c1_info[30].fileTime2 = 0U;
  c1_info[31].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/datatypes/isnumeric.m";
  c1_info[31].name = "isa";
  c1_info[31].dominantType = "double";
  c1_info[31].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/datatypes/isa.m";
  c1_info[31].fileLength = 791U;
  c1_info[31].fileTime1 = 1160425018U;
  c1_info[31].fileTime2 = 0U;
  c1_info[32].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/datatypes/isa.m";
  c1_info[32].name = "eml_is_integer_class";
  c1_info[32].dominantType = "char";
  c1_info[32].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_is_integer_class.m";
  c1_info[32].fileLength = 462U;
  c1_info[32].fileTime1 = 1160425144U;
  c1_info[32].fileTime2 = 0U;
  c1_info[33].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_alloc.m";
  c1_info[33].name = "plus";
  c1_info[33].dominantType = "double";
  c1_info[33].resolved = "[B]plus";
  c1_info[33].fileLength = 0U;
  c1_info[33].fileTime1 = 0U;
  c1_info[33].fileTime2 = 0U;
  c1_info[34].context = "";
  c1_info[34].name = "atan";
  c1_info[34].dominantType = "double";
  c1_info[34].resolved = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/atan.m";
  c1_info[34].fileLength = 612U;
  c1_info[34].fileTime1 = 1163949118U;
  c1_info[34].fileTime2 = 0U;
  c1_info[35].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/elmat/isscalar.m";
  c1_info[35].name = "length";
  c1_info[35].dominantType = "double";
  c1_info[35].resolved = "[I]$matlabroot$/toolbox/eml/lib/matlab/elmat/length.m";
  c1_info[35].fileLength = 347U;
  c1_info[35].fileTime1 = 1163949170U;
  c1_info[35].fileTime2 = 0U;
  c1_info[36].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m";
  c1_info[36].name = "eml_error";
  c1_info[36].dominantType = "char";
  c1_info[36].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_error.m";
  c1_info[36].fileLength = 585U;
  c1_info[36].fileTime1 = 1177078120U;
  c1_info[36].fileTime2 = 0U;
  c1_info[37].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_assert_valid_size_arg.m/check_arg";
  c1_info[37].name = "false";
  c1_info[37].dominantType = "";
  c1_info[37].resolved = "[I]$matlabroot$/toolbox/eml/lib/matlab/elmat/false.m";
  c1_info[37].fileLength = 631U;
  c1_info[37].fileTime1 = 1163949166U;
  c1_info[37].fileTime2 = 0U;
  c1_info[38].context = "";
  c1_info[38].name = "sqrt";
  c1_info[38].dominantType = "double";
  c1_info[38].resolved = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/sqrt.m";
  c1_info[38].fileLength = 1276U;
  c1_info[38].fileTime1 = 1177078108U;
  c1_info[38].fileTime2 = 0U;
  c1_info[39].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_assert_valid_size_arg.m/check_arg";
  c1_info[39].name = "isfloat";
  c1_info[39].dominantType = "double";
  c1_info[39].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/datatypes/isfloat.m";
  c1_info[39].fileLength = 182U;
  c1_info[39].fileTime1 = 1160425020U;
  c1_info[39].fileTime2 = 0U;
  c1_info[40].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_alloc.m";
  c1_info[40].name = "eml_assert_valid_size_arg";
  c1_info[40].dominantType = "double";
  c1_info[40].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_assert_valid_size_arg.m";
  c1_info[40].fileLength = 1097U;
  c1_info[40].fileTime1 = 1163949188U;
  c1_info[40].fileTime2 = 0U;
  c1_info[41].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mpower.m";
  c1_info[41].name = "isscalar";
  c1_info[41].dominantType = "double";
  c1_info[41].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/elmat/isscalar.m";
  c1_info[41].fileLength = 243U;
  c1_info[41].fileTime1 = 1160425104U;
  c1_info[41].fileTime2 = 0U;
  c1_info[42].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elmat/length.m";
  c1_info[42].name = "eml_numel";
  c1_info[42].dominantType = "double";
  c1_info[42].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_numel.m";
  c1_info[42].fileLength = 278U;
  c1_info[42].fileTime1 = 1163949202U;
  c1_info[42].fileTime2 = 0U;
  c1_info[43].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elmat/length.m";
  c1_info[43].name = "size";
  c1_info[43].dominantType = "double";
  c1_info[43].resolved = "[B]size";
  c1_info[43].fileLength = 0U;
  c1_info[43].fileTime1 = 0U;
  c1_info[43].fileTime2 = 0U;
  c1_info[44].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/floor.m";
  c1_info[44].name = "isempty";
  c1_info[44].dominantType = "double";
  c1_info[44].resolved = "[B]isempty";
  c1_info[44].fileLength = 0U;
  c1_info[44].fileTime1 = 0U;
  c1_info[44].fileTime2 = 0U;
  c1_info[45].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_alloc.m";
  c1_info[45].name = "isreal";
  c1_info[45].dominantType = "double";
  c1_info[45].resolved = "[B]isreal";
  c1_info[45].fileLength = 0U;
  c1_info[45].fileTime1 = 0U;
  c1_info[45].fileTime2 = 0U;
  c1_info[46].context = "";
  c1_info[46].name = "pi";
  c1_info[46].dominantType = "";
  c1_info[46].resolved = "[B]pi";
  c1_info[46].fileLength = 0U;
  c1_info[46].fileTime1 = 0U;
  c1_info[46].fileTime2 = 0U;
  c1_info[47].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mpower.m";
  c1_info[47].name = "eml_assert";
  c1_info[47].dominantType = "char";
  c1_info[47].resolved = "[B]eml_assert";
  c1_info[47].fileLength = 0U;
  c1_info[47].fileTime1 = 0U;
  c1_info[47].fileTime2 = 0U;
  c1_info[48].context = "";
  c1_info[48].name = "sin";
  c1_info[48].dominantType = "double";
  c1_info[48].resolved = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/sin.m";
  c1_info[48].fileLength = 769U;
  c1_info[48].fileTime1 = 1163949154U;
  c1_info[48].fileTime2 = 0U;
  c1_info[49].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.m";
  c1_info[49].name = "rdivide";
  c1_info[49].dominantType = "double";
  c1_info[49].resolved = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c1_info[49].fileLength = 4533U;
  c1_info[49].fileTime1 = 1177078148U;
  c1_info[49].fileTime2 = 0U;
  c1_info[50].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m";
  c1_info[50].name = "eml_alloc";
  c1_info[50].dominantType = "double";
  c1_info[50].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_alloc.m";
  c1_info[50].fileLength = 2151U;
  c1_info[50].fileTime1 = 1179442870U;
  c1_info[50].fileTime2 = 0U;
  c1_info[51].context = "";
  c1_info[51].name = "mpower";
  c1_info[51].dominantType = "double";
  c1_info[51].resolved = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mpower.m";
  c1_info[51].fileLength = 3116U;
  c1_info[51].fileTime1 = 1177078146U;
  c1_info[51].fileTime2 = 0U;
  c1_info[52].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_numel.m";
  c1_info[52].name = "numel";
  c1_info[52].dominantType = "double";
  c1_info[52].resolved = "[B]numel";
  c1_info[52].fileLength = 0U;
  c1_info[52].fileTime1 = 0U;
  c1_info[52].fileTime2 = 0U;
  c1_info[53].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_assert_valid_size_arg.m/check_arg";
  c1_info[53].name = "isvector";
  c1_info[53].dominantType = "double";
  c1_info[53].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/elmat/isvector.m";
  c1_info[53].fileLength = 284U;
  c1_info[53].fileTime1 = 1160425106U;
  c1_info[53].fileTime2 = 0U;
  c1_info[54].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mpower.m";
  c1_info[54].name = "gt";
  c1_info[54].dominantType = "double";
  c1_info[54].resolved = "[B]gt";
  c1_info[54].fileLength = 0U;
  c1_info[54].fileTime1 = 0U;
  c1_info[54].fileTime2 = 0U;
}

static void init_dsm_address_info(void)
{
}

/* SFunction Glue Code */
void sf_c1_supply__get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(577776620U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(2543949667U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(1871760093U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(360450502U);
}

mxArray *sf_c1_supply__get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] =
  {"checksum","inputs","parameters","outputs"};
  mxArray *mxAutoinheritanceInfo =
  mxCreateStructMatrix(1,1,4,autoinheritanceFields);
  {
    mxArray *mxChecksum = mxCreateDoubleMatrix(4,1,mxREAL);
    double *pr = mxGetPr(mxChecksum);
    pr[0] = (double)(4044945127U);
    pr[1] = (double)(2508193321U);
    pr[2] = (double)(1669537578U);
    pr[3] = (double)(1494837202U);
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }
  {
    const char *dataFields[] = {"size","type","complexity"};
    mxArray *mxData = mxCreateStructMatrix(1,8,3,dataFields);
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }
    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }
    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }
    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,3,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,3,"type",mxType);
    }
    mxSetField(mxData,3,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,4,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,4,"type",mxType);
    }
    mxSetField(mxData,4,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,5,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,5,"type",mxType);
    }
    mxSetField(mxData,5,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,6,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,6,"type",mxType);
    }
    mxSetField(mxData,6,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,7,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,7,"type",mxType);
    }
    mxSetField(mxData,7,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }
  {
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxCreateDoubleMatrix(0,0,mxREAL));
  }
  {
    const char *dataFields[] = {"size","type","complexity"};
    mxArray *mxData = mxCreateStructMatrix(1,1,3,dataFields);
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(2);
      mxSetField(mxData,0,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }
    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }
  return(mxAutoinheritanceInfo);
}

static void chart_debug_initialization(SimStruct *S, unsigned int
 fullDebuggerInitialization)
{
  if(ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
    /* do this only if simulation is starting */
    if(!sim_mode_is_rtw_gen(S)) {
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart(_supply_MachineNumber_,
         1,
         1,
         1,
         9,
         0,
         0,
         0,
         0,
         0,
         &(chartInstance.chartNumber),
         &(chartInstance.instanceNumber),
         ssGetPath(S),
         (void *)S);
        if(chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation(_supply_MachineNumber_,chartInstance.chartNumber);
          sf_debug_set_chart_disable_implicit_casting(_supply_MachineNumber_,chartInstance.chartNumber,1);
          sf_debug_set_chart_event_thresholds(_supply_MachineNumber_,
           chartInstance.chartNumber,
           0,
           0,
           0);

          {
            unsigned int dimVector[1];
            dimVector[0]= 3;
            _SFD_SET_DATA_PROPS(8,1,1,0,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,1.0,0,"a",0,c1_sf_marshall);
          }
          {
            unsigned int dimVector[1];
            dimVector[0]= 3;
            _SFD_SET_DATA_PROPS(5,1,1,0,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,1.0,0,"b",0,c1_b_sf_marshall);
          }
          {
            unsigned int dimVector[1];
            dimVector[0]= 3;
            _SFD_SET_DATA_PROPS(3,1,1,0,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,1.0,0,"c",0,c1_c_sf_marshall);
          }
          _SFD_SET_DATA_PROPS(6,1,1,0,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,"x",0,c1_d_sf_marshall);
          {
            unsigned int dimVector[2];
            dimVector[0]= 3;
            dimVector[1]= 2;
            _SFD_SET_DATA_PROPS(7,2,0,1,SF_DOUBLE,2,&(dimVector[0]),0,0,0,0.0,1.0,0,"Jp",0,c1_i_sf_marshall);
          }
          _SFD_SET_DATA_PROPS(1,1,1,0,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,"y",0,c1_e_sf_marshall);
          _SFD_SET_DATA_PROPS(4,1,1,0,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,"psi",0,c1_f_sf_marshall);
          {
            unsigned int dimVector[1];
            dimVector[0]= 3;
            _SFD_SET_DATA_PROPS(0,1,1,0,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,1.0,0,"l",0,c1_g_sf_marshall);
          }
          {
            unsigned int dimVector[1];
            dimVector[0]= 3;
            _SFD_SET_DATA_PROPS(2,1,1,0,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,1.0,0,"h",0,c1_h_sf_marshall);
          }
          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }
        _SFD_CV_INIT_CHART(0,0,0,0);
        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of EML Model Coverage */
        _SFD_CV_INIT_EML(0,1,7,0,0,0,0,0);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,723);
        _SFD_CV_INIT_EML_IF(0,0,128,136,153,182);
        _SFD_CV_INIT_EML_IF(0,1,416,425,-1,450);
        _SFD_CV_INIT_EML_IF(0,2,451,460,-1,485);
        _SFD_CV_INIT_EML_IF(0,3,486,495,-1,520);
        _SFD_CV_INIT_EML_IF(0,4,573,590,-1,615);
        _SFD_CV_INIT_EML_IF(0,5,616,633,-1,658);
        _SFD_CV_INIT_EML_IF(0,6,659,676,-1,701);
        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if(chartAlreadyPresent==0)
        {
          _SFD_TRANS_COV_MAPS(0,
           0,NULL,NULL,
           0,NULL,NULL,
           1,NULL,NULL,
           0,NULL,NULL);
        }

        {
          real_T (*c1_a)[3];
          real_T (*c1_b)[3];
          real_T (*c1_c)[3];
          real_T *c1_x;
          real_T (*c1_Jp)[6];
          real_T *c1_y;
          real_T *c1_psi;
          real_T (*c1_l)[3];
          real_T (*c1_h)[3];
          c1_psi = (real_T *)ssGetInputPortSignal(chartInstance.S, 5);
          c1_b = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 1);
          c1_Jp = (real_T (*)[6])ssGetOutputPortSignal(chartInstance.S, 1);
          c1_y = (real_T *)ssGetInputPortSignal(chartInstance.S, 4);
          c1_c = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 2);
          c1_x = (real_T *)ssGetInputPortSignal(chartInstance.S, 3);
          c1_l = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 6);
          c1_h = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 7);
          c1_a = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 0);
          _SFD_SET_DATA_VALUE_PTR(8U, c1_a);
          _SFD_SET_DATA_VALUE_PTR(5U, c1_b);
          _SFD_SET_DATA_VALUE_PTR(3U, c1_c);
          _SFD_SET_DATA_VALUE_PTR(6U, c1_x);
          _SFD_SET_DATA_VALUE_PTR(7U, c1_Jp);
          _SFD_SET_DATA_VALUE_PTR(1U, c1_y);
          _SFD_SET_DATA_VALUE_PTR(4U, c1_psi);
          _SFD_SET_DATA_VALUE_PTR(0U, c1_l);
          _SFD_SET_DATA_VALUE_PTR(2U, c1_h);
        }
      }
    }
  } else {
    sf_debug_reset_current_state_configuration(_supply_MachineNumber_,chartInstance.chartNumber,chartInstance.instanceNumber);
  }
}

static void sf_opaque_initialize_c1_supply_(void *chartInstanceVar)
{
  chart_debug_initialization(chartInstance.S,0);
  initialize_params_c1_supply_();
  initialize_c1_supply_();
}

static void sf_opaque_enable_c1_supply_(void *chartInstanceVar)
{
  enable_c1_supply_();
}

static void sf_opaque_disable_c1_supply_(void *chartInstanceVar)
{
  disable_c1_supply_();
}

static void sf_opaque_gateway_c1_supply_(void *chartInstanceVar)
{
  sf_c1_supply_();
}

static void sf_opaque_terminate_c1_supply_(void *chartInstanceVar)
{
  if (sim_mode_is_rtw_gen(chartInstance.S) ||
   sim_mode_is_external(chartInstance.S)) {
    sf_clear_rtw_identifier(chartInstance.S);
  }
  finalize_c1_supply_();
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c1_supply_(SimStruct *S)
{
  int i;
  for(i=0;i<ssGetNumRunTimeParams(S);i++) {
    if(ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }
  if(sf_machine_global_initializer_called()) {
    initialize_params_c1_supply_();
  }
}

static void mdlSetWorkWidths_c1_supply_(SimStruct *S)
{
  if(sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable("supply_",1);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop("supply_",1,"gatewayCannotBeInlinedMultipleTimes"));
    if(chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 1, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 2, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 3, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 4, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 5, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 6, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 7, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,"supply_",1,8);
      sf_mark_chart_reusable_outputs(S,"supply_",1,1);
    }
    sf_set_rtw_dwork_info(S,"supply_",1);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
    ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  }

  ssSetChecksum0(S,(4178980289U));
  ssSetChecksum1(S,(648343974U));
  ssSetChecksum2(S,(1072002059U));
  ssSetChecksum3(S,(1008811573U));

  ssSetmdlDerivatives(S, NULL);

  ssSetExplicitFCSSCtrl(S,1);
}

static void mdlRTW_c1_supply_(SimStruct *S)
{
  if(sim_mode_is_rtw_gen(S)) {
    sf_write_symbol_mapping(S, "supply_", 1);
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c1_supply_(SimStruct *S)
{
  chartInstance.chartInfo.chartInstance = NULL;
  chartInstance.chartInfo.isEMLChart = 1;
  chartInstance.chartInfo.chartInitialized = 0;
  chartInstance.chartInfo.sFunctionGateway = sf_opaque_gateway_c1_supply_;
  chartInstance.chartInfo.initializeChart = sf_opaque_initialize_c1_supply_;
  chartInstance.chartInfo.terminateChart = sf_opaque_terminate_c1_supply_;
  chartInstance.chartInfo.enableChart = sf_opaque_enable_c1_supply_;
  chartInstance.chartInfo.disableChart = sf_opaque_disable_c1_supply_;
  chartInstance.chartInfo.zeroCrossings = NULL;
  chartInstance.chartInfo.outputs = NULL;
  chartInstance.chartInfo.derivatives = NULL;
  chartInstance.chartInfo.mdlRTW = mdlRTW_c1_supply_;
  chartInstance.chartInfo.mdlStart = mdlStart_c1_supply_;
  chartInstance.chartInfo.mdlSetWorkWidths = mdlSetWorkWidths_c1_supply_;
  chartInstance.chartInfo.extModeExec = NULL;
  chartInstance.chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance.chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance.chartInfo.storeCurrentConfiguration = NULL;
  chartInstance.S = S;
  ssSetUserData(S,(void *)(&(chartInstance.chartInfo))); /* register the chart instance with simstruct */

  if(!sim_mode_is_rtw_gen(S)) {
    init_dsm_address_info();
  }
  chart_debug_initialization(S,1);
}

void c1_supply__method_dispatcher(SimStruct *S, int_T method, void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c1_supply_(S);
    break;
   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c1_supply_(S);
    break;
   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c1_supply_(S);
    break;
   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
     "Error calling c1_supply__method_dispatcher.\n"
     "Can't handle method %d.\n", method);
    break;
  }
}

