/* Include files */
#include "supply__sfun.h"
#include "c3_supply_.h"
#define CHARTINSTANCE_CHARTNUMBER       (chartInstance.chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER    (chartInstance.instanceNumber)
#include "supply__sfun_debug_macros.h"

/* Type Definitions */

/* Named Constants */
#define c3_IN_NO_ACTIVE_CHILD           (0)

/* Variable Declarations */

/* Variable Definitions */
static SFc3_supply_InstanceStruct chartInstance;

/* Function Declarations */
static void initialize_c3_supply_(void);
static void initialize_params_c3_supply_(void);
static void enable_c3_supply_(void);
static void disable_c3_supply_(void);
static void finalize_c3_supply_(void);
static void sf_c3_supply_(void);
static void init_script_number_translation(uint32_T c3_machineNumber, uint32_T
 c3_chartNumber);
static real_T c3_mpower(real_T c3_a);
static const mxArray *c3_sf_marshall(void *c3_chartInstance, void *c3_u);
static const mxArray *c3_b_sf_marshall(void *c3_chartInstance, void *c3_u);
static const mxArray *c3_c_sf_marshall(void *c3_chartInstance, void *c3_u);
static const mxArray *c3_d_sf_marshall(void *c3_chartInstance, void *c3_u);
static const mxArray *c3_e_sf_marshall(void *c3_chartInstance, void *c3_u);
static const mxArray *c3_f_sf_marshall(void *c3_chartInstance, void *c3_u);
static const mxArray *c3_g_sf_marshall(void *c3_chartInstance, void *c3_u);
static const mxArray *c3_h_sf_marshall(void *c3_chartInstance, void *c3_u);
static const mxArray *c3_i_sf_marshall(void *c3_chartInstance, void *c3_u);
static const mxArray *c3_j_sf_marshall(void *c3_chartInstance, void *c3_u);
static const mxArray *c3_k_sf_marshall(void *c3_chartInstance, void *c3_u);
static const mxArray *c3_l_sf_marshall(void *c3_chartInstance, void *c3_u);
static const mxArray *c3_m_sf_marshall(void *c3_chartInstance, void *c3_u);
static const mxArray *c3_n_sf_marshall(void *c3_chartInstance, void *c3_u);
static const mxArray *c3_o_sf_marshall(void *c3_chartInstance, void *c3_u);
static const mxArray *c3_p_sf_marshall(void *c3_chartInstance, void *c3_u);
static const mxArray *c3_q_sf_marshall(void *c3_chartInstance, void *c3_u);
static const mxArray *c3_r_sf_marshall(void *c3_chartInstance, void *c3_u);
static const mxArray *c3_s_sf_marshall(void *c3_chartInstance, void *c3_u);
static const mxArray *c3_t_sf_marshall(void *c3_chartInstance, void *c3_u);
static const mxArray *c3_u_sf_marshall(void *c3_chartInstance, void *c3_u);
static const mxArray *c3_v_sf_marshall(void *c3_chartInstance, void *c3_u);
static const mxArray *c3_w_sf_marshall(void *c3_chartInstance, void *c3_u);
static const mxArray *c3_x_sf_marshall(void *c3_chartInstance, void *c3_u);
static const mxArray *c3_y_sf_marshall(void *c3_chartInstance, void *c3_u);
static const mxArray *c3_ab_sf_marshall(void *c3_chartInstance, void *c3_u);
static const mxArray *c3_bb_sf_marshall(void *c3_chartInstance, void *c3_u);
static const mxArray *c3_cb_sf_marshall(void *c3_chartInstance, void *c3_u);
static const mxArray *c3_db_sf_marshall(void *c3_chartInstance, void *c3_u);
static const mxArray *c3_eb_sf_marshall(void *c3_chartInstance, void *c3_u);
static void c3_info_helper(c3_ResolvedFunctionInfo c3_info[57]);
static void init_dsm_address_info(void);

/* Function Definitions */
static void initialize_c3_supply_(void)
{
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
  chartInstance.c3_is_active_c3_supply_ = 0U;
}

static void initialize_params_c3_supply_(void)
{
}

static void enable_c3_supply_(void)
{
}

static void disable_c3_supply_(void)
{
}

static void finalize_c3_supply_(void)
{
}

static void sf_c3_supply_(void)
{
  int32_T c3_i0;
  int32_T c3_i1;
  int32_T c3_i2;
  int32_T c3_i3;
  uint8_T c3_previousEvent;
  int32_T c3_i4;
  real_T c3_a[3];
  int32_T c3_i5;
  real_T c3_b[3];
  int32_T c3_i6;
  real_T c3_c[3];
  real_T c3_x;
  real_T c3_y;
  real_T c3_psi;
  real_T c3_omega_o_su;
  real_T c3_omega_o_sw;
  real_T c3_omega_o_ya;
  real_T c3_r_1;
  real_T c3_psi_1;
  real_T c3_omega_ya;
  real_T c3_omega_sw;
  real_T c3_omega_su;
  real_T c3_e_sign_h;
  real_T c3_e_sign_r;
  real_T c3_de_h;
  real_T c3_de_r;
  real_T c3_r_3;
  real_T c3_r_2;
  real_T c3_phi;
  real_T c3_h_1;
  real_T c3_abs_psi;
  real_T c3_s;
  real_T c3_omega_p_ya;
  real_T c3_omega_p_sw;
  real_T c3_omega_p_su;
  real_T c3_sigma;
  real_T c3_r;
  real_T c3_Jp[5];
  real_T c3_b_x;
  int32_T c3_i7;
  static char c3_cv0[31] = { 'E', 'm', 'b', 'e', 'd', 'd', 'e', 'd', 'M', 'A',
    'T', 'L', 'A', 'B', ':', 's', 'q', 'r', 't', ':', 'd',
    'o', 'm', 'a', 'i', 'n', 'E', 'r', 'r', 'o', 'r' };
  char c3_x1[31];
  int32_T c3_i8;
  static char c3_cv1[77] = { 'D', 'o', 'm', 'a', 'i', 'n', ' ', 'e', 'r', 'r',
    'o', 'r', '.', ' ', 'T', 'o', ' ', 'c', 'o', 'm', 'p',
    'u', 't', 'e', ' ', 'c', 'o', 'm', 'p', 'l', 'e', 'x', ' ', 'r', 'e', 's',
    'u', 'l', 't', 's', ' ', 'f',
    'r', 'o', 'm', ' ', 'r', 'e', 'a', 'l', ' ', 'x', ',', ' ', 'u', 's', 'e',
    ' ', '\'', 's', 'q', 'r', 't'
    , '(', 'c', 'o', 'm', 'p', 'l', 'e', 'x', '(', 'x', ')', ')', '\'', '.' };
  char c3_x2[77];
  int32_T c3_i9;
  char c3_u[31];
  const mxArray *c3_b_y = NULL;
  int32_T c3_i10;
  char c3_b_u[77];
  const mxArray *c3_c_y = NULL;
  real_T c3_c_x;
  real_T c3_d_y;
  real_T c3_A;
  real_T c3_B;
  real_T c3_d_x;
  real_T c3_e_y;
  real_T c3_b_A;
  real_T c3_b_B;
  real_T c3_e_x;
  real_T c3_f_y;
  real_T c3_c_A;
  real_T c3_c_B;
  real_T c3_f_x;
  real_T c3_g_y;
  real_T c3_g_x;
  real_T c3_d_A;
  real_T c3_h_x;
  real_T c3_i_x;
  real_T c3_j_x;
  real_T c3_k_x;
  real_T c3_l_x;
  real_T c3_d_B;
  int32_T c3_i11;
  char c3_b_x1[31];
  int32_T c3_i12;
  char c3_b_x2[77];
  int32_T c3_i13;
  char c3_c_u[31];
  const mxArray *c3_h_y = NULL;
  int32_T c3_i14;
  char c3_d_u[77];
  const mxArray *c3_i_y = NULL;
  real_T c3_m_x;
  real_T c3_j_y;
  real_T c3_e_A;
  real_T c3_n_x;
  real_T c3_o_x;
  real_T c3_p_x;
  real_T c3_q_x;
  real_T c3_r_x;
  real_T c3_e_B;
  int32_T c3_i15;
  char c3_c_x1[31];
  int32_T c3_i16;
  char c3_c_x2[77];
  int32_T c3_i17;
  char c3_e_u[31];
  const mxArray *c3_k_y = NULL;
  int32_T c3_i18;
  char c3_f_u[77];
  const mxArray *c3_l_y = NULL;
  real_T c3_s_x;
  real_T c3_m_y;
  real_T c3_f_A;
  real_T c3_t_x;
  real_T c3_f_B;
  int32_T c3_i19;
  char c3_d_x1[31];
  int32_T c3_i20;
  char c3_d_x2[77];
  int32_T c3_i21;
  char c3_g_u[31];
  const mxArray *c3_n_y = NULL;
  int32_T c3_i22;
  char c3_h_u[77];
  const mxArray *c3_o_y = NULL;
  real_T c3_u_x;
  real_T c3_p_y;
  real_T c3_q_y;
  real_T c3_g_A;
  real_T c3_v_x;
  real_T c3_g_B;
  int32_T c3_i23;
  char c3_e_x1[31];
  int32_T c3_i24;
  char c3_e_x2[77];
  int32_T c3_i25;
  char c3_i_u[31];
  const mxArray *c3_r_y = NULL;
  int32_T c3_i26;
  char c3_j_u[77];
  const mxArray *c3_s_y = NULL;
  real_T c3_w_x;
  real_T c3_t_y;
  real_T c3_u_y;
  real_T c3_h_A;
  real_T c3_x_x;
  real_T c3_h_B;
  int32_T c3_i27;
  char c3_f_x1[31];
  int32_T c3_i28;
  char c3_f_x2[77];
  int32_T c3_i29;
  char c3_k_u[31];
  const mxArray *c3_v_y = NULL;
  int32_T c3_i30;
  char c3_l_u[77];
  const mxArray *c3_w_y = NULL;
  real_T c3_y_x;
  real_T c3_x_y;
  real_T c3_y_y;
  real_T c3_i_A;
  real_T c3_i_B;
  real_T c3_ab_x;
  real_T c3_ab_y;
  real_T c3_bb_y;
  real_T c3_j_A;
  real_T c3_bb_x;
  real_T c3_j_B;
  int32_T c3_i31;
  char c3_g_x1[31];
  int32_T c3_i32;
  char c3_g_x2[77];
  int32_T c3_i33;
  char c3_m_u[31];
  const mxArray *c3_cb_y = NULL;
  int32_T c3_i34;
  char c3_n_u[77];
  const mxArray *c3_db_y = NULL;
  real_T c3_cb_x;
  real_T c3_eb_y;
  real_T c3_fb_y;
  real_T c3_k_A;
  real_T c3_k_B;
  real_T c3_db_x;
  real_T c3_gb_y;
  real_T c3_hb_y;
  real_T c3_l_A;
  real_T c3_eb_x;
  real_T c3_l_B;
  int32_T c3_i35;
  char c3_h_x1[31];
  int32_T c3_i36;
  char c3_h_x2[77];
  int32_T c3_i37;
  char c3_o_u[31];
  const mxArray *c3_ib_y = NULL;
  int32_T c3_i38;
  char c3_p_u[77];
  const mxArray *c3_jb_y = NULL;
  real_T c3_fb_x;
  real_T c3_kb_y;
  real_T c3_lb_y;
  real_T c3_m_A;
  real_T c3_m_B;
  real_T c3_gb_x;
  real_T c3_mb_y;
  real_T c3_nb_y;
  int32_T c3_i39;
  real_T *c3_hb_x;
  real_T *c3_ob_y;
  real_T *c3_b_psi;
  real_T *c3_b_omega_o_su;
  real_T *c3_b_omega_o_sw;
  real_T *c3_b_omega_o_ya;
  real_T *c3_b_r_1;
  real_T *c3_b_psi_1;
  real_T (*c3_b_Jp)[5];
  real_T (*c3_b_a)[3];
  real_T (*c3_b_b)[3];
  real_T (*c3_b_c)[3];
  c3_b_omega_o_su = (real_T *)ssGetInputPortSignal(chartInstance.S, 6);
  c3_b_a = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 0);
  c3_b_Jp = (real_T (*)[5])ssGetOutputPortSignal(chartInstance.S, 1);
  c3_ob_y = (real_T *)ssGetInputPortSignal(chartInstance.S, 4);
  c3_b_r_1 = (real_T *)ssGetInputPortSignal(chartInstance.S, 9);
  c3_hb_x = (real_T *)ssGetInputPortSignal(chartInstance.S, 3);
  c3_b_omega_o_ya = (real_T *)ssGetInputPortSignal(chartInstance.S, 8);
  c3_b_psi_1 = (real_T *)ssGetInputPortSignal(chartInstance.S, 10);
  c3_b_omega_o_sw = (real_T *)ssGetInputPortSignal(chartInstance.S, 7);
  c3_b_c = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 2);
  c3_b_b = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 1);
  c3_b_psi = (real_T *)ssGetInputPortSignal(chartInstance.S, 5);
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
  for(c3_i0 = 0; c3_i0 < 3; c3_i0 = c3_i0 + 1) {
    _SFD_DATA_RANGE_CHECK((*c3_b_a)[c3_i0], 10U);
  }
  for(c3_i1 = 0; c3_i1 < 3; c3_i1 = c3_i1 + 1) {
    _SFD_DATA_RANGE_CHECK((*c3_b_b)[c3_i1], 8U);
  }
  for(c3_i2 = 0; c3_i2 < 3; c3_i2 = c3_i2 + 1) {
    _SFD_DATA_RANGE_CHECK((*c3_b_c)[c3_i2], 5U);
  }
  _SFD_DATA_RANGE_CHECK(*c3_hb_x, 9U);
  for(c3_i3 = 0; c3_i3 < 5; c3_i3 = c3_i3 + 1) {
    _SFD_DATA_RANGE_CHECK((*c3_b_Jp)[c3_i3], 3U);
  }
  _SFD_DATA_RANGE_CHECK(*c3_ob_y, 0U);
  _SFD_DATA_RANGE_CHECK(*c3_b_psi, 7U);
  _SFD_DATA_RANGE_CHECK(*c3_b_omega_o_su, 6U);
  _SFD_DATA_RANGE_CHECK(*c3_b_omega_o_sw, 4U);
  _SFD_DATA_RANGE_CHECK(*c3_b_omega_o_ya, 11U);
  _SFD_DATA_RANGE_CHECK(*c3_b_r_1, 1U);
  _SFD_DATA_RANGE_CHECK(*c3_b_psi_1, 2U);
  c3_previousEvent = _sfEvent_;
  _sfEvent_ = CALL_EVENT;
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG,1);
  for(c3_i4 = 0; c3_i4 < 3; c3_i4 = c3_i4 + 1) {
    c3_a[c3_i4] = (*c3_b_a)[c3_i4];
  }
  for(c3_i5 = 0; c3_i5 < 3; c3_i5 = c3_i5 + 1) {
    c3_b[c3_i5] = (*c3_b_b)[c3_i5];
  }
  for(c3_i6 = 0; c3_i6 < 3; c3_i6 = c3_i6 + 1) {
    c3_c[c3_i6] = (*c3_b_c)[c3_i6];
  }
  c3_x = *c3_hb_x;
  c3_y = *c3_ob_y;
  c3_psi = *c3_b_psi;
  c3_omega_o_su = *c3_b_omega_o_su;
  c3_omega_o_sw = *c3_b_omega_o_sw;
  c3_omega_o_ya = *c3_b_omega_o_ya;
  c3_r_1 = *c3_b_r_1;
  c3_psi_1 = *c3_b_psi_1;
  sf_debug_symbol_scope_push(30U, 0U);
  sf_debug_symbol_scope_add("omega_ya", &c3_omega_ya, c3_eb_sf_marshall);
  sf_debug_symbol_scope_add("omega_sw", &c3_omega_sw, c3_db_sf_marshall);
  sf_debug_symbol_scope_add("omega_su", &c3_omega_su, c3_cb_sf_marshall);
  sf_debug_symbol_scope_add("e_sign_h", &c3_e_sign_h, c3_bb_sf_marshall);
  sf_debug_symbol_scope_add("e_sign_r", &c3_e_sign_r, c3_ab_sf_marshall);
  sf_debug_symbol_scope_add("de_h", &c3_de_h, c3_y_sf_marshall);
  sf_debug_symbol_scope_add("de_r", &c3_de_r, c3_x_sf_marshall);
  sf_debug_symbol_scope_add("r_3", &c3_r_3, c3_w_sf_marshall);
  sf_debug_symbol_scope_add("r_2", &c3_r_2, c3_v_sf_marshall);
  sf_debug_symbol_scope_add("phi", &c3_phi, c3_u_sf_marshall);
  sf_debug_symbol_scope_add("h_1", &c3_h_1, c3_t_sf_marshall);
  sf_debug_symbol_scope_add("abs_psi", &c3_abs_psi, c3_s_sf_marshall);
  sf_debug_symbol_scope_add("s", &c3_s, c3_r_sf_marshall);
  sf_debug_symbol_scope_add("omega_p_ya", &c3_omega_p_ya, c3_q_sf_marshall);
  sf_debug_symbol_scope_add("omega_p_sw", &c3_omega_p_sw, c3_p_sf_marshall);
  sf_debug_symbol_scope_add("omega_p_su", &c3_omega_p_su, c3_o_sf_marshall);
  sf_debug_symbol_scope_add("sigma", &c3_sigma, c3_n_sf_marshall);
  sf_debug_symbol_scope_add("r", &c3_r, c3_m_sf_marshall);
  sf_debug_symbol_scope_add("Jp", &c3_Jp, c3_l_sf_marshall);
  sf_debug_symbol_scope_add("psi_1", &c3_psi_1, c3_k_sf_marshall);
  sf_debug_symbol_scope_add("r_1", &c3_r_1, c3_j_sf_marshall);
  sf_debug_symbol_scope_add("omega_o_ya", &c3_omega_o_ya, c3_i_sf_marshall);
  sf_debug_symbol_scope_add("omega_o_sw", &c3_omega_o_sw, c3_h_sf_marshall);
  sf_debug_symbol_scope_add("omega_o_su", &c3_omega_o_su, c3_g_sf_marshall);
  sf_debug_symbol_scope_add("psi", &c3_psi, c3_f_sf_marshall);
  sf_debug_symbol_scope_add("y", &c3_y, c3_e_sf_marshall);
  sf_debug_symbol_scope_add("x", &c3_x, c3_d_sf_marshall);
  sf_debug_symbol_scope_add("c", &c3_c, c3_c_sf_marshall);
  sf_debug_symbol_scope_add("b", &c3_b, c3_b_sf_marshall);
  sf_debug_symbol_scope_add("a", &c3_a, c3_sf_marshall);
  CV_EML_FCN(0, 0);
  /*  Radius to position from setpoint */
  _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,3);
  c3_b_x = c3_mpower(c3_x) + c3_mpower(c3_y);
  c3_r = c3_b_x;
  if(c3_r < 0.0) {
    for(c3_i7 = 0; c3_i7 < 31; c3_i7 = c3_i7 + 1) {
      c3_x1[c3_i7] = c3_cv0[c3_i7];
    }
    for(c3_i8 = 0; c3_i8 < 77; c3_i8 = c3_i8 + 1) {
      c3_x2[c3_i8] = c3_cv1[c3_i8];
    }
    for(c3_i9 = 0; c3_i9 < 31; c3_i9 = c3_i9 + 1) {
      c3_u[c3_i9] = c3_x1[c3_i9];
    }
    c3_b_y = NULL;
    sf_mex_assign(&c3_b_y, sf_mex_create(&c3_u, "y", 8, 0U, 1U, 2, 1, 31));
    for(c3_i10 = 0; c3_i10 < 77; c3_i10 = c3_i10 + 1) {
      c3_b_u[c3_i10] = c3_x2[c3_i10];
    }
    c3_c_y = NULL;
    sf_mex_assign(&c3_c_y, sf_mex_create(&c3_b_u, "y", 8, 0U, 1U, 2, 1, 77));
    sf_mex_call("error", 0U, 2U, 14, c3_b_y, 14, c3_c_y);
  }
  c3_r = sqrt(c3_r);
  /*  radius deviation */
  _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,4);
  c3_sigma = 0.1;
  _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,5);
  c3_omega_p_su = 0.08;
  _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,6);
  c3_omega_p_sw = 0.15;
  _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,7);
  c3_omega_p_ya = 0.15;
  _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,8);
  c3_s = 0.75;
  _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,9);
  c3_c_x = c3_psi;
  c3_d_y = fabs(c3_c_x);
  c3_A = c3_d_y * 180.0;
  c3_B = 3.1415926535897931E+000;
  c3_d_x = c3_A;
  c3_e_y = c3_B;
  c3_abs_psi = c3_d_x / c3_e_y;
  _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,10);
  c3_h_1 = c3_psi_1;
  _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,13);
  if(CV_EML_IF(0, 0, c3_y == 0.0)) {
    /*  Angle to position from setpoint */
    _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,14);
    c3_b_A = 3.1415926535897931E+000;
    c3_b_B = 2.0;
    c3_e_x = c3_b_A;
    c3_f_y = c3_b_B;
    c3_phi = c3_e_x / c3_f_y;
  } else {
    _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,16);
    c3_c_A = c3_x;
    c3_c_B = c3_y;
    c3_f_x = c3_c_A;
    c3_g_y = c3_c_B;
    c3_g_x = c3_f_x / c3_g_y;
    c3_phi = c3_g_x;
    c3_phi = atan(c3_phi);
  }
  /*  Radius levels */
  /* r1 = (a(1)*b(1))/sqrt(b(1)^2*cos(phi)^2 + a(1)^2*sin(phi)^2); */
  _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,20);
  c3_d_A = c3_a[1] * c3_b[1];
  c3_h_x = c3_phi;
  c3_i_x = c3_h_x;
  c3_i_x = sin(c3_i_x);
  c3_j_x = c3_phi;
  c3_k_x = c3_j_x;
  c3_k_x = cos(c3_k_x);
  c3_l_x = c3_mpower(c3_b[1]) * c3_mpower(c3_k_x) + c3_mpower(c3_a[1]) *
    c3_mpower(c3_i_x);
  c3_d_B = c3_l_x;
  if(c3_d_B < 0.0) {
    for(c3_i11 = 0; c3_i11 < 31; c3_i11 = c3_i11 + 1) {
      c3_b_x1[c3_i11] = c3_cv0[c3_i11];
    }
    for(c3_i12 = 0; c3_i12 < 77; c3_i12 = c3_i12 + 1) {
      c3_b_x2[c3_i12] = c3_cv1[c3_i12];
    }
    for(c3_i13 = 0; c3_i13 < 31; c3_i13 = c3_i13 + 1) {
      c3_c_u[c3_i13] = c3_b_x1[c3_i13];
    }
    c3_h_y = NULL;
    sf_mex_assign(&c3_h_y, sf_mex_create(&c3_c_u, "y", 8, 0U, 1U, 2, 1, 31));
    for(c3_i14 = 0; c3_i14 < 77; c3_i14 = c3_i14 + 1) {
      c3_d_u[c3_i14] = c3_b_x2[c3_i14];
    }
    c3_i_y = NULL;
    sf_mex_assign(&c3_i_y, sf_mex_create(&c3_d_u, "y", 8, 0U, 1U, 2, 1, 77));
    sf_mex_call("error", 0U, 2U, 14, c3_h_y, 14, c3_i_y);
  }
  c3_d_B = sqrt(c3_d_B);
  c3_m_x = c3_d_A;
  c3_j_y = c3_d_B;
  c3_r_2 = c3_m_x / c3_j_y;
  _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,21);
  c3_e_A = c3_a[2] * c3_b[2];
  c3_n_x = c3_phi;
  c3_o_x = c3_n_x;
  c3_o_x = sin(c3_o_x);
  c3_p_x = c3_phi;
  c3_q_x = c3_p_x;
  c3_q_x = cos(c3_q_x);
  c3_r_x = c3_mpower(c3_b[2]) * c3_mpower(c3_q_x) + c3_mpower(c3_a[2]) *
    c3_mpower(c3_o_x);
  c3_e_B = c3_r_x;
  if(c3_e_B < 0.0) {
    for(c3_i15 = 0; c3_i15 < 31; c3_i15 = c3_i15 + 1) {
      c3_c_x1[c3_i15] = c3_cv0[c3_i15];
    }
    for(c3_i16 = 0; c3_i16 < 77; c3_i16 = c3_i16 + 1) {
      c3_c_x2[c3_i16] = c3_cv1[c3_i16];
    }
    for(c3_i17 = 0; c3_i17 < 31; c3_i17 = c3_i17 + 1) {
      c3_e_u[c3_i17] = c3_c_x1[c3_i17];
    }
    c3_k_y = NULL;
    sf_mex_assign(&c3_k_y, sf_mex_create(&c3_e_u, "y", 8, 0U, 1U, 2, 1, 31));
    for(c3_i18 = 0; c3_i18 < 77; c3_i18 = c3_i18 + 1) {
      c3_f_u[c3_i18] = c3_c_x2[c3_i18];
    }
    c3_l_y = NULL;
    sf_mex_assign(&c3_l_y, sf_mex_create(&c3_f_u, "y", 8, 0U, 1U, 2, 1, 77));
    sf_mex_call("error", 0U, 2U, 14, c3_k_y, 14, c3_l_y);
  }
  c3_e_B = sqrt(c3_e_B);
  c3_s_x = c3_e_A;
  c3_m_y = c3_e_B;
  c3_r_3 = c3_s_x / c3_m_y;
  /*  derivated error to make sign function */
  _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,24);
  c3_de_r = -(c3_r - c3_r_1);
  _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,25);
  c3_de_h = -(c3_abs_psi - c3_h_1);
  _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,27);
  c3_f_A = c3_de_r;
  c3_t_x = c3_mpower(c3_de_r) + c3_mpower(0.1);
  c3_f_B = c3_t_x;
  if(c3_f_B < 0.0) {
    for(c3_i19 = 0; c3_i19 < 31; c3_i19 = c3_i19 + 1) {
      c3_d_x1[c3_i19] = c3_cv0[c3_i19];
    }
    for(c3_i20 = 0; c3_i20 < 77; c3_i20 = c3_i20 + 1) {
      c3_d_x2[c3_i20] = c3_cv1[c3_i20];
    }
    for(c3_i21 = 0; c3_i21 < 31; c3_i21 = c3_i21 + 1) {
      c3_g_u[c3_i21] = c3_d_x1[c3_i21];
    }
    c3_n_y = NULL;
    sf_mex_assign(&c3_n_y, sf_mex_create(&c3_g_u, "y", 8, 0U, 1U, 2, 1, 31));
    for(c3_i22 = 0; c3_i22 < 77; c3_i22 = c3_i22 + 1) {
      c3_h_u[c3_i22] = c3_d_x2[c3_i22];
    }
    c3_o_y = NULL;
    sf_mex_assign(&c3_o_y, sf_mex_create(&c3_h_u, "y", 8, 0U, 1U, 2, 1, 77));
    sf_mex_call("error", 0U, 2U, 14, c3_n_y, 14, c3_o_y);
  }
  c3_f_B = sqrt(c3_f_B);
  c3_u_x = c3_f_A;
  c3_p_y = c3_f_B;
  c3_q_y = c3_u_x / c3_p_y;
  c3_e_sign_r = 0.5 - c3_sigma * c3_q_y;
  _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,28);
  c3_g_A = c3_de_h;
  c3_v_x = c3_mpower(c3_de_h) + c3_mpower(0.1);
  c3_g_B = c3_v_x;
  if(c3_g_B < 0.0) {
    for(c3_i23 = 0; c3_i23 < 31; c3_i23 = c3_i23 + 1) {
      c3_e_x1[c3_i23] = c3_cv0[c3_i23];
    }
    for(c3_i24 = 0; c3_i24 < 77; c3_i24 = c3_i24 + 1) {
      c3_e_x2[c3_i24] = c3_cv1[c3_i24];
    }
    for(c3_i25 = 0; c3_i25 < 31; c3_i25 = c3_i25 + 1) {
      c3_i_u[c3_i25] = c3_e_x1[c3_i25];
    }
    c3_r_y = NULL;
    sf_mex_assign(&c3_r_y, sf_mex_create(&c3_i_u, "y", 8, 0U, 1U, 2, 1, 31));
    for(c3_i26 = 0; c3_i26 < 77; c3_i26 = c3_i26 + 1) {
      c3_j_u[c3_i26] = c3_e_x2[c3_i26];
    }
    c3_s_y = NULL;
    sf_mex_assign(&c3_s_y, sf_mex_create(&c3_j_u, "y", 8, 0U, 1U, 2, 1, 77));
    sf_mex_call("error", 0U, 2U, 14, c3_r_y, 14, c3_s_y);
  }
  c3_g_B = sqrt(c3_g_B);
  c3_w_x = c3_g_A;
  c3_t_y = c3_g_B;
  c3_u_y = c3_w_x / c3_t_y;
  c3_e_sign_h = 0.5 - c3_sigma * c3_u_y;
  _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,30);
  c3_h_A = c3_r - c3_e_sign_r * (c3_r_3 + c3_r_2);
  c3_x_x = c3_mpower(c3_e_sign_r * (c3_r_3 + c3_r_2) - c3_r) + c3_mpower(c3_s *
    c3_e_sign_r * (c3_r_3 - c3_r_2));
  c3_h_B = c3_x_x;
  if(c3_h_B < 0.0) {
    for(c3_i27 = 0; c3_i27 < 31; c3_i27 = c3_i27 + 1) {
      c3_f_x1[c3_i27] = c3_cv0[c3_i27];
    }
    for(c3_i28 = 0; c3_i28 < 77; c3_i28 = c3_i28 + 1) {
      c3_f_x2[c3_i28] = c3_cv1[c3_i28];
    }
    for(c3_i29 = 0; c3_i29 < 31; c3_i29 = c3_i29 + 1) {
      c3_k_u[c3_i29] = c3_f_x1[c3_i29];
    }
    c3_v_y = NULL;
    sf_mex_assign(&c3_v_y, sf_mex_create(&c3_k_u, "y", 8, 0U, 1U, 2, 1, 31));
    for(c3_i30 = 0; c3_i30 < 77; c3_i30 = c3_i30 + 1) {
      c3_l_u[c3_i30] = c3_f_x2[c3_i30];
    }
    c3_w_y = NULL;
    sf_mex_assign(&c3_w_y, sf_mex_create(&c3_l_u, "y", 8, 0U, 1U, 2, 1, 77));
    sf_mex_call("error", 0U, 2U, 14, c3_v_y, 14, c3_w_y);
  }
  c3_h_B = sqrt(c3_h_B);
  c3_y_x = c3_h_A;
  c3_x_y = c3_h_B;
  c3_y_y = c3_y_x / c3_x_y;
  c3_i_A = c3_omega_p_su - c3_omega_o_su;
  c3_i_B = 2.0;
  c3_ab_x = c3_i_A;
  c3_ab_y = c3_i_B;
  c3_bb_y = c3_ab_x / c3_ab_y;
  c3_omega_su = c3_bb_y * (c3_y_y + 1.0);
  /* + omega_m; */
  _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,34);
  c3_j_A = c3_r - c3_e_sign_r * (c3_r_3 + c3_r_2);
  c3_bb_x = c3_mpower(c3_e_sign_r * (c3_r_3 + c3_r_2) - c3_r) + c3_mpower(c3_s *
    c3_e_sign_r * (c3_r_3 - c3_r_2));
  c3_j_B = c3_bb_x;
  if(c3_j_B < 0.0) {
    for(c3_i31 = 0; c3_i31 < 31; c3_i31 = c3_i31 + 1) {
      c3_g_x1[c3_i31] = c3_cv0[c3_i31];
    }
    for(c3_i32 = 0; c3_i32 < 77; c3_i32 = c3_i32 + 1) {
      c3_g_x2[c3_i32] = c3_cv1[c3_i32];
    }
    for(c3_i33 = 0; c3_i33 < 31; c3_i33 = c3_i33 + 1) {
      c3_m_u[c3_i33] = c3_g_x1[c3_i33];
    }
    c3_cb_y = NULL;
    sf_mex_assign(&c3_cb_y, sf_mex_create(&c3_m_u, "y", 8, 0U, 1U, 2, 1, 31));
    for(c3_i34 = 0; c3_i34 < 77; c3_i34 = c3_i34 + 1) {
      c3_n_u[c3_i34] = c3_g_x2[c3_i34];
    }
    c3_db_y = NULL;
    sf_mex_assign(&c3_db_y, sf_mex_create(&c3_n_u, "y", 8, 0U, 1U, 2, 1, 77));
    sf_mex_call("error", 0U, 2U, 14, c3_cb_y, 14, c3_db_y);
  }
  c3_j_B = sqrt(c3_j_B);
  c3_cb_x = c3_j_A;
  c3_eb_y = c3_j_B;
  c3_fb_y = c3_cb_x / c3_eb_y;
  c3_k_A = c3_omega_p_sw - c3_omega_o_sw;
  c3_k_B = 2.0;
  c3_db_x = c3_k_A;
  c3_gb_y = c3_k_B;
  c3_hb_y = c3_db_x / c3_gb_y;
  c3_omega_sw = c3_hb_y * (c3_fb_y + 1.0);
  /* + omega_m; */
  _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,38);
  c3_l_A = c3_abs_psi - c3_e_sign_h * (c3_c[2] + c3_c[1]);
  c3_eb_x = c3_mpower(c3_e_sign_h * (c3_c[2] + c3_c[1]) - c3_abs_psi) +
    c3_mpower(c3_s * c3_e_sign_h * (c3_c[2] - c3_c[1]));
  c3_l_B = c3_eb_x;
  if(c3_l_B < 0.0) {
    for(c3_i35 = 0; c3_i35 < 31; c3_i35 = c3_i35 + 1) {
      c3_h_x1[c3_i35] = c3_cv0[c3_i35];
    }
    for(c3_i36 = 0; c3_i36 < 77; c3_i36 = c3_i36 + 1) {
      c3_h_x2[c3_i36] = c3_cv1[c3_i36];
    }
    for(c3_i37 = 0; c3_i37 < 31; c3_i37 = c3_i37 + 1) {
      c3_o_u[c3_i37] = c3_h_x1[c3_i37];
    }
    c3_ib_y = NULL;
    sf_mex_assign(&c3_ib_y, sf_mex_create(&c3_o_u, "y", 8, 0U, 1U, 2, 1, 31));
    for(c3_i38 = 0; c3_i38 < 77; c3_i38 = c3_i38 + 1) {
      c3_p_u[c3_i38] = c3_h_x2[c3_i38];
    }
    c3_jb_y = NULL;
    sf_mex_assign(&c3_jb_y, sf_mex_create(&c3_p_u, "y", 8, 0U, 1U, 2, 1, 77));
    sf_mex_call("error", 0U, 2U, 14, c3_ib_y, 14, c3_jb_y);
  }
  c3_l_B = sqrt(c3_l_B);
  c3_fb_x = c3_l_A;
  c3_kb_y = c3_l_B;
  c3_lb_y = c3_fb_x / c3_kb_y;
  c3_m_A = c3_omega_p_ya - c3_omega_o_ya;
  c3_m_B = 2.0;
  c3_gb_x = c3_m_A;
  c3_mb_y = c3_m_B;
  c3_nb_y = c3_gb_x / c3_mb_y;
  c3_omega_ya = c3_nb_y * (c3_lb_y + 1.0);
  /* + omega_m; */
  /*  Output */
  _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,44);
  c3_Jp[0] = c3_omega_su;
  c3_Jp[1] = c3_omega_sw;
  c3_Jp[2] = c3_omega_ya;
  c3_Jp[3] = c3_r;
  c3_Jp[4] = c3_abs_psi;
  _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,-44);
  sf_debug_symbol_scope_pop();
  for(c3_i39 = 0; c3_i39 < 5; c3_i39 = c3_i39 + 1) {
    (*c3_b_Jp)[c3_i39] = c3_Jp[c3_i39];
  }
  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG,1);
  _sfEvent_ = c3_previousEvent;
  sf_debug_check_for_state_inconsistency(_supply_MachineNumber_,
   chartInstance.chartNumber, chartInstance.instanceNumber);
}

static void init_script_number_translation(uint32_T c3_machineNumber, uint32_T
 c3_chartNumber)
{
}

static real_T c3_mpower(real_T c3_a)
{
  real_T c3_b_a;
  real_T c3_b;
  real_T c3_ak;
  real_T c3_bk;
  real_T c3_x;
  real_T c3_b_x;
  int32_T c3_i40;
  static char c3_cv2[32] = { 'E', 'm', 'b', 'e', 'd', 'd', 'e', 'd', 'M', 'A',
    'T', 'L', 'A', 'B', ':', 'p', 'o', 'w', 'e', 'r', ':',
    'd', 'o', 'm', 'a', 'i', 'n', 'E', 'r', 'r', 'o', 'r' };
  char c3_x1[32];
  int32_T c3_i41;
  static char c3_cv3[102] = { 'D', 'o', 'm', 'a', 'i', 'n', ' ', 'e', 'r', 'r',
    'o', 'r', '.', ' ', 'T', 'o', ' ', 'c', 'o', 'm', 'p'
    , 'u', 't', 'e', ' ', 'c', 'o', 'm', 'p', 'l', 'e', 'x', ' ', 'r', 'e', 's',
    'u', 'l', 't', 's', ',',
    ' ', 'm', 'a', 'k', 'e', ' ', 'a', 't', ' ', 'l', 'e', 'a', 's', 't', ' ',
    'o', 'n', 'e', ' ', 'i', 'n'
    , 'p', 'u', 't', ' ', 'c', 'o', 'm', 'p', 'l', 'e', 'x', ',', ' ', 'e', '.',
    'g', '.', ' ', '\'', 'p',
    'o', 'w', 'e', 'r', '(', 'c', 'o', 'm', 'p', 'l', 'e', 'x', '(', 'a', ')',
    ',', 'b', ')', '\'', '.' };
  char c3_x2[102];
  int32_T c3_i42;
  char c3_u[32];
  const mxArray *c3_y = NULL;
  int32_T c3_i43;
  char c3_b_u[102];
  const mxArray *c3_b_y = NULL;
  c3_b_a = c3_a;
  c3_b = 2.0;
  c3_ak = c3_b_a;
  c3_bk = c3_b;
  if(c3_ak < 0.0) {
    c3_x = c3_bk;
    c3_b_x = c3_x;
    c3_b_x = floor(c3_b_x);
    if(c3_b_x != c3_bk) {
      for(c3_i40 = 0; c3_i40 < 32; c3_i40 = c3_i40 + 1) {
        c3_x1[c3_i40] = c3_cv2[c3_i40];
      }
      for(c3_i41 = 0; c3_i41 < 102; c3_i41 = c3_i41 + 1) {
        c3_x2[c3_i41] = c3_cv3[c3_i41];
      }
      for(c3_i42 = 0; c3_i42 < 32; c3_i42 = c3_i42 + 1) {
        c3_u[c3_i42] = c3_x1[c3_i42];
      }
      c3_y = NULL;
      sf_mex_assign(&c3_y, sf_mex_create(&c3_u, "y", 8, 0U, 1U, 2, 1, 32));
      for(c3_i43 = 0; c3_i43 < 102; c3_i43 = c3_i43 + 1) {
        c3_b_u[c3_i43] = c3_x2[c3_i43];
      }
      c3_b_y = NULL;
      sf_mex_assign(&c3_b_y, sf_mex_create(&c3_b_u, "y", 8, 0U, 1U, 2, 1, 102));
      sf_mex_call("error", 0U, 2U, 14, c3_y, 14, c3_b_y);
    }
  }
  return pow(c3_ak, c3_bk);
}

static const mxArray *c3_sf_marshall(void *c3_chartInstance, void *c3_u)
{
  const mxArray *c3_y = NULL;
  int32_T c3_i44;
  real_T c3_b_u[3];
  const mxArray *c3_b_y = NULL;
  c3_y = NULL;
  for(c3_i44 = 0; c3_i44 < 3; c3_i44 = c3_i44 + 1) {
    c3_b_u[c3_i44] = (*((real_T (*)[3])c3_u))[c3_i44];
  }
  c3_b_y = NULL;
  sf_mex_assign(&c3_b_y, sf_mex_create(&c3_b_u, "y", 0, 0U, 1U, 1, 3));
  sf_mex_assign(&c3_y, c3_b_y);
  return c3_y;
}

static const mxArray *c3_b_sf_marshall(void *c3_chartInstance, void *c3_u)
{
  const mxArray *c3_y = NULL;
  int32_T c3_i45;
  real_T c3_b_u[3];
  const mxArray *c3_b_y = NULL;
  c3_y = NULL;
  for(c3_i45 = 0; c3_i45 < 3; c3_i45 = c3_i45 + 1) {
    c3_b_u[c3_i45] = (*((real_T (*)[3])c3_u))[c3_i45];
  }
  c3_b_y = NULL;
  sf_mex_assign(&c3_b_y, sf_mex_create(&c3_b_u, "y", 0, 0U, 1U, 1, 3));
  sf_mex_assign(&c3_y, c3_b_y);
  return c3_y;
}

static const mxArray *c3_c_sf_marshall(void *c3_chartInstance, void *c3_u)
{
  const mxArray *c3_y = NULL;
  int32_T c3_i46;
  real_T c3_b_u[3];
  const mxArray *c3_b_y = NULL;
  c3_y = NULL;
  for(c3_i46 = 0; c3_i46 < 3; c3_i46 = c3_i46 + 1) {
    c3_b_u[c3_i46] = (*((real_T (*)[3])c3_u))[c3_i46];
  }
  c3_b_y = NULL;
  sf_mex_assign(&c3_b_y, sf_mex_create(&c3_b_u, "y", 0, 0U, 1U, 1, 3));
  sf_mex_assign(&c3_y, c3_b_y);
  return c3_y;
}

static const mxArray *c3_d_sf_marshall(void *c3_chartInstance, void *c3_u)
{
  const mxArray *c3_y = NULL;
  real_T c3_b_u;
  const mxArray *c3_b_y = NULL;
  c3_y = NULL;
  c3_b_u = *((real_T *)c3_u);
  c3_b_y = NULL;
  sf_mex_assign(&c3_b_y, sf_mex_create(&c3_b_u, "y", 0, 0U, 0U, 0));
  sf_mex_assign(&c3_y, c3_b_y);
  return c3_y;
}

static const mxArray *c3_e_sf_marshall(void *c3_chartInstance, void *c3_u)
{
  const mxArray *c3_y = NULL;
  real_T c3_b_u;
  const mxArray *c3_b_y = NULL;
  c3_y = NULL;
  c3_b_u = *((real_T *)c3_u);
  c3_b_y = NULL;
  sf_mex_assign(&c3_b_y, sf_mex_create(&c3_b_u, "y", 0, 0U, 0U, 0));
  sf_mex_assign(&c3_y, c3_b_y);
  return c3_y;
}

static const mxArray *c3_f_sf_marshall(void *c3_chartInstance, void *c3_u)
{
  const mxArray *c3_y = NULL;
  real_T c3_b_u;
  const mxArray *c3_b_y = NULL;
  c3_y = NULL;
  c3_b_u = *((real_T *)c3_u);
  c3_b_y = NULL;
  sf_mex_assign(&c3_b_y, sf_mex_create(&c3_b_u, "y", 0, 0U, 0U, 0));
  sf_mex_assign(&c3_y, c3_b_y);
  return c3_y;
}

static const mxArray *c3_g_sf_marshall(void *c3_chartInstance, void *c3_u)
{
  const mxArray *c3_y = NULL;
  real_T c3_b_u;
  const mxArray *c3_b_y = NULL;
  c3_y = NULL;
  c3_b_u = *((real_T *)c3_u);
  c3_b_y = NULL;
  sf_mex_assign(&c3_b_y, sf_mex_create(&c3_b_u, "y", 0, 0U, 0U, 0));
  sf_mex_assign(&c3_y, c3_b_y);
  return c3_y;
}

static const mxArray *c3_h_sf_marshall(void *c3_chartInstance, void *c3_u)
{
  const mxArray *c3_y = NULL;
  real_T c3_b_u;
  const mxArray *c3_b_y = NULL;
  c3_y = NULL;
  c3_b_u = *((real_T *)c3_u);
  c3_b_y = NULL;
  sf_mex_assign(&c3_b_y, sf_mex_create(&c3_b_u, "y", 0, 0U, 0U, 0));
  sf_mex_assign(&c3_y, c3_b_y);
  return c3_y;
}

static const mxArray *c3_i_sf_marshall(void *c3_chartInstance, void *c3_u)
{
  const mxArray *c3_y = NULL;
  real_T c3_b_u;
  const mxArray *c3_b_y = NULL;
  c3_y = NULL;
  c3_b_u = *((real_T *)c3_u);
  c3_b_y = NULL;
  sf_mex_assign(&c3_b_y, sf_mex_create(&c3_b_u, "y", 0, 0U, 0U, 0));
  sf_mex_assign(&c3_y, c3_b_y);
  return c3_y;
}

static const mxArray *c3_j_sf_marshall(void *c3_chartInstance, void *c3_u)
{
  const mxArray *c3_y = NULL;
  real_T c3_b_u;
  const mxArray *c3_b_y = NULL;
  c3_y = NULL;
  c3_b_u = *((real_T *)c3_u);
  c3_b_y = NULL;
  sf_mex_assign(&c3_b_y, sf_mex_create(&c3_b_u, "y", 0, 0U, 0U, 0));
  sf_mex_assign(&c3_y, c3_b_y);
  return c3_y;
}

static const mxArray *c3_k_sf_marshall(void *c3_chartInstance, void *c3_u)
{
  const mxArray *c3_y = NULL;
  real_T c3_b_u;
  const mxArray *c3_b_y = NULL;
  c3_y = NULL;
  c3_b_u = *((real_T *)c3_u);
  c3_b_y = NULL;
  sf_mex_assign(&c3_b_y, sf_mex_create(&c3_b_u, "y", 0, 0U, 0U, 0));
  sf_mex_assign(&c3_y, c3_b_y);
  return c3_y;
}

static const mxArray *c3_l_sf_marshall(void *c3_chartInstance, void *c3_u)
{
  const mxArray *c3_y = NULL;
  int32_T c3_i47;
  real_T c3_b_u[5];
  const mxArray *c3_b_y = NULL;
  c3_y = NULL;
  for(c3_i47 = 0; c3_i47 < 5; c3_i47 = c3_i47 + 1) {
    c3_b_u[c3_i47] = (*((real_T (*)[5])c3_u))[c3_i47];
  }
  c3_b_y = NULL;
  sf_mex_assign(&c3_b_y, sf_mex_create(&c3_b_u, "y", 0, 0U, 1U, 2, 1, 5));
  sf_mex_assign(&c3_y, c3_b_y);
  return c3_y;
}

static const mxArray *c3_m_sf_marshall(void *c3_chartInstance, void *c3_u)
{
  const mxArray *c3_y = NULL;
  real_T c3_b_u;
  const mxArray *c3_b_y = NULL;
  c3_y = NULL;
  c3_b_u = *((real_T *)c3_u);
  c3_b_y = NULL;
  sf_mex_assign(&c3_b_y, sf_mex_create(&c3_b_u, "y", 0, 0U, 0U, 0));
  sf_mex_assign(&c3_y, c3_b_y);
  return c3_y;
}

static const mxArray *c3_n_sf_marshall(void *c3_chartInstance, void *c3_u)
{
  const mxArray *c3_y = NULL;
  real_T c3_b_u;
  const mxArray *c3_b_y = NULL;
  c3_y = NULL;
  c3_b_u = *((real_T *)c3_u);
  c3_b_y = NULL;
  sf_mex_assign(&c3_b_y, sf_mex_create(&c3_b_u, "y", 0, 0U, 0U, 0));
  sf_mex_assign(&c3_y, c3_b_y);
  return c3_y;
}

static const mxArray *c3_o_sf_marshall(void *c3_chartInstance, void *c3_u)
{
  const mxArray *c3_y = NULL;
  real_T c3_b_u;
  const mxArray *c3_b_y = NULL;
  c3_y = NULL;
  c3_b_u = *((real_T *)c3_u);
  c3_b_y = NULL;
  sf_mex_assign(&c3_b_y, sf_mex_create(&c3_b_u, "y", 0, 0U, 0U, 0));
  sf_mex_assign(&c3_y, c3_b_y);
  return c3_y;
}

static const mxArray *c3_p_sf_marshall(void *c3_chartInstance, void *c3_u)
{
  const mxArray *c3_y = NULL;
  real_T c3_b_u;
  const mxArray *c3_b_y = NULL;
  c3_y = NULL;
  c3_b_u = *((real_T *)c3_u);
  c3_b_y = NULL;
  sf_mex_assign(&c3_b_y, sf_mex_create(&c3_b_u, "y", 0, 0U, 0U, 0));
  sf_mex_assign(&c3_y, c3_b_y);
  return c3_y;
}

static const mxArray *c3_q_sf_marshall(void *c3_chartInstance, void *c3_u)
{
  const mxArray *c3_y = NULL;
  real_T c3_b_u;
  const mxArray *c3_b_y = NULL;
  c3_y = NULL;
  c3_b_u = *((real_T *)c3_u);
  c3_b_y = NULL;
  sf_mex_assign(&c3_b_y, sf_mex_create(&c3_b_u, "y", 0, 0U, 0U, 0));
  sf_mex_assign(&c3_y, c3_b_y);
  return c3_y;
}

static const mxArray *c3_r_sf_marshall(void *c3_chartInstance, void *c3_u)
{
  const mxArray *c3_y = NULL;
  real_T c3_b_u;
  const mxArray *c3_b_y = NULL;
  c3_y = NULL;
  c3_b_u = *((real_T *)c3_u);
  c3_b_y = NULL;
  sf_mex_assign(&c3_b_y, sf_mex_create(&c3_b_u, "y", 0, 0U, 0U, 0));
  sf_mex_assign(&c3_y, c3_b_y);
  return c3_y;
}

static const mxArray *c3_s_sf_marshall(void *c3_chartInstance, void *c3_u)
{
  const mxArray *c3_y = NULL;
  real_T c3_b_u;
  const mxArray *c3_b_y = NULL;
  c3_y = NULL;
  c3_b_u = *((real_T *)c3_u);
  c3_b_y = NULL;
  sf_mex_assign(&c3_b_y, sf_mex_create(&c3_b_u, "y", 0, 0U, 0U, 0));
  sf_mex_assign(&c3_y, c3_b_y);
  return c3_y;
}

static const mxArray *c3_t_sf_marshall(void *c3_chartInstance, void *c3_u)
{
  const mxArray *c3_y = NULL;
  real_T c3_b_u;
  const mxArray *c3_b_y = NULL;
  c3_y = NULL;
  c3_b_u = *((real_T *)c3_u);
  c3_b_y = NULL;
  sf_mex_assign(&c3_b_y, sf_mex_create(&c3_b_u, "y", 0, 0U, 0U, 0));
  sf_mex_assign(&c3_y, c3_b_y);
  return c3_y;
}

static const mxArray *c3_u_sf_marshall(void *c3_chartInstance, void *c3_u)
{
  const mxArray *c3_y = NULL;
  real_T c3_b_u;
  const mxArray *c3_b_y = NULL;
  c3_y = NULL;
  c3_b_u = *((real_T *)c3_u);
  c3_b_y = NULL;
  sf_mex_assign(&c3_b_y, sf_mex_create(&c3_b_u, "y", 0, 0U, 0U, 0));
  sf_mex_assign(&c3_y, c3_b_y);
  return c3_y;
}

static const mxArray *c3_v_sf_marshall(void *c3_chartInstance, void *c3_u)
{
  const mxArray *c3_y = NULL;
  real_T c3_b_u;
  const mxArray *c3_b_y = NULL;
  c3_y = NULL;
  c3_b_u = *((real_T *)c3_u);
  c3_b_y = NULL;
  sf_mex_assign(&c3_b_y, sf_mex_create(&c3_b_u, "y", 0, 0U, 0U, 0));
  sf_mex_assign(&c3_y, c3_b_y);
  return c3_y;
}

static const mxArray *c3_w_sf_marshall(void *c3_chartInstance, void *c3_u)
{
  const mxArray *c3_y = NULL;
  real_T c3_b_u;
  const mxArray *c3_b_y = NULL;
  c3_y = NULL;
  c3_b_u = *((real_T *)c3_u);
  c3_b_y = NULL;
  sf_mex_assign(&c3_b_y, sf_mex_create(&c3_b_u, "y", 0, 0U, 0U, 0));
  sf_mex_assign(&c3_y, c3_b_y);
  return c3_y;
}

static const mxArray *c3_x_sf_marshall(void *c3_chartInstance, void *c3_u)
{
  const mxArray *c3_y = NULL;
  real_T c3_b_u;
  const mxArray *c3_b_y = NULL;
  c3_y = NULL;
  c3_b_u = *((real_T *)c3_u);
  c3_b_y = NULL;
  sf_mex_assign(&c3_b_y, sf_mex_create(&c3_b_u, "y", 0, 0U, 0U, 0));
  sf_mex_assign(&c3_y, c3_b_y);
  return c3_y;
}

static const mxArray *c3_y_sf_marshall(void *c3_chartInstance, void *c3_u)
{
  const mxArray *c3_y = NULL;
  real_T c3_b_u;
  const mxArray *c3_b_y = NULL;
  c3_y = NULL;
  c3_b_u = *((real_T *)c3_u);
  c3_b_y = NULL;
  sf_mex_assign(&c3_b_y, sf_mex_create(&c3_b_u, "y", 0, 0U, 0U, 0));
  sf_mex_assign(&c3_y, c3_b_y);
  return c3_y;
}

static const mxArray *c3_ab_sf_marshall(void *c3_chartInstance, void *c3_u)
{
  const mxArray *c3_y = NULL;
  real_T c3_b_u;
  const mxArray *c3_b_y = NULL;
  c3_y = NULL;
  c3_b_u = *((real_T *)c3_u);
  c3_b_y = NULL;
  sf_mex_assign(&c3_b_y, sf_mex_create(&c3_b_u, "y", 0, 0U, 0U, 0));
  sf_mex_assign(&c3_y, c3_b_y);
  return c3_y;
}

static const mxArray *c3_bb_sf_marshall(void *c3_chartInstance, void *c3_u)
{
  const mxArray *c3_y = NULL;
  real_T c3_b_u;
  const mxArray *c3_b_y = NULL;
  c3_y = NULL;
  c3_b_u = *((real_T *)c3_u);
  c3_b_y = NULL;
  sf_mex_assign(&c3_b_y, sf_mex_create(&c3_b_u, "y", 0, 0U, 0U, 0));
  sf_mex_assign(&c3_y, c3_b_y);
  return c3_y;
}

static const mxArray *c3_cb_sf_marshall(void *c3_chartInstance, void *c3_u)
{
  const mxArray *c3_y = NULL;
  real_T c3_b_u;
  const mxArray *c3_b_y = NULL;
  c3_y = NULL;
  c3_b_u = *((real_T *)c3_u);
  c3_b_y = NULL;
  sf_mex_assign(&c3_b_y, sf_mex_create(&c3_b_u, "y", 0, 0U, 0U, 0));
  sf_mex_assign(&c3_y, c3_b_y);
  return c3_y;
}

static const mxArray *c3_db_sf_marshall(void *c3_chartInstance, void *c3_u)
{
  const mxArray *c3_y = NULL;
  real_T c3_b_u;
  const mxArray *c3_b_y = NULL;
  c3_y = NULL;
  c3_b_u = *((real_T *)c3_u);
  c3_b_y = NULL;
  sf_mex_assign(&c3_b_y, sf_mex_create(&c3_b_u, "y", 0, 0U, 0U, 0));
  sf_mex_assign(&c3_y, c3_b_y);
  return c3_y;
}

static const mxArray *c3_eb_sf_marshall(void *c3_chartInstance, void *c3_u)
{
  const mxArray *c3_y = NULL;
  real_T c3_b_u;
  const mxArray *c3_b_y = NULL;
  c3_y = NULL;
  c3_b_u = *((real_T *)c3_u);
  c3_b_y = NULL;
  sf_mex_assign(&c3_b_y, sf_mex_create(&c3_b_u, "y", 0, 0U, 0U, 0));
  sf_mex_assign(&c3_y, c3_b_y);
  return c3_y;
}

const mxArray *sf_c3_supply__get_eml_resolved_functions_info(void)
{
  const mxArray *c3_nameCaptureInfo = NULL;
  c3_ResolvedFunctionInfo c3_info[57];
  const mxArray *c3_m0 = NULL;
  int32_T c3_i48;
  c3_ResolvedFunctionInfo *c3_r0;
  c3_nameCaptureInfo = NULL;
  c3_info_helper(c3_info);
  sf_mex_assign(&c3_m0, sf_mex_createstruct("nameCaptureInfo", 1, 57));
  for(c3_i48 = 0; c3_i48 < 57; c3_i48 = c3_i48 + 1) {
    c3_r0 = &c3_info[c3_i48];
    sf_mex_addfield(c3_m0, sf_mex_create(c3_r0->context, "nameCaptureInfo", 13,
      0U, 0U, 2, 1, strlen(c3_r0->context)), "context",
     "nameCaptureInfo", c3_i48);
    sf_mex_addfield(c3_m0, sf_mex_create(c3_r0->name, "nameCaptureInfo", 13, 0U,
      0U, 2, 1, strlen(c3_r0->name)), "name",
     "nameCaptureInfo", c3_i48);
    sf_mex_addfield(c3_m0, sf_mex_create(c3_r0->dominantType, "nameCaptureInfo",
      13, 0U, 0U, 2, 1, strlen(c3_r0->dominantType)),
     "dominantType", "nameCaptureInfo", c3_i48);
    sf_mex_addfield(c3_m0, sf_mex_create(c3_r0->resolved, "nameCaptureInfo", 13,
      0U, 0U, 2, 1, strlen(c3_r0->resolved)), "resolved",
     "nameCaptureInfo", c3_i48);
    sf_mex_addfield(c3_m0, sf_mex_create(&c3_r0->fileLength, "nameCaptureInfo",
      7, 0U, 0U, 0), "fileLength", "nameCaptureInfo", c3_i48);
    sf_mex_addfield(c3_m0, sf_mex_create(&c3_r0->fileTime1, "nameCaptureInfo",
      7, 0U, 0U, 0), "fileTime1", "nameCaptureInfo", c3_i48);
    sf_mex_addfield(c3_m0, sf_mex_create(&c3_r0->fileTime2, "nameCaptureInfo",
      7, 0U, 0U, 0), "fileTime2", "nameCaptureInfo", c3_i48);
  }
  sf_mex_assign(&c3_nameCaptureInfo, c3_m0);
  return c3_nameCaptureInfo;
}

static void c3_info_helper(c3_ResolvedFunctionInfo c3_info[57])
{
  c3_info[0].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mpower.m";
  c3_info[0].name = "isnumeric";
  c3_info[0].dominantType = "double";
  c3_info[0].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/datatypes/isnumeric.m";
  c3_info[0].fileLength = 250U;
  c3_info[0].fileTime1 = 1160425022U;
  c3_info[0].fileTime2 = 0U;
  c3_info[1].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_assert_valid_size_arg.m/check_arg";
  c3_info[1].name = "isfloat";
  c3_info[1].dominantType = "double";
  c3_info[1].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/datatypes/isfloat.m";
  c3_info[1].fileLength = 182U;
  c3_info[1].fileTime1 = 1160425020U;
  c3_info[1].fileTime2 = 0U;
  c3_info[2].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c3_info[2].name = "eml_isa_uint";
  c3_info[2].dominantType = "double";
  c3_info[2].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_isa_uint.m";
  c3_info[2].fileLength = 288U;
  c3_info[2].fileTime1 = 1163949198U;
  c3_info[2].fileTime2 = 0U;
  c3_info[3].context = "";
  c3_info[3].name = "mrdivide";
  c3_info[3].dominantType = "double";
  c3_info[3].resolved = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.m";
  c3_info[3].fileLength = 653U;
  c3_info[3].fileTime1 = 1160425202U;
  c3_info[3].fileTime2 = 0U;
  c3_info[4].context = "";
  c3_info[4].name = "mtimes";
  c3_info[4].dominantType = "double";
  c3_info[4].resolved = "[B]mtimes";
  c3_info[4].fileLength = 0U;
  c3_info[4].fileTime1 = 0U;
  c3_info[4].fileTime2 = 0U;
  c3_info[5].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalexp_size.m";
  c3_info[5].name = "eml_scalexp_compatible";
  c3_info[5].dominantType = "double";
  c3_info[5].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalexp_compatible.m";
  c3_info[5].fileLength = 422U;
  c3_info[5].fileTime1 = 1160425154U;
  c3_info[5].fileTime2 = 0U;
  c3_info[6].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elmat/length.m";
  c3_info[6].name = "size";
  c3_info[6].dominantType = "double";
  c3_info[6].resolved = "[B]size";
  c3_info[6].fileLength = 0U;
  c3_info[6].fileTime1 = 0U;
  c3_info[6].fileTime2 = 0U;
  c3_info[7].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/datatypes/isa.m";
  c3_info[7].name = "eml_is_float_class";
  c3_info[7].dominantType = "char";
  c3_info[7].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_is_float_class.m";
  c3_info[7].fileLength = 273U;
  c3_info[7].fileTime1 = 1160425144U;
  c3_info[7].fileTime2 = 0U;
  c3_info[8].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/datatypes/cast.m";
  c3_info[8].name = "double";
  c3_info[8].dominantType = "double";
  c3_info[8].resolved = "[B]double";
  c3_info[8].fileLength = 0U;
  c3_info[8].fileTime1 = 0U;
  c3_info[8].fileTime2 = 0U;
  c3_info[9].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.m";
  c3_info[9].name = "rdivide";
  c3_info[9].dominantType = "double";
  c3_info[9].resolved = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c3_info[9].fileLength = 4533U;
  c3_info[9].fileTime1 = 1177078148U;
  c3_info[9].fileTime2 = 0U;
  c3_info[10].context = "";
  c3_info[10].name = "minus";
  c3_info[10].dominantType = "double";
  c3_info[10].resolved = "[B]minus";
  c3_info[10].fileLength = 0U;
  c3_info[10].fileTime1 = 0U;
  c3_info[10].fileTime2 = 0U;
  c3_info[11].context = "";
  c3_info[11].name = "atan";
  c3_info[11].dominantType = "double";
  c3_info[11].resolved = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/atan.m";
  c3_info[11].fileLength = 612U;
  c3_info[11].fileTime1 = 1163949118U;
  c3_info[11].fileTime2 = 0U;
  c3_info[12].context = "";
  c3_info[12].name = "pi";
  c3_info[12].dominantType = "";
  c3_info[12].resolved = "[B]pi";
  c3_info[12].fileLength = 0U;
  c3_info[12].fileTime1 = 0U;
  c3_info[12].fileTime2 = 0U;
  c3_info[13].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mpower.m";
  c3_info[13].name = "isinteger";
  c3_info[13].dominantType = "double";
  c3_info[13].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/datatypes/isinteger.m";
  c3_info[13].fileLength = 254U;
  c3_info[13].fileTime1 = 1160425020U;
  c3_info[13].fileTime2 = 0U;
  c3_info[14].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_is_float_class.m";
  c3_info[14].name = "ischar";
  c3_info[14].dominantType = "char";
  c3_info[14].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/strfun/ischar.m";
  c3_info[14].fileLength = 244U;
  c3_info[14].fileTime1 = 1160425234U;
  c3_info[14].fileTime2 = 0U;
  c3_info[15].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elmat/false.m";
  c3_info[15].name = "lt";
  c3_info[15].dominantType = "double";
  c3_info[15].resolved = "[B]lt";
  c3_info[15].fileLength = 0U;
  c3_info[15].fileTime1 = 0U;
  c3_info[15].fileTime2 = 0U;
  c3_info[16].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mpower.m";
  c3_info[16].name = "eml_assert";
  c3_info[16].dominantType = "char";
  c3_info[16].resolved = "[B]eml_assert";
  c3_info[16].fileLength = 0U;
  c3_info[16].fileTime1 = 0U;
  c3_info[16].fileTime2 = 0U;
  c3_info[17].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mpower.m";
  c3_info[17].name = "gt";
  c3_info[17].dominantType = "double";
  c3_info[17].resolved = "[B]gt";
  c3_info[17].fileLength = 0U;
  c3_info[17].fileTime1 = 0U;
  c3_info[17].fileTime2 = 0U;
  c3_info[18].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_alloc.m";
  c3_info[18].name = "cast";
  c3_info[18].dominantType = "double";
  c3_info[18].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/datatypes/cast.m";
  c3_info[18].fileLength = 907U;
  c3_info[18].fileTime1 = 1160425018U;
  c3_info[18].fileTime2 = 0U;
  c3_info[19].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/floor.m";
  c3_info[19].name = "isempty";
  c3_info[19].dominantType = "double";
  c3_info[19].resolved = "[B]isempty";
  c3_info[19].fileLength = 0U;
  c3_info[19].fileTime1 = 0U;
  c3_info[19].fileTime2 = 0U;
  c3_info[20].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/datatypes/isa.m";
  c3_info[20].name = "eq";
  c3_info[20].dominantType = "double";
  c3_info[20].resolved = "[B]eq";
  c3_info[20].fileLength = 0U;
  c3_info[20].fileTime1 = 0U;
  c3_info[20].fileTime2 = 0U;
  c3_info[21].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mpower.m";
  c3_info[21].name = "nargin";
  c3_info[21].dominantType = "";
  c3_info[21].resolved = "[B]nargin";
  c3_info[21].fileLength = 0U;
  c3_info[21].fileTime1 = 0U;
  c3_info[21].fileTime2 = 0U;
  c3_info[22].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/elmat/isscalar.m";
  c3_info[22].name = "length";
  c3_info[22].dominantType = "double";
  c3_info[22].resolved = "[I]$matlabroot$/toolbox/eml/lib/matlab/elmat/length.m";
  c3_info[22].fileLength = 347U;
  c3_info[22].fileTime1 = 1163949170U;
  c3_info[22].fileTime2 = 0U;
  c3_info[23].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_alloc.m";
  c3_info[23].name = "eml_assert_valid_size_arg";
  c3_info[23].dominantType = "double";
  c3_info[23].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_assert_valid_size_arg.m";
  c3_info[23].fileLength = 1097U;
  c3_info[23].fileTime1 = 1163949188U;
  c3_info[23].fileTime2 = 0U;
  c3_info[24].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_assert_valid_size_arg.m/check_arg";
  c3_info[24].name = "real";
  c3_info[24].dominantType = "double";
  c3_info[24].resolved = "[B]real";
  c3_info[24].fileLength = 0U;
  c3_info[24].fileTime1 = 0U;
  c3_info[24].fileTime2 = 0U;
  c3_info[25].context = "";
  c3_info[25].name = "sin";
  c3_info[25].dominantType = "double";
  c3_info[25].resolved = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/sin.m";
  c3_info[25].fileLength = 769U;
  c3_info[25].fileTime1 = 1163949154U;
  c3_info[25].fileTime2 = 0U;
  c3_info[26].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/datatypes/isnumeric.m";
  c3_info[26].name = "isa";
  c3_info[26].dominantType = "double";
  c3_info[26].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/datatypes/isa.m";
  c3_info[26].fileLength = 791U;
  c3_info[26].fileTime1 = 1160425018U;
  c3_info[26].fileTime2 = 0U;
  c3_info[27].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_alloc.m";
  c3_info[27].name = "plus";
  c3_info[27].dominantType = "double";
  c3_info[27].resolved = "[B]plus";
  c3_info[27].fileLength = 0U;
  c3_info[27].fileTime1 = 0U;
  c3_info[27].fileTime2 = 0U;
  c3_info[28].context = "";
  c3_info[28].name = "cos";
  c3_info[28].dominantType = "double";
  c3_info[28].resolved = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/cos.m";
  c3_info[28].fileLength = 772U;
  c3_info[28].fileTime1 = 1163949124U;
  c3_info[28].fileTime2 = 0U;
  c3_info[29].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mpower.m";
  c3_info[29].name = "power";
  c3_info[29].dominantType = "double";
  c3_info[29].resolved = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m";
  c3_info[29].fileLength = 4842U;
  c3_info[29].fileTime1 = 1177078146U;
  c3_info[29].fileTime2 = 0U;
  c3_info[30].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elmat/false.m";
  c3_info[30].name = "logical";
  c3_info[30].dominantType = "double";
  c3_info[30].resolved = "[B]logical";
  c3_info[30].fileLength = 0U;
  c3_info[30].fileTime1 = 0U;
  c3_info[30].fileTime2 = 0U;
  c3_info[31].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mpower.m";
  c3_info[31].name = "isscalar";
  c3_info[31].dominantType = "double";
  c3_info[31].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/elmat/isscalar.m";
  c3_info[31].fileLength = 243U;
  c3_info[31].fileTime1 = 1160425104U;
  c3_info[31].fileTime2 = 0U;
  c3_info[32].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elmat/length.m";
  c3_info[32].name = "eml_numel";
  c3_info[32].dominantType = "double";
  c3_info[32].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_numel.m";
  c3_info[32].fileLength = 278U;
  c3_info[32].fileTime1 = 1163949202U;
  c3_info[32].fileTime2 = 0U;
  c3_info[33].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m";
  c3_info[33].name = "floor";
  c3_info[33].dominantType = "double";
  c3_info[33].resolved = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/floor.m";
  c3_info[33].fileLength = 595U;
  c3_info[33].fileTime1 = 1163949136U;
  c3_info[33].fileTime2 = 0U;
  c3_info[34].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m";
  c3_info[34].name = "eml_error";
  c3_info[34].dominantType = "char";
  c3_info[34].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_error.m";
  c3_info[34].fileLength = 585U;
  c3_info[34].fileTime1 = 1177078120U;
  c3_info[34].fileTime2 = 0U;
  c3_info[35].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_assert_valid_size_arg.m/check_arg";
  c3_info[35].name = "isvector";
  c3_info[35].dominantType = "double";
  c3_info[35].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/elmat/isvector.m";
  c3_info[35].fileLength = 284U;
  c3_info[35].fileTime1 = 1160425106U;
  c3_info[35].fileTime2 = 0U;
  c3_info[36].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_numel.m";
  c3_info[36].name = "numel";
  c3_info[36].dominantType = "double";
  c3_info[36].resolved = "[B]numel";
  c3_info[36].fileLength = 0U;
  c3_info[36].fileTime1 = 0U;
  c3_info[36].fileTime2 = 0U;
  c3_info[37].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c3_info[37].name = "not";
  c3_info[37].dominantType = "logical";
  c3_info[37].resolved = "[B]not";
  c3_info[37].fileLength = 0U;
  c3_info[37].fileTime1 = 0U;
  c3_info[37].fileTime2 = 0U;
  c3_info[38].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_alloc.m";
  c3_info[38].name = "zeros";
  c3_info[38].dominantType = "double";
  c3_info[38].resolved = "[B]zeros";
  c3_info[38].fileLength = 0U;
  c3_info[38].fileTime1 = 0U;
  c3_info[38].fileTime2 = 0U;
  c3_info[39].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/datatypes/isa.m";
  c3_info[39].name = "eml_is_integer_class";
  c3_info[39].dominantType = "char";
  c3_info[39].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_is_integer_class.m";
  c3_info[39].fileLength = 462U;
  c3_info[39].fileTime1 = 1160425144U;
  c3_info[39].fileTime2 = 0U;
  c3_info[40].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m";
  c3_info[40].name = "eml_alloc";
  c3_info[40].dominantType = "double";
  c3_info[40].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_alloc.m";
  c3_info[40].fileLength = 2151U;
  c3_info[40].fileTime1 = 1179442870U;
  c3_info[40].fileTime2 = 0U;
  c3_info[41].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_assert_valid_size_arg.m/check_arg";
  c3_info[41].name = "ne";
  c3_info[41].dominantType = "double";
  c3_info[41].resolved = "[B]ne";
  c3_info[41].fileLength = 0U;
  c3_info[41].fileTime1 = 0U;
  c3_info[41].fileTime2 = 0U;
  c3_info[42].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m";
  c3_info[42].name = "eml_scalexp_size";
  c3_info[42].dominantType = "double";
  c3_info[42].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalexp_size.m";
  c3_info[42].fileLength = 923U;
  c3_info[42].fileTime1 = 1160425156U;
  c3_info[42].fileTime2 = 0U;
  c3_info[43].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_assert_valid_size_arg.m/check_arg";
  c3_info[43].name = "true";
  c3_info[43].dominantType = "";
  c3_info[43].resolved = "[I]$matlabroot$/toolbox/eml/lib/matlab/elmat/true.m";
  c3_info[43].fileLength = 625U;
  c3_info[43].fileTime1 = 1163949186U;
  c3_info[43].fileTime2 = 0U;
  c3_info[44].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_alloc.m";
  c3_info[44].name = "isreal";
  c3_info[44].dominantType = "double";
  c3_info[44].resolved = "[B]isreal";
  c3_info[44].fileLength = 0U;
  c3_info[44].fileTime1 = 0U;
  c3_info[44].fileTime2 = 0U;
  c3_info[45].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_assert_valid_size_arg.m/check_arg";
  c3_info[45].name = "imag";
  c3_info[45].dominantType = "double";
  c3_info[45].resolved = "[B]imag";
  c3_info[45].fileLength = 0U;
  c3_info[45].fileTime1 = 0U;
  c3_info[45].fileTime2 = 0U;
  c3_info[46].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/datatypes/cast.m";
  c3_info[46].name = "ge";
  c3_info[46].dominantType = "double";
  c3_info[46].resolved = "[B]ge";
  c3_info[46].fileLength = 0U;
  c3_info[46].fileTime1 = 0U;
  c3_info[46].fileTime2 = 0U;
  c3_info[47].context = "";
  c3_info[47].name = "uminus";
  c3_info[47].dominantType = "double";
  c3_info[47].resolved = "[B]uminus";
  c3_info[47].fileLength = 0U;
  c3_info[47].fileTime1 = 0U;
  c3_info[47].fileTime2 = 0U;
  c3_info[48].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_assert_valid_size_arg.m/check_arg";
  c3_info[48].name = "false";
  c3_info[48].dominantType = "";
  c3_info[48].resolved = "[I]$matlabroot$/toolbox/eml/lib/matlab/elmat/false.m";
  c3_info[48].fileLength = 631U;
  c3_info[48].fileTime1 = 1163949166U;
  c3_info[48].fileTime2 = 0U;
  c3_info[49].context = "";
  c3_info[49].name = "mpower";
  c3_info[49].dominantType = "double";
  c3_info[49].resolved = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mpower.m";
  c3_info[49].fileLength = 3116U;
  c3_info[49].fileTime1 = 1177078146U;
  c3_info[49].fileTime2 = 0U;
  c3_info[50].context = "";
  c3_info[50].name = "sqrt";
  c3_info[50].dominantType = "double";
  c3_info[50].resolved = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/sqrt.m";
  c3_info[50].fileLength = 1276U;
  c3_info[50].fileTime1 = 1177078108U;
  c3_info[50].fileTime2 = 0U;
  c3_info[51].context = "";
  c3_info[51].name = "abs";
  c3_info[51].dominantType = "double";
  c3_info[51].resolved = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c3_info[51].fileLength = 1031U;
  c3_info[51].fileTime1 = 1163949102U;
  c3_info[51].fileTime2 = 0U;
  c3_info[52].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mpower.m";
  c3_info[52].name = "ndims";
  c3_info[52].dominantType = "double";
  c3_info[52].resolved = "[I]$matlabroot$/toolbox/eml/lib/matlab/elmat/ndims.m";
  c3_info[52].fileLength = 236U;
  c3_info[52].fileTime1 = 1163949176U;
  c3_info[52].fileTime2 = 0U;
  c3_info[53].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/datatypes/isa.m";
  c3_info[53].name = "strcmp";
  c3_info[53].dominantType = "char";
  c3_info[53].resolved = "[B]strcmp";
  c3_info[53].fileLength = 0U;
  c3_info[53].fileTime1 = 0U;
  c3_info[53].fileTime2 = 0U;
  c3_info[54].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_alloc.m";
  c3_info[54].name = "isstruct";
  c3_info[54].dominantType = "double";
  c3_info[54].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/datatypes/isstruct.m";
  c3_info[54].fileLength = 179U;
  c3_info[54].fileTime1 = 1160425024U;
  c3_info[54].fileTime2 = 0U;
  c3_info[55].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/datatypes/isa.m";
  c3_info[55].name = "class";
  c3_info[55].dominantType = "char";
  c3_info[55].resolved = "[B]class";
  c3_info[55].fileLength = 0U;
  c3_info[55].fileTime1 = 0U;
  c3_info[55].fileTime2 = 0U;
  c3_info[56].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c3_info[56].name = "islogical";
  c3_info[56].dominantType = "double";
  c3_info[56].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/datatypes/islogical.m";
  c3_info[56].fileLength = 186U;
  c3_info[56].fileTime1 = 1160425022U;
  c3_info[56].fileTime2 = 0U;
}

static void init_dsm_address_info(void)
{
}

/* SFunction Glue Code */
void sf_c3_supply__get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(1766013710U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(1212436350U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(1684686544U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(1054291302U);
}

mxArray *sf_c3_supply__get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] =
  {"checksum","inputs","parameters","outputs"};
  mxArray *mxAutoinheritanceInfo =
  mxCreateStructMatrix(1,1,4,autoinheritanceFields);
  {
    mxArray *mxChecksum = mxCreateDoubleMatrix(4,1,mxREAL);
    double *pr = mxGetPr(mxChecksum);
    pr[0] = (double)(3541595298U);
    pr[1] = (double)(1764026521U);
    pr[2] = (double)(595043072U);
    pr[3] = (double)(1197295041U);
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }
  {
    const char *dataFields[] = {"size","type","complexity"};
    mxArray *mxData = mxCreateStructMatrix(1,11,3,dataFields);
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }
    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }
    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }
    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,3,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,3,"type",mxType);
    }
    mxSetField(mxData,3,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,4,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,4,"type",mxType);
    }
    mxSetField(mxData,4,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,5,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,5,"type",mxType);
    }
    mxSetField(mxData,5,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,6,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,6,"type",mxType);
    }
    mxSetField(mxData,6,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,7,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,7,"type",mxType);
    }
    mxSetField(mxData,7,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,8,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,8,"type",mxType);
    }
    mxSetField(mxData,8,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,9,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,9,"type",mxType);
    }
    mxSetField(mxData,9,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,10,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,10,"type",mxType);
    }
    mxSetField(mxData,10,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }
  {
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxCreateDoubleMatrix(0,0,mxREAL));
  }
  {
    const char *dataFields[] = {"size","type","complexity"};
    mxArray *mxData = mxCreateStructMatrix(1,1,3,dataFields);
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(5);
      mxSetField(mxData,0,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }
    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }
  return(mxAutoinheritanceInfo);
}

static void chart_debug_initialization(SimStruct *S, unsigned int
 fullDebuggerInitialization)
{
  if(ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
    /* do this only if simulation is starting */
    if(!sim_mode_is_rtw_gen(S)) {
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart(_supply_MachineNumber_,
         3,
         1,
         1,
         12,
         0,
         0,
         0,
         0,
         0,
         &(chartInstance.chartNumber),
         &(chartInstance.instanceNumber),
         ssGetPath(S),
         (void *)S);
        if(chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation(_supply_MachineNumber_,chartInstance.chartNumber);
          sf_debug_set_chart_disable_implicit_casting(_supply_MachineNumber_,chartInstance.chartNumber,1);
          sf_debug_set_chart_event_thresholds(_supply_MachineNumber_,
           chartInstance.chartNumber,
           0,
           0,
           0);

          {
            unsigned int dimVector[1];
            dimVector[0]= 3;
            _SFD_SET_DATA_PROPS(10,1,1,0,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,1.0,0,"a",0,c3_sf_marshall);
          }
          {
            unsigned int dimVector[1];
            dimVector[0]= 3;
            _SFD_SET_DATA_PROPS(8,1,1,0,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,1.0,0,"b",0,c3_b_sf_marshall);
          }
          {
            unsigned int dimVector[1];
            dimVector[0]= 3;
            _SFD_SET_DATA_PROPS(5,1,1,0,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,1.0,0,"c",0,c3_c_sf_marshall);
          }
          _SFD_SET_DATA_PROPS(9,1,1,0,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,"x",0,c3_d_sf_marshall);
          {
            unsigned int dimVector[2];
            dimVector[0]= 1;
            dimVector[1]= 5;
            _SFD_SET_DATA_PROPS(3,2,0,1,SF_DOUBLE,2,&(dimVector[0]),0,0,0,0.0,1.0,0,"Jp",0,c3_l_sf_marshall);
          }
          _SFD_SET_DATA_PROPS(0,1,1,0,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,"y",0,c3_e_sf_marshall);
          _SFD_SET_DATA_PROPS(7,1,1,0,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,"psi",0,c3_f_sf_marshall);
          _SFD_SET_DATA_PROPS(6,1,1,0,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,"omega_o_su",0,c3_g_sf_marshall);
          _SFD_SET_DATA_PROPS(4,1,1,0,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,"omega_o_sw",0,c3_h_sf_marshall);
          _SFD_SET_DATA_PROPS(11,1,1,0,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,"omega_o_ya",0,c3_i_sf_marshall);
          _SFD_SET_DATA_PROPS(1,1,1,0,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,"r_1",0,c3_j_sf_marshall);
          _SFD_SET_DATA_PROPS(2,1,1,0,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,"psi_1",0,c3_k_sf_marshall);
          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }
        _SFD_CV_INIT_CHART(0,0,0,0);
        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of EML Model Coverage */
        _SFD_CV_INIT_EML(0,1,1,0,0,0,0,0);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,1404);
        _SFD_CV_INIT_EML_IF(0,0,308,316,333,362);
        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if(chartAlreadyPresent==0)
        {
          _SFD_TRANS_COV_MAPS(0,
           0,NULL,NULL,
           0,NULL,NULL,
           1,NULL,NULL,
           0,NULL,NULL);
        }

        {
          real_T (*c3_a)[3];
          real_T (*c3_b)[3];
          real_T (*c3_c)[3];
          real_T *c3_x;
          real_T (*c3_Jp)[5];
          real_T *c3_y;
          real_T *c3_psi;
          real_T *c3_omega_o_su;
          real_T *c3_omega_o_sw;
          real_T *c3_omega_o_ya;
          real_T *c3_r_1;
          real_T *c3_psi_1;
          c3_omega_o_su = (real_T *)ssGetInputPortSignal(chartInstance.S, 6);
          c3_a = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 0);
          c3_Jp = (real_T (*)[5])ssGetOutputPortSignal(chartInstance.S, 1);
          c3_y = (real_T *)ssGetInputPortSignal(chartInstance.S, 4);
          c3_r_1 = (real_T *)ssGetInputPortSignal(chartInstance.S, 9);
          c3_x = (real_T *)ssGetInputPortSignal(chartInstance.S, 3);
          c3_omega_o_ya = (real_T *)ssGetInputPortSignal(chartInstance.S, 8);
          c3_psi_1 = (real_T *)ssGetInputPortSignal(chartInstance.S, 10);
          c3_omega_o_sw = (real_T *)ssGetInputPortSignal(chartInstance.S, 7);
          c3_c = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 2);
          c3_b = (real_T (*)[3])ssGetInputPortSignal(chartInstance.S, 1);
          c3_psi = (real_T *)ssGetInputPortSignal(chartInstance.S, 5);
          _SFD_SET_DATA_VALUE_PTR(10U, c3_a);
          _SFD_SET_DATA_VALUE_PTR(8U, c3_b);
          _SFD_SET_DATA_VALUE_PTR(5U, c3_c);
          _SFD_SET_DATA_VALUE_PTR(9U, c3_x);
          _SFD_SET_DATA_VALUE_PTR(3U, c3_Jp);
          _SFD_SET_DATA_VALUE_PTR(0U, c3_y);
          _SFD_SET_DATA_VALUE_PTR(7U, c3_psi);
          _SFD_SET_DATA_VALUE_PTR(6U, c3_omega_o_su);
          _SFD_SET_DATA_VALUE_PTR(4U, c3_omega_o_sw);
          _SFD_SET_DATA_VALUE_PTR(11U, c3_omega_o_ya);
          _SFD_SET_DATA_VALUE_PTR(1U, c3_r_1);
          _SFD_SET_DATA_VALUE_PTR(2U, c3_psi_1);
        }
      }
    }
  } else {
    sf_debug_reset_current_state_configuration(_supply_MachineNumber_,chartInstance.chartNumber,chartInstance.instanceNumber);
  }
}

static void sf_opaque_initialize_c3_supply_(void *chartInstanceVar)
{
  chart_debug_initialization(chartInstance.S,0);
  initialize_params_c3_supply_();
  initialize_c3_supply_();
}

static void sf_opaque_enable_c3_supply_(void *chartInstanceVar)
{
  enable_c3_supply_();
}

static void sf_opaque_disable_c3_supply_(void *chartInstanceVar)
{
  disable_c3_supply_();
}

static void sf_opaque_gateway_c3_supply_(void *chartInstanceVar)
{
  sf_c3_supply_();
}

static void sf_opaque_terminate_c3_supply_(void *chartInstanceVar)
{
  if (sim_mode_is_rtw_gen(chartInstance.S) ||
   sim_mode_is_external(chartInstance.S)) {
    sf_clear_rtw_identifier(chartInstance.S);
  }
  finalize_c3_supply_();
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c3_supply_(SimStruct *S)
{
  int i;
  for(i=0;i<ssGetNumRunTimeParams(S);i++) {
    if(ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }
  if(sf_machine_global_initializer_called()) {
    initialize_params_c3_supply_();
  }
}

static void mdlSetWorkWidths_c3_supply_(SimStruct *S)
{
  if(sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable("supply_",3);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop("supply_",3,"gatewayCannotBeInlinedMultipleTimes"));
    if(chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 1, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 2, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 3, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 4, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 5, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 6, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 7, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 8, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 9, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 10, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,"supply_",3,11);
      sf_mark_chart_reusable_outputs(S,"supply_",3,1);
    }
    sf_set_rtw_dwork_info(S,"supply_",3);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
    ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  }

  ssSetChecksum0(S,(208461752U));
  ssSetChecksum1(S,(3476016818U));
  ssSetChecksum2(S,(2020020459U));
  ssSetChecksum3(S,(3760261582U));

  ssSetmdlDerivatives(S, NULL);

  ssSetExplicitFCSSCtrl(S,1);
}

static void mdlRTW_c3_supply_(SimStruct *S)
{
  if(sim_mode_is_rtw_gen(S)) {
    sf_write_symbol_mapping(S, "supply_", 3);
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c3_supply_(SimStruct *S)
{
  chartInstance.chartInfo.chartInstance = NULL;
  chartInstance.chartInfo.isEMLChart = 1;
  chartInstance.chartInfo.chartInitialized = 0;
  chartInstance.chartInfo.sFunctionGateway = sf_opaque_gateway_c3_supply_;
  chartInstance.chartInfo.initializeChart = sf_opaque_initialize_c3_supply_;
  chartInstance.chartInfo.terminateChart = sf_opaque_terminate_c3_supply_;
  chartInstance.chartInfo.enableChart = sf_opaque_enable_c3_supply_;
  chartInstance.chartInfo.disableChart = sf_opaque_disable_c3_supply_;
  chartInstance.chartInfo.zeroCrossings = NULL;
  chartInstance.chartInfo.outputs = NULL;
  chartInstance.chartInfo.derivatives = NULL;
  chartInstance.chartInfo.mdlRTW = mdlRTW_c3_supply_;
  chartInstance.chartInfo.mdlStart = mdlStart_c3_supply_;
  chartInstance.chartInfo.mdlSetWorkWidths = mdlSetWorkWidths_c3_supply_;
  chartInstance.chartInfo.extModeExec = NULL;
  chartInstance.chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance.chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance.chartInfo.storeCurrentConfiguration = NULL;
  chartInstance.S = S;
  ssSetUserData(S,(void *)(&(chartInstance.chartInfo))); /* register the chart instance with simstruct */

  if(!sim_mode_is_rtw_gen(S)) {
    init_dsm_address_info();
  }
  chart_debug_initialization(S,1);
}

void c3_supply__method_dispatcher(SimStruct *S, int_T method, void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c3_supply_(S);
    break;
   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c3_supply_(S);
    break;
   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c3_supply_(S);
    break;
   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
     "Error calling c3_supply__method_dispatcher.\n"
     "Can't handle method %d.\n", method);
    break;
  }
}

