/* Include files */
#include "supply_3_GA_sfun.h"
#include "c3_supply_3_GA.h"
#define CHARTINSTANCE_CHARTNUMBER       (chartInstance.chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER    (chartInstance.instanceNumber)
#include "supply_3_GA_sfun_debug_macros.h"

/* Type Definitions */

/* Named Constants */
#define c3_IN_NO_ACTIVE_CHILD           (0)

/* Variable Declarations */

/* Variable Definitions */
static SFc3_supply_3_GAInstanceStruct chartInstance;

/* Function Declarations */
static void initialize_c3_supply_3_GA(void);
static void initialize_params_c3_supply_3_GA(void);
static void enable_c3_supply_3_GA(void);
static void disable_c3_supply_3_GA(void);
static void finalize_c3_supply_3_GA(void);
static void sf_c3_supply_3_GA(void);
static void init_script_number_translation(uint32_T c3_machineNumber, uint32_T
 c3_chartNumber);
static const mxArray *c3_sf_marshall(void *c3_chartInstance, void *c3_u);
static const mxArray *c3_b_sf_marshall(void *c3_chartInstance, void *c3_u);
static const mxArray *c3_c_sf_marshall(void *c3_chartInstance, void *c3_u);
static const mxArray *c3_d_sf_marshall(void *c3_chartInstance, void *c3_u);
static const mxArray *c3_e_sf_marshall(void *c3_chartInstance, void *c3_u);
static const mxArray *c3_f_sf_marshall(void *c3_chartInstance, void *c3_u);
static const mxArray *c3_g_sf_marshall(void *c3_chartInstance, void *c3_u);
static const mxArray *c3_h_sf_marshall(void *c3_chartInstance, void *c3_u);
static void c3_info_helper(c3_ResolvedFunctionInfo c3_info[31]);
static void init_dsm_address_info(void);

/* Function Definitions */
static void initialize_c3_supply_3_GA(void)
{
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
  chartInstance.c3_is_active_c3_supply_3_GA = 0U;
}

static void initialize_params_c3_supply_3_GA(void)
{
}

static void enable_c3_supply_3_GA(void)
{
}

static void disable_c3_supply_3_GA(void)
{
}

static void finalize_c3_supply_3_GA(void)
{
}

static void sf_c3_supply_3_GA(void)
{
  int32_T c3_i0;
  int32_T c3_i1;
  int32_T c3_i2;
  uint8_T c3_previousEvent;
  int32_T c3_i3;
  real_T c3_tl[2];
  int32_T c3_i4;
  real_T c3_dtl[2];
  real_T c3_tau;
  real_T c3_dtau;
  real_T c3_Jdt_log1;
  real_T c3_Jt_log1;
  real_T c3_tau_abs1;
  real_T c3_Jp[2];
  real_T c3_x;
  real_T c3_A;
  real_T c3_B;
  real_T c3_b_x;
  real_T c3_y;
  real_T c3_c_x;
  real_T c3_b_A;
  real_T c3_b_B;
  real_T c3_d_x;
  real_T c3_b_y;
  real_T c3_e_x;
  int32_T c3_i5;
  real_T *c3_b_tau;
  real_T *c3_b_dtau;
  real_T (*c3_b_Jp)[2];
  real_T (*c3_b_tl)[2];
  real_T (*c3_b_dtl)[2];
  c3_b_dtau = (real_T *)ssGetInputPortSignal(chartInstance.S, 3);
  c3_b_Jp = (real_T (*)[2])ssGetOutputPortSignal(chartInstance.S, 1);
  c3_b_tau = (real_T *)ssGetInputPortSignal(chartInstance.S, 2);
  c3_b_dtl = (real_T (*)[2])ssGetInputPortSignal(chartInstance.S, 1);
  c3_b_tl = (real_T (*)[2])ssGetInputPortSignal(chartInstance.S, 0);
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
  for(c3_i0 = 0; c3_i0 < 2; c3_i0 = c3_i0 + 1) {
    _SFD_DATA_RANGE_CHECK((*c3_b_tl)[c3_i0], 1U);
  }
  for(c3_i1 = 0; c3_i1 < 2; c3_i1 = c3_i1 + 1) {
    _SFD_DATA_RANGE_CHECK((*c3_b_dtl)[c3_i1], 3U);
  }
  _SFD_DATA_RANGE_CHECK(*c3_b_tau, 0U);
  _SFD_DATA_RANGE_CHECK(*c3_b_dtau, 2U);
  for(c3_i2 = 0; c3_i2 < 2; c3_i2 = c3_i2 + 1) {
    _SFD_DATA_RANGE_CHECK((*c3_b_Jp)[c3_i2], 4U);
  }
  c3_previousEvent = _sfEvent_;
  _sfEvent_ = CALL_EVENT;
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG,2);
  for(c3_i3 = 0; c3_i3 < 2; c3_i3 = c3_i3 + 1) {
    c3_tl[c3_i3] = (*c3_b_tl)[c3_i3];
  }
  for(c3_i4 = 0; c3_i4 < 2; c3_i4 = c3_i4 + 1) {
    c3_dtl[c3_i4] = (*c3_b_dtl)[c3_i4];
  }
  c3_tau = *c3_b_tau;
  c3_dtau = *c3_b_dtau;
  sf_debug_symbol_scope_push(8U, 0U);
  sf_debug_symbol_scope_add("Jdt_log1", &c3_Jdt_log1, c3_h_sf_marshall);
  sf_debug_symbol_scope_add("Jt_log1", &c3_Jt_log1, c3_g_sf_marshall);
  sf_debug_symbol_scope_add("tau_abs1", &c3_tau_abs1, c3_f_sf_marshall);
  sf_debug_symbol_scope_add("Jp", &c3_Jp, c3_e_sf_marshall);
  sf_debug_symbol_scope_add("dtau", &c3_dtau, c3_d_sf_marshall);
  sf_debug_symbol_scope_add("tau", &c3_tau, c3_c_sf_marshall);
  sf_debug_symbol_scope_add("dtl", &c3_dtl, c3_b_sf_marshall);
  sf_debug_symbol_scope_add("tl", &c3_tl, c3_sf_marshall);
  CV_EML_FCN(0, 0);
  _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,3);
  c3_x = c3_tau;
  c3_tau_abs1 = fabs(c3_x);
  _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,5);
  if(CV_EML_IF(0, 0, c3_tau_abs1 < c3_tl[0])) {
    /* % Force Log Performance index */
    _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,6);
    c3_Jt_log1 = 1.0;
  } else {
    _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,8);
    c3_A = -c3_tau_abs1;
    c3_B = c3_tl[1];
    c3_b_x = c3_A;
    c3_y = c3_B;
    c3_c_x = c3_b_x / c3_y;
    c3_Jt_log1 = c3_c_x;
    c3_Jt_log1 = exp(c3_Jt_log1);
  }
  _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,12);
  if(CV_EML_IF(0, 1, c3_dtau < c3_tl[0])) {
    /* % delta Force Log Performance index */
    _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,13);
    c3_Jdt_log1 = 1.0;
  } else {
    _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,15);
    c3_b_A = -c3_dtau;
    c3_b_B = c3_dtl[1];
    c3_d_x = c3_b_A;
    c3_b_y = c3_b_B;
    c3_e_x = c3_d_x / c3_b_y;
    c3_Jdt_log1 = c3_e_x;
    c3_Jdt_log1 = exp(c3_Jdt_log1);
  }
  /*  Output */
  _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,19);
  c3_Jp[0] = c3_Jt_log1;
  c3_Jp[1] = c3_Jdt_log1;
  _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,-19);
  sf_debug_symbol_scope_pop();
  for(c3_i5 = 0; c3_i5 < 2; c3_i5 = c3_i5 + 1) {
    (*c3_b_Jp)[c3_i5] = c3_Jp[c3_i5];
  }
  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG,2);
  _sfEvent_ = c3_previousEvent;
  sf_debug_check_for_state_inconsistency(_supply_3_GAMachineNumber_,
   chartInstance.chartNumber, chartInstance.instanceNumber);
}

static void init_script_number_translation(uint32_T c3_machineNumber, uint32_T
 c3_chartNumber)
{
}

static const mxArray *c3_sf_marshall(void *c3_chartInstance, void *c3_u)
{
  const mxArray *c3_y = NULL;
  int32_T c3_i6;
  real_T c3_b_u[2];
  const mxArray *c3_b_y = NULL;
  c3_y = NULL;
  for(c3_i6 = 0; c3_i6 < 2; c3_i6 = c3_i6 + 1) {
    c3_b_u[c3_i6] = (*((real_T (*)[2])c3_u))[c3_i6];
  }
  c3_b_y = NULL;
  sf_mex_assign(&c3_b_y, sf_mex_create(&c3_b_u, "y", 0, 0U, 1U, 1, 2));
  sf_mex_assign(&c3_y, c3_b_y);
  return c3_y;
}

static const mxArray *c3_b_sf_marshall(void *c3_chartInstance, void *c3_u)
{
  const mxArray *c3_y = NULL;
  int32_T c3_i7;
  real_T c3_b_u[2];
  const mxArray *c3_b_y = NULL;
  c3_y = NULL;
  for(c3_i7 = 0; c3_i7 < 2; c3_i7 = c3_i7 + 1) {
    c3_b_u[c3_i7] = (*((real_T (*)[2])c3_u))[c3_i7];
  }
  c3_b_y = NULL;
  sf_mex_assign(&c3_b_y, sf_mex_create(&c3_b_u, "y", 0, 0U, 1U, 1, 2));
  sf_mex_assign(&c3_y, c3_b_y);
  return c3_y;
}

static const mxArray *c3_c_sf_marshall(void *c3_chartInstance, void *c3_u)
{
  const mxArray *c3_y = NULL;
  real_T c3_b_u;
  const mxArray *c3_b_y = NULL;
  c3_y = NULL;
  c3_b_u = *((real_T *)c3_u);
  c3_b_y = NULL;
  sf_mex_assign(&c3_b_y, sf_mex_create(&c3_b_u, "y", 0, 0U, 0U, 0));
  sf_mex_assign(&c3_y, c3_b_y);
  return c3_y;
}

static const mxArray *c3_d_sf_marshall(void *c3_chartInstance, void *c3_u)
{
  const mxArray *c3_y = NULL;
  real_T c3_b_u;
  const mxArray *c3_b_y = NULL;
  c3_y = NULL;
  c3_b_u = *((real_T *)c3_u);
  c3_b_y = NULL;
  sf_mex_assign(&c3_b_y, sf_mex_create(&c3_b_u, "y", 0, 0U, 0U, 0));
  sf_mex_assign(&c3_y, c3_b_y);
  return c3_y;
}

static const mxArray *c3_e_sf_marshall(void *c3_chartInstance, void *c3_u)
{
  const mxArray *c3_y = NULL;
  int32_T c3_i8;
  real_T c3_b_u[2];
  const mxArray *c3_b_y = NULL;
  c3_y = NULL;
  for(c3_i8 = 0; c3_i8 < 2; c3_i8 = c3_i8 + 1) {
    c3_b_u[c3_i8] = (*((real_T (*)[2])c3_u))[c3_i8];
  }
  c3_b_y = NULL;
  sf_mex_assign(&c3_b_y, sf_mex_create(&c3_b_u, "y", 0, 0U, 1U, 2, 1, 2));
  sf_mex_assign(&c3_y, c3_b_y);
  return c3_y;
}

static const mxArray *c3_f_sf_marshall(void *c3_chartInstance, void *c3_u)
{
  const mxArray *c3_y = NULL;
  real_T c3_b_u;
  const mxArray *c3_b_y = NULL;
  c3_y = NULL;
  c3_b_u = *((real_T *)c3_u);
  c3_b_y = NULL;
  sf_mex_assign(&c3_b_y, sf_mex_create(&c3_b_u, "y", 0, 0U, 0U, 0));
  sf_mex_assign(&c3_y, c3_b_y);
  return c3_y;
}

static const mxArray *c3_g_sf_marshall(void *c3_chartInstance, void *c3_u)
{
  const mxArray *c3_y = NULL;
  real_T c3_b_u;
  const mxArray *c3_b_y = NULL;
  c3_y = NULL;
  c3_b_u = *((real_T *)c3_u);
  c3_b_y = NULL;
  sf_mex_assign(&c3_b_y, sf_mex_create(&c3_b_u, "y", 0, 0U, 0U, 0));
  sf_mex_assign(&c3_y, c3_b_y);
  return c3_y;
}

static const mxArray *c3_h_sf_marshall(void *c3_chartInstance, void *c3_u)
{
  const mxArray *c3_y = NULL;
  real_T c3_b_u;
  const mxArray *c3_b_y = NULL;
  c3_y = NULL;
  c3_b_u = *((real_T *)c3_u);
  c3_b_y = NULL;
  sf_mex_assign(&c3_b_y, sf_mex_create(&c3_b_u, "y", 0, 0U, 0U, 0));
  sf_mex_assign(&c3_y, c3_b_y);
  return c3_y;
}

const mxArray *sf_c3_supply_3_GA_get_eml_resolved_functions_info(void)
{
  const mxArray *c3_nameCaptureInfo = NULL;
  c3_ResolvedFunctionInfo c3_info[31];
  const mxArray *c3_m0 = NULL;
  int32_T c3_i9;
  c3_ResolvedFunctionInfo *c3_r0;
  c3_nameCaptureInfo = NULL;
  c3_info_helper(c3_info);
  sf_mex_assign(&c3_m0, sf_mex_createstruct("nameCaptureInfo", 1, 31));
  for(c3_i9 = 0; c3_i9 < 31; c3_i9 = c3_i9 + 1) {
    c3_r0 = &c3_info[c3_i9];
    sf_mex_addfield(c3_m0, sf_mex_create(c3_r0->context, "nameCaptureInfo", 13,
      0U, 0U, 2, 1, strlen(c3_r0->context)), "context",
     "nameCaptureInfo", c3_i9);
    sf_mex_addfield(c3_m0, sf_mex_create(c3_r0->name, "nameCaptureInfo", 13, 0U,
      0U, 2, 1, strlen(c3_r0->name)), "name",
     "nameCaptureInfo", c3_i9);
    sf_mex_addfield(c3_m0, sf_mex_create(c3_r0->dominantType, "nameCaptureInfo",
      13, 0U, 0U, 2, 1, strlen(c3_r0->dominantType)),
     "dominantType", "nameCaptureInfo", c3_i9);
    sf_mex_addfield(c3_m0, sf_mex_create(c3_r0->resolved, "nameCaptureInfo", 13,
      0U, 0U, 2, 1, strlen(c3_r0->resolved)), "resolved",
     "nameCaptureInfo", c3_i9);
    sf_mex_addfield(c3_m0, sf_mex_create(&c3_r0->fileLength, "nameCaptureInfo",
      7, 0U, 0U, 0), "fileLength", "nameCaptureInfo", c3_i9);
    sf_mex_addfield(c3_m0, sf_mex_create(&c3_r0->fileTime1, "nameCaptureInfo",
      7, 0U, 0U, 0), "fileTime1", "nameCaptureInfo", c3_i9);
    sf_mex_addfield(c3_m0, sf_mex_create(&c3_r0->fileTime2, "nameCaptureInfo",
      7, 0U, 0U, 0), "fileTime2", "nameCaptureInfo", c3_i9);
  }
  sf_mex_assign(&c3_nameCaptureInfo, c3_m0);
  return c3_nameCaptureInfo;
}

static void c3_info_helper(c3_ResolvedFunctionInfo c3_info[31])
{
  c3_info[0].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/datatypes/isa.m";
  c3_info[0].name = "strcmp";
  c3_info[0].dominantType = "char";
  c3_info[0].resolved = "[B]strcmp";
  c3_info[0].fileLength = 0U;
  c3_info[0].fileTime1 = 0U;
  c3_info[0].fileTime2 = 0U;
  c3_info[1].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elmat/isscalar.m";
  c3_info[1].name = "length";
  c3_info[1].dominantType = "double";
  c3_info[1].resolved = "[I]$matlabroot$/toolbox/eml/lib/matlab/elmat/length.m";
  c3_info[1].fileLength = 347U;
  c3_info[1].fileTime1 = 1163949170U;
  c3_info[1].fileTime2 = 0U;
  c3_info[2].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.m";
  c3_info[2].name = "ge";
  c3_info[2].dominantType = "double";
  c3_info[2].resolved = "[B]ge";
  c3_info[2].fileLength = 0U;
  c3_info[2].fileTime1 = 0U;
  c3_info[2].fileTime2 = 0U;
  c3_info[3].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_is_float_class.m";
  c3_info[3].name = "ischar";
  c3_info[3].dominantType = "char";
  c3_info[3].resolved = "[I]$matlabroot$/toolbox/eml/lib/matlab/strfun/ischar.m";
  c3_info[3].fileLength = 244U;
  c3_info[3].fileTime1 = 1160425234U;
  c3_info[3].fileTime2 = 0U;
  c3_info[4].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elmat/length.m";
  c3_info[4].name = "eml_numel";
  c3_info[4].dominantType = "double";
  c3_info[4].resolved = "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_numel.m";
  c3_info[4].fileLength = 278U;
  c3_info[4].fileTime1 = 1163949202U;
  c3_info[4].fileTime2 = 0U;
  c3_info[5].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c3_info[5].name = "eml_isa_uint";
  c3_info[5].dominantType = "double";
  c3_info[5].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_isa_uint.m";
  c3_info[5].fileLength = 288U;
  c3_info[5].fileTime1 = 1163949198U;
  c3_info[5].fileTime2 = 0U;
  c3_info[6].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c3_info[6].name = "zeros";
  c3_info[6].dominantType = "double";
  c3_info[6].resolved = "[B]zeros";
  c3_info[6].fileLength = 0U;
  c3_info[6].fileTime1 = 0U;
  c3_info[6].fileTime2 = 0U;
  c3_info[7].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c3_info[7].name = "isfloat";
  c3_info[7].dominantType = "double";
  c3_info[7].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/datatypes/isfloat.m";
  c3_info[7].fileLength = 182U;
  c3_info[7].fileTime1 = 1160425020U;
  c3_info[7].fileTime2 = 0U;
  c3_info[8].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_numel.m";
  c3_info[8].name = "numel";
  c3_info[8].dominantType = "double";
  c3_info[8].resolved = "[B]numel";
  c3_info[8].fileLength = 0U;
  c3_info[8].fileTime1 = 0U;
  c3_info[8].fileTime2 = 0U;
  c3_info[9].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c3_info[9].name = "isscalar";
  c3_info[9].dominantType = "double";
  c3_info[9].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/elmat/isscalar.m";
  c3_info[9].fileLength = 243U;
  c3_info[9].fileTime1 = 1160425104U;
  c3_info[9].fileTime2 = 0U;
  c3_info[10].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c3_info[10].name = "not";
  c3_info[10].dominantType = "logical";
  c3_info[10].resolved = "[B]not";
  c3_info[10].fileLength = 0U;
  c3_info[10].fileTime1 = 0U;
  c3_info[10].fileTime2 = 0U;
  c3_info[11].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c3_info[11].name = "nargin";
  c3_info[11].dominantType = "";
  c3_info[11].resolved = "[B]nargin";
  c3_info[11].fileLength = 0U;
  c3_info[11].fileTime1 = 0U;
  c3_info[11].fileTime2 = 0U;
  c3_info[12].context = "";
  c3_info[12].name = "uminus";
  c3_info[12].dominantType = "double";
  c3_info[12].resolved = "[B]uminus";
  c3_info[12].fileLength = 0U;
  c3_info[12].fileTime1 = 0U;
  c3_info[12].fileTime2 = 0U;
  c3_info[13].context = "";
  c3_info[13].name = "mrdivide";
  c3_info[13].dominantType = "double";
  c3_info[13].resolved = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.m";
  c3_info[13].fileLength = 653U;
  c3_info[13].fileTime1 = 1160425202U;
  c3_info[13].fileTime2 = 0U;
  c3_info[14].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/datatypes/isa.m";
  c3_info[14].name = "eml_is_float_class";
  c3_info[14].dominantType = "char";
  c3_info[14].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_is_float_class.m";
  c3_info[14].fileLength = 273U;
  c3_info[14].fileTime1 = 1160425144U;
  c3_info[14].fileTime2 = 0U;
  c3_info[15].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c3_info[15].name = "isreal";
  c3_info[15].dominantType = "double";
  c3_info[15].resolved = "[B]isreal";
  c3_info[15].fileLength = 0U;
  c3_info[15].fileTime1 = 0U;
  c3_info[15].fileTime2 = 0U;
  c3_info[16].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c3_info[16].name = "isinteger";
  c3_info[16].dominantType = "double";
  c3_info[16].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/datatypes/isinteger.m";
  c3_info[16].fileLength = 254U;
  c3_info[16].fileTime1 = 1160425020U;
  c3_info[16].fileTime2 = 0U;
  c3_info[17].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c3_info[17].name = "gt";
  c3_info[17].dominantType = "double";
  c3_info[17].resolved = "[B]gt";
  c3_info[17].fileLength = 0U;
  c3_info[17].fileTime1 = 0U;
  c3_info[17].fileTime2 = 0U;
  c3_info[18].context = "";
  c3_info[18].name = "lt";
  c3_info[18].dominantType = "double";
  c3_info[18].resolved = "[B]lt";
  c3_info[18].fileLength = 0U;
  c3_info[18].fileTime1 = 0U;
  c3_info[18].fileTime2 = 0U;
  c3_info[19].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c3_info[19].name = "islogical";
  c3_info[19].dominantType = "double";
  c3_info[19].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/datatypes/islogical.m";
  c3_info[19].fileLength = 186U;
  c3_info[19].fileTime1 = 1160425022U;
  c3_info[19].fileTime2 = 0U;
  c3_info[20].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elmat/length.m";
  c3_info[20].name = "size";
  c3_info[20].dominantType = "double";
  c3_info[20].resolved = "[B]size";
  c3_info[20].fileLength = 0U;
  c3_info[20].fileTime1 = 0U;
  c3_info[20].fileTime2 = 0U;
  c3_info[21].context = "";
  c3_info[21].name = "abs";
  c3_info[21].dominantType = "double";
  c3_info[21].resolved = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c3_info[21].fileLength = 1031U;
  c3_info[21].fileTime1 = 1163949102U;
  c3_info[21].fileTime2 = 0U;
  c3_info[22].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/datatypes/isa.m";
  c3_info[22].name = "eml_is_integer_class";
  c3_info[22].dominantType = "char";
  c3_info[22].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_is_integer_class.m";
  c3_info[22].fileLength = 462U;
  c3_info[22].fileTime1 = 1160425144U;
  c3_info[22].fileTime2 = 0U;
  c3_info[23].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c3_info[23].name = "eml_assert";
  c3_info[23].dominantType = "char";
  c3_info[23].resolved = "[B]eml_assert";
  c3_info[23].fileLength = 0U;
  c3_info[23].fileTime1 = 0U;
  c3_info[23].fileTime2 = 0U;
  c3_info[24].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/datatypes/isnumeric.m";
  c3_info[24].name = "isa";
  c3_info[24].dominantType = "double";
  c3_info[24].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/datatypes/isa.m";
  c3_info[24].fileLength = 791U;
  c3_info[24].fileTime1 = 1160425018U;
  c3_info[24].fileTime2 = 0U;
  c3_info[25].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/datatypes/isa.m";
  c3_info[25].name = "eq";
  c3_info[25].dominantType = "double";
  c3_info[25].resolved = "[B]eq";
  c3_info[25].fileLength = 0U;
  c3_info[25].fileTime1 = 0U;
  c3_info[25].fileTime2 = 0U;
  c3_info[26].context = "";
  c3_info[26].name = "exp";
  c3_info[26].dominantType = "double";
  c3_info[26].resolved = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/exp.m";
  c3_info[26].fileLength = 598U;
  c3_info[26].fileTime1 = 1163949132U;
  c3_info[26].fileTime2 = 0U;
  c3_info[27].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c3_info[27].name = "isnumeric";
  c3_info[27].dominantType = "double";
  c3_info[27].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/datatypes/isnumeric.m";
  c3_info[27].fileLength = 250U;
  c3_info[27].fileTime1 = 1160425022U;
  c3_info[27].fileTime2 = 0U;
  c3_info[28].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c3_info[28].name = "isempty";
  c3_info[28].dominantType = "double";
  c3_info[28].resolved = "[B]isempty";
  c3_info[28].fileLength = 0U;
  c3_info[28].fileTime1 = 0U;
  c3_info[28].fileTime2 = 0U;
  c3_info[29].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/datatypes/isa.m";
  c3_info[29].name = "class";
  c3_info[29].dominantType = "char";
  c3_info[29].resolved = "[B]class";
  c3_info[29].fileLength = 0U;
  c3_info[29].fileTime1 = 0U;
  c3_info[29].fileTime2 = 0U;
  c3_info[30].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.m";
  c3_info[30].name = "rdivide";
  c3_info[30].dominantType = "double";
  c3_info[30].resolved = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c3_info[30].fileLength = 4533U;
  c3_info[30].fileTime1 = 1177078148U;
  c3_info[30].fileTime2 = 0U;
}

static void init_dsm_address_info(void)
{
}

/* SFunction Glue Code */
void sf_c3_supply_3_GA_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(2471304613U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(1895901611U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(2315443904U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(934899364U);
}

mxArray *sf_c3_supply_3_GA_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] =
  {"checksum","inputs","parameters","outputs"};
  mxArray *mxAutoinheritanceInfo =
  mxCreateStructMatrix(1,1,4,autoinheritanceFields);
  {
    mxArray *mxChecksum = mxCreateDoubleMatrix(4,1,mxREAL);
    double *pr = mxGetPr(mxChecksum);
    pr[0] = (double)(4234173950U);
    pr[1] = (double)(1431999142U);
    pr[2] = (double)(1395741216U);
    pr[3] = (double)(2998496970U);
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }
  {
    const char *dataFields[] = {"size","type","complexity"};
    mxArray *mxData = mxCreateStructMatrix(1,4,3,dataFields);
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(2);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }
    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(2);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }
    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }
    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,3,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,3,"type",mxType);
    }
    mxSetField(mxData,3,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }
  {
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxCreateDoubleMatrix(0,0,mxREAL));
  }
  {
    const char *dataFields[] = {"size","type","complexity"};
    mxArray *mxData = mxCreateStructMatrix(1,1,3,dataFields);
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(2);
      mxSetField(mxData,0,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }
    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }
  return(mxAutoinheritanceInfo);
}

static void chart_debug_initialization(SimStruct *S, unsigned int
 fullDebuggerInitialization)
{
  if(ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
    /* do this only if simulation is starting */
    if(!sim_mode_is_rtw_gen(S)) {
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent =
          sf_debug_initialize_chart(_supply_3_GAMachineNumber_,
         3,
         1,
         1,
         5,
         0,
         0,
         0,
         0,
         0,
         &(chartInstance.chartNumber),
         &(chartInstance.instanceNumber),
         ssGetPath(S),
         (void *)S);
        if(chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation(_supply_3_GAMachineNumber_,chartInstance.chartNumber);
          sf_debug_set_chart_disable_implicit_casting(_supply_3_GAMachineNumber_,chartInstance.chartNumber,1);
          sf_debug_set_chart_event_thresholds(_supply_3_GAMachineNumber_,
           chartInstance.chartNumber,
           0,
           0,
           0);

          {
            unsigned int dimVector[1];
            dimVector[0]= 2;
            _SFD_SET_DATA_PROPS(1,1,1,0,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,1.0,0,"tl",0,c3_sf_marshall);
          }
          {
            unsigned int dimVector[1];
            dimVector[0]= 2;
            _SFD_SET_DATA_PROPS(3,1,1,0,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,1.0,0,"dtl",0,c3_b_sf_marshall);
          }
          _SFD_SET_DATA_PROPS(0,1,1,0,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,"tau",0,c3_c_sf_marshall);
          _SFD_SET_DATA_PROPS(2,1,1,0,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,"dtau",0,c3_d_sf_marshall);
          {
            unsigned int dimVector[2];
            dimVector[0]= 1;
            dimVector[1]= 2;
            _SFD_SET_DATA_PROPS(4,2,0,1,SF_DOUBLE,2,&(dimVector[0]),0,0,0,0.0,1.0,0,"Jp",0,c3_e_sf_marshall);
          }
          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }
        _SFD_CV_INIT_CHART(0,0,0,0);
        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of EML Model Coverage */
        _SFD_CV_INIT_EML(0,1,2,0,0,0,0,0);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,322);
        _SFD_CV_INIT_EML_IF(0,0,90,109,127,171);
        _SFD_CV_INIT_EML_IF(0,1,210,225,244,286);
        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if(chartAlreadyPresent==0)
        {
          _SFD_TRANS_COV_MAPS(0,
           0,NULL,NULL,
           0,NULL,NULL,
           1,NULL,NULL,
           0,NULL,NULL);
        }

        {
          real_T (*c3_tl)[2];
          real_T (*c3_dtl)[2];
          real_T *c3_tau;
          real_T *c3_dtau;
          real_T (*c3_Jp)[2];
          c3_dtau = (real_T *)ssGetInputPortSignal(chartInstance.S, 3);
          c3_Jp = (real_T (*)[2])ssGetOutputPortSignal(chartInstance.S, 1);
          c3_tau = (real_T *)ssGetInputPortSignal(chartInstance.S, 2);
          c3_dtl = (real_T (*)[2])ssGetInputPortSignal(chartInstance.S, 1);
          c3_tl = (real_T (*)[2])ssGetInputPortSignal(chartInstance.S, 0);
          _SFD_SET_DATA_VALUE_PTR(1U, c3_tl);
          _SFD_SET_DATA_VALUE_PTR(3U, c3_dtl);
          _SFD_SET_DATA_VALUE_PTR(0U, c3_tau);
          _SFD_SET_DATA_VALUE_PTR(2U, c3_dtau);
          _SFD_SET_DATA_VALUE_PTR(4U, c3_Jp);
        }
      }
    }
  } else {
    sf_debug_reset_current_state_configuration(_supply_3_GAMachineNumber_,chartInstance.chartNumber,chartInstance.instanceNumber);
  }
}

static void sf_opaque_initialize_c3_supply_3_GA(void *chartInstanceVar)
{
  chart_debug_initialization(chartInstance.S,0);
  initialize_params_c3_supply_3_GA();
  initialize_c3_supply_3_GA();
}

static void sf_opaque_enable_c3_supply_3_GA(void *chartInstanceVar)
{
  enable_c3_supply_3_GA();
}

static void sf_opaque_disable_c3_supply_3_GA(void *chartInstanceVar)
{
  disable_c3_supply_3_GA();
}

static void sf_opaque_gateway_c3_supply_3_GA(void *chartInstanceVar)
{
  sf_c3_supply_3_GA();
}

static void sf_opaque_terminate_c3_supply_3_GA(void *chartInstanceVar)
{
  if (sim_mode_is_rtw_gen(chartInstance.S) ||
   sim_mode_is_external(chartInstance.S)) {
    sf_clear_rtw_identifier(chartInstance.S);
  }
  finalize_c3_supply_3_GA();
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c3_supply_3_GA(SimStruct *S)
{
  int i;
  for(i=0;i<ssGetNumRunTimeParams(S);i++) {
    if(ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }
  if(sf_machine_global_initializer_called()) {
    initialize_params_c3_supply_3_GA();
  }
}

static void mdlSetWorkWidths_c3_supply_3_GA(SimStruct *S)
{
  if(sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable("supply_3_GA",3);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop("supply_3_GA",3,"gatewayCannotBeInlinedMultipleTimes"));
    if(chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 1, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 2, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 3, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,"supply_3_GA",3,4);
      sf_mark_chart_reusable_outputs(S,"supply_3_GA",3,1);
    }
    sf_set_rtw_dwork_info(S,"supply_3_GA",3);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
    ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  }

  ssSetChecksum0(S,(1572378993U));
  ssSetChecksum1(S,(3407328494U));
  ssSetChecksum2(S,(3131125503U));
  ssSetChecksum3(S,(114441026U));

  ssSetmdlDerivatives(S, NULL);

  ssSetExplicitFCSSCtrl(S,1);
}

static void mdlRTW_c3_supply_3_GA(SimStruct *S)
{
  if(sim_mode_is_rtw_gen(S)) {
    sf_write_symbol_mapping(S, "supply_3_GA", 3);
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c3_supply_3_GA(SimStruct *S)
{
  chartInstance.chartInfo.chartInstance = NULL;
  chartInstance.chartInfo.isEMLChart = 1;
  chartInstance.chartInfo.chartInitialized = 0;
  chartInstance.chartInfo.sFunctionGateway = sf_opaque_gateway_c3_supply_3_GA;
  chartInstance.chartInfo.initializeChart = sf_opaque_initialize_c3_supply_3_GA;
  chartInstance.chartInfo.terminateChart = sf_opaque_terminate_c3_supply_3_GA;
  chartInstance.chartInfo.enableChart = sf_opaque_enable_c3_supply_3_GA;
  chartInstance.chartInfo.disableChart = sf_opaque_disable_c3_supply_3_GA;
  chartInstance.chartInfo.zeroCrossings = NULL;
  chartInstance.chartInfo.outputs = NULL;
  chartInstance.chartInfo.derivatives = NULL;
  chartInstance.chartInfo.mdlRTW = mdlRTW_c3_supply_3_GA;
  chartInstance.chartInfo.mdlStart = mdlStart_c3_supply_3_GA;
  chartInstance.chartInfo.mdlSetWorkWidths = mdlSetWorkWidths_c3_supply_3_GA;
  chartInstance.chartInfo.extModeExec = NULL;
  chartInstance.chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance.chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance.chartInfo.storeCurrentConfiguration = NULL;
  chartInstance.S = S;
  ssSetUserData(S,(void *)(&(chartInstance.chartInfo))); /* register the chart instance with simstruct */

  if(!sim_mode_is_rtw_gen(S)) {
    init_dsm_address_info();
  }
  chart_debug_initialization(S,1);
}

void c3_supply_3_GA_method_dispatcher(SimStruct *S, int_T method, void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c3_supply_3_GA(S);
    break;
   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c3_supply_3_GA(S);
    break;
   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c3_supply_3_GA(S);
    break;
   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
     "Error calling c3_supply_3_GA_method_dispatcher.\n"
     "Can't handle method %d.\n", method);
    break;
  }
}

